GLvoid gltest()
{
    char text[1024]="!@#$%^&*()1234567890-=abcdfghijklmnopqrstuvwxyz";
//    va_list ap;      /* Pointer To List Of Arguments */


    glLoadIdentity( );                       /* Reset The Modelview Matrix   */
    glTranslated( 0, 0, 0 );                 /* Position The Text            */
    glListBase( base  ); /* Choose The Font Set (0 or 1) */

    glScalef( 1.0f, 1.0f, 1.0f );            /* Make The Text 2X Taller      */
    /* Write The Text To The Screen */
    glCallLists( strlen( text ), GL_UNSIGNED_BYTE, text );
}

int Draw_S(){

    glEnable( GL_TEXTURE_2D );               /* Enable Texture Mapping       */

    glLoadIdentity( );     /* Set The Color To White */    

    glBindTexture( GL_TEXTURE_2D, texture[0] );
	    printf("texture name =%d \n",texture[0]);

    glBegin( GL_QUADS );
        glTexCoord2i( 0, 0 );
	glVertex2i( 0, 0 );

	glTexCoord2f( 1, 0 );
	glVertex2i( SCREEN_WIDTH, 0 );

	glTexCoord2f( 1, 1 );
	glVertex2i( SCREEN_WIDTH, SCREEN_HEIGHT   );


	glTexCoord2f( 0, 1 );
	glVertex2i( 0, SCREEN_HEIGHT );

    glEnd( ); 

    return 1;
}

/
GLvoid intBuildFont( GLvoid )
{
    int loop1;

    int font_height=12;
    int font_width=7;


    /* Creating 256 Display Lists */
    base = glGenLists( 128 );

    /* Select Our Font Texture */
    glBindTexture( GL_TEXTURE_2D, texture[0] );

    /* Loop Through All 256 Lists */
    for ( loop1 = 0; loop1 < 128; loop1++ )
        {
	    /* X Position Of Current Character */
	    int cx = (loop1 % 16) * font_width  ;
	    /* Y Position Of Current Character */
	    int cy = font_image_height  -  (loop1 / 16)*font_height  ;

	    printf("cx=%d ,cy=%d \n",cx,cy);

	    /* Start Building A List */
	    glNewList( base + loop1 , GL_COMPILE );
	      /* Use A Quad For Each Character */
	      glBegin( GL_QUADS );

	        glTexCoord2i( cx , cy );
		glVertex2i( 0, 0 );

		glTexCoord2i( cx+font_width, cy );
		glVertex2i( font_width, 0 );

		glTexCoord2i( cx+font_width, cy - font_height );
		glVertex2i( font_width, font_height );

		glTexCoord2i( cx, cy -font_height );
		glVertex2i( 0, font_height );

	      glEnd( );

	      /* Move To The Right Of The Character */
//	      glTranslated( 14, 0, 0 );
	    glEndList( );
        }
}


GLvoid XBuildFont( GLvoid )
{
    int loop1;

    /* Creating 256 Display Lists */
    base = glGenLists( 256 );

    /* Select Our Font Texture */
    glBindTexture( GL_TEXTURE_2D, texture[0] );

//	        glTexCoord2i( cx , cy );
//		glVertex2i( 0, font_height );
//		glTexCoord2i( cx+font_width, cy );
//		glVertex2i( font_width, font_height );
//		glTexCoord2i( cx+font_width, cy - font_height );
//		glVertex2i( font_width, 0 );
//		glTexCoord2i( cx, cy -font_height );
//		glVertex2i( 0, 0 );

    /* Loop Through All 256 Lists */
    for ( loop1 = 0; loop1 < 256; loop1++ )
        {
	    /* X Position Of Current Character */
	    float cx = 1 - ( float )( loop1 % 16 ) / 16.0f;
	    /* Y Position Of Current Character */
	    float cy = 1 - ( float )( loop1 / 16 ) / 16.0f;

	    /* Start Building A List */
	    glNewList( base + ( 255 - loop1 ), GL_COMPILE );
	      /* Use A Quad For Each Character */
	      glBegin( GL_QUADS );
	        /* Texture Coord (Bottom Left) */
	        glTexCoord2f( cx - 0.0625f, cy );
		/* Vertex Coord (Bottom Left) */
		glVertex2i( 0, 16 );
		/* Texture Coord (Bottom Right) */
		glTexCoord2f( cx, cy );
		/* Vertex Coord (Bottom Right) */
		glVertex2i( 16, 16 );
		/* Texture Coord (Top Right) */
		glTexCoord2f( cx, cy - 0.0625f );
		/* Vertex Coord (Top Right) */
		glVertex2i( 16, 0 );
		/* Texture Coord (Top Left) */
		glTexCoord2f( cx - 0.0625f, cy - 0.0625f );
		/* Vertex Coord (Top Left) */
		glVertex2i( 0, 0 );
	      glEnd( );

	      /* Move To The Right Of The Character */
	      glTranslated( 14, 0, 0 );
	    glEndList( );
        }
}


* Where The Printing Happens */
GLvoid glPrint( GLint x, GLint y, int set, const char *fmt, ... )
{
    char text[1024]; /* Holds Our String             */
    va_list ap;      /* Pointer To List Of Arguments */

    /* If there's no text */
    if ( fmt == NULL )
	return;

    /* Parses The String For Variables */
    va_start( ap, fmt );
      /* And Converts Symbols To Actual Numbers */
      vsprintf( text, fmt, ap );
    va_end( ap );


    glEnable( GL_TEXTURE_2D );               /* Enable Texture Mapping       */
    glLoadIdentity( );                       /* Reset The Modelview Matrix   */
    glTranslated( x, y, 0 );                 /* Position The Text            */
    glListBase( base  ); /* Choose The Font Set (0 or 1) */

    glScalef( 1.0f, 1.0f, 1.0f );            /* Make The Text 2X Taller      */

    /* Write The Text To The Screen */
    glCallLists( strlen( text ), GL_UNSIGNED_BYTE, text );

    /* Disable Texture Mapping */
///    glDisable( GL_TEXTURE_2D );
}



    if ( ( TextureImage = IMG_Load( "data/font.bmp" ) ) )/// "data/font_lucida_7x12.tga" ) ) )
        {
	    GLuint type = GL_RGB;

	    /* Set the status to true */
	    Status = TRUE;

	    glGenTextures( 1, &texture[0] );

	    glBindTexture( GL_TEXTURE_2D, texture[0] );
	    printf("texture name =%d  w=%d,h=%d\n",texture[0],TextureImage->w, TextureImage->h);
	    font_image_height=TextureImage->h;

	    glTexImage2D( GL_TEXTURE_2D, 0, type, TextureImage->w,
			  TextureImage->h, 0, type,
			  GL_UNSIGNED_BYTE, TextureImage->pixels );

    	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	    /* Linear Filtering */
	    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
        }
    else 
    { printf( " error \n"); exit(1); }


    /* Free up any memory we may have used */
//    if ( TextureImage )
//	SDL_FreeSurface( TextureImage );
