/*
 * Ϻ RGB ̻ϰ о. 
 * Ϻ index÷ ʵ (gif)

 
   png ȵ.
	
	BMP:RGB -> OK

	SDL_CreateRGBSurface ̰ ü RGBA, RGB BGR̳ ?
 */
#define _VERSION_  40

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>


#include <GL/glu.h>
#include "../gpf.c"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

/* Set up some booleans */
#define TRUE  1
#define FALSE 0



GPF *g;  
SDL_Surface *image; // input image !!
SDL_Surface *sdl_new_image; // input image !!
SDL_Surface *surface; 

GLint gl_format; //  GL_RGBA,GL_RGB ...
GLint type;	//GL_BYTE,GL_UNSIGNED_BYTE...
GLint width,height;
GLint new_width,new_height;

char *BitmapBits;
int  BPP;
char filename[64];
char *data,*tmp;

int	dont_modify_size=0;


void strlowcase(char *s)
{

	//while ( *s != '\0' )
	while ( *s != 0x00 )  //this is better     
	{
		if ( *s >= 'A' && *s < 'Z' )
		{
			*s += 32; 
		}
		s++;
	}
}

remove_ext(char *fname)
{
	int i;
	for(i=0;0!=fname[i];i++){
		if(fname[i]=='.'  && fname[i+1]!='/') fname[i]=0;

	}
}

SDL_Surface * LoadImage()
{

	if ( !(image = IMG_Load( filename ) ) )
	{
		fprintf( stderr, "Could not open image: %s: %s\n", filename,
				SDL_GetError( ) );

		exit(0);
	}
	return image;
}

int check_BGR(SDL_Surface *image)
{
	// SDL_Surface  Ϲ BGR ° .
	// Ƹ little_endian 0xFF0000 BLUE Ǵ°Ͱ -> Ȯ 

	printf("R=%0.8x G=%0.8x B=%0.8x\n",image->format->Rmask,image->format->Gmask,image->format->Bmask);
	//if(image->format->Rmask==0x0000FF)
	if(image->format->Rmask==0xFF0000)
		return 1;
	else return 0;
	//image->format->Gmask,image->format->Bmask
	
}


void BGR2RGB1(int w,int h,unsigned char *image)
{
	/* This Will Hold Our RGB Pixel Data */
	GLubyte *RGB_stream;
	GLubyte red,blue;
	int imageSize;
	int i;

	imageSize = w * h * 3;
	RGB_stream = image;

	/* Swap The 1st And 3rd Bytes */
	for ( i = 0; i < imageSize; i += 3)
	{
//		RGB_image[i] ^= RGB_image[i + 2] ^= RGB_image[i] ^= RGB_image[i + 2];
//		̰Դ ?
		red=RGB_stream[i+2];
		blue=RGB_stream[i];
		RGB_stream[i]=red;
		RGB_stream[i+2]=blue;
	}
}

void BGR2RGB(SDL_Surface *image)
{
	/* This Will Hold Our RGB Pixel Data */
	GLubyte *RGB_image;
	GLubyte red,blue;
	int imageSize;
	int i;

	/* Create A Copy Of The Pixel Data */
	imageSize = image->w * image->h * image->format->BytesPerPixel;
	RGB_image = image->pixels;

	/* Swap The 1st And 3rd Bytes */
	for ( i = 0; i < imageSize; i += image->format->BytesPerPixel )
	{
//		RGB_image[i] ^= RGB_image[i + 2] ^= RGB_image[i] ^= RGB_image[i + 2];
//		̰Դ ?
		red=RGB_image[i+2];
		blue=RGB_image[i];
		RGB_image[i]=red;
		RGB_image[i+2]=blue;
	}
}

int SaveGPF()
{
    int lenth,linelenth;
    int row=0;
    char *source;
    int format;

    printf("	filename = %s\n",filename);

    
    data=image->pixels; 
    BPP=image->format->BytesPerPixel;
    
    // upside-down ֱ  hyun 
   
    lenth=width * height * BPP;
    BitmapBits=malloc(lenth);
    linelenth=width*BPP;

    source=data + lenth - linelenth;
    for(row=0;row < height ;row++)
	memcpy(BitmapBits + row*linelenth ,source - row*linelenth ,linelenth);
    

    if(BPP==1)
    	format=GPF_INDEX;
    if(BPP==3)
    	format=RGB;
    if(BPP==4)
    	format=RGBA;



//    if(dont_modify_size) BitmapBits=data;
    g=New_GPF(width,height,format,BitmapBits);
    strcat(filename,".gpf");
 
    
    GPF_filesave(g,filename);
    printf("	Saved \"%s\" !!\n",filename);
    return 1;
}

void Quit( int returnCode )
{
    SDL_Quit( );
    exit( returnCode );
}


//   32Ʈ(RGBA)ؾϴ 𸣰. 
// 32Ʈ ʹٲٸ ̹ʳ 
void INDEX2RGBA()
{

	SDL_Surface *s1,*s2;
	Uint32 rmask, gmask, bmask, amask;

	Uint8 r,g,b;
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
	rmask = 0xff000000;
	gmask = 0x00ff0000;
	bmask = 0x0000ff00;
	amask = 0x000000ff;
#else
	rmask = 0x000000ff;
	gmask = 0x0000ff00;
	bmask = 0x00ff0000;
	amask = 0xff000000;
	amask = 0xff000000;
#endif


	s1 = SDL_CreateRGBSurface(SDL_SWSURFACE, image->w, image->h, 32,
			rmask, gmask, bmask, amask);
	if(s1==NULL){
		printf("SDL error  s1   \n");
		exit(0);
	}

	s2 = SDL_ConvertSurface(image, s1->format, SDL_SWSURFACE);

	if(s2==NULL){
		printf("SDL error  s2   \n");
		exit(0);
	}

	SDL_FreeSurface(image);
	SDL_FreeSurface(s1);
	image=s2;

}

// RGBA RGB ٲٱ =>Ȯο 
RGBA2RGB()
{

	SDL_Surface *s1,*s2;
	Uint32 rmask, gmask, bmask, amask;

	Uint8 r,g,b;
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
	rmask = 0xff000000;
	gmask = 0x00ff0000;
	bmask = 0x0000ff00;
	amask = 0x000000ff;
#else
	rmask = 0x000000ff;
	gmask = 0x0000ff00;
	bmask = 0x00ff0000;
	amask = 0xff000000;
#endif

	s1 = SDL_CreateRGBSurface(SDL_SWSURFACE, image->w, image->h, 24,
			rmask, gmask, bmask, amask);
	if(s1==NULL){
		printf("SDL error  s1   \n");
		exit(0);
	}

	s2 = SDL_ConvertSurface(image, s1->format, SDL_SWSURFACE);

	if(s2==NULL){
		printf("SDL error  s2   \n");
		exit(0);
	}

	SDL_FreeSurface(image);
	SDL_FreeSurface(s1);
	image=s2;
}



//
int main( int argc, char **argv )
{

	int i,r;


	fprintf(stderr, "GPF convert  by hyun 0.90\n");

	if ( argc == 1 ) {
		printf( "need GLU,SDL,SDL_image library \n"
				"option : -x dont_modify \n"
				"Usage: %s <imagefile>\n\n", argv[0]);
		fprintf(stderr, "Example: %s  *.bmp \n\n", argv[0]);
		exit(1);                                                                        
	}                                                                                       

	for(i=1;i< argc ;i++)
		if(strcmp(argv[i],"-x")==0) dont_modify_size=1;


	for(i=1;i< argc ;i++)
	{
		if(strcmp(argv[i],"-x")==0) continue;

		strcpy(filename,argv[i]);

		image=LoadImage();
		remove_ext(filename);
		strlowcase(filename);



		// get property
		width=image->w;
		height=image->h;
		data=image->pixels;

		switch(image->format->BytesPerPixel)
		{
			case 4:
				printf("RGBA image...\n");
				BPP=4;
				RGBA2RGB();
				break;
			case 3:
				if(check_BGR(image)==0)
					printf("RGB image...\n");
				else {
					printf("BGR image...\n");
					BGR2RGB(image);
				}
				
				BPP=3;
				break;

			case 1:
				printf("Color Index image...\n");
				INDEX2RGBA();
				BPP=image->format->BytesPerPixel;
				printf("BPP=%d\n",BPP);
				data=image->pixels; 
				break;

			default :
				printf("format Error !! [%d]\n",image->format->BytesPerPixel);
				exit(0);

		}

		SaveGPF();
	}

	return( 0 );
}
