
#include "../gpf.h" 

#define FONT_LUCIDA	0


// ̷  ü
typedef struct FontChar_  
{
    float U[4], V[4];
    int PixelWidth, PixelHeight;
} FontChar;
FontChar CharSet[256];
FontChar lucida_set[256];
FontChar alpha_set[256];
FontChar hangul_set[256*8];



//   
int FontHeight[8]={14,};
int FontWidth[8]={7,};
int CurrentFontID=0;
int FontBase[8];
int FontTexture;

int Font_getWidth()
{
	return FontWidth[CurrentFontID];
}

int Font_getStrWidth(char *str)
{

	return FontWidth[CurrentFontID];
}


int LoadTextureFont( )
{
    int Status = FALSE;

    GPF *g;
    /* Create storage space for the texture */

    if ( g=GPF_fileload("font.gpf") )/// "data/font_lucida_7x12.tga" ) ) )
        {
	    GLuint type;
//	    if(g->format==GPF_RGBA) type= GL_RGBA;
	    if(g->format==GPF_RGB) type= GL_RGB;
	    else ERROR(" ");
	    
	    printf("type=%d,width=%d,height=%d\n",g->format,g->width,g->height);

	    glGenTextures( 1, &FontTexture );
	    glBindTexture( GL_TEXTURE_2D, FontTexture );
	    glTexImage2D( GL_TEXTURE_2D, 0, 3, g->width, g->height, 0, type, GL_UNSIGNED_BYTE, g->data );

	    /* Linear Filtering */
	    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	    printf("Ok..Font loaded\n");

	}
    else printf("error load..\n");
	
    //     κ, Status    ִ ǰ? - PSJ
    return 1;
    return Status;
}

GLvoid floatBuildFont( )
{
    int loop1;
    float fw,fh;
    int	font_width,font_height;
//    int texture;
    
    /* Creating 256 Display Lists */
    FontBase[CurrentFontID] = glGenLists( 128 );

    /* Select Our Font Texture */
    glBindTexture( GL_TEXTURE_2D, FontTexture );

    font_width=FontWidth[CurrentFontID];
    font_height=FontHeight[CurrentFontID];

    fw=(float)font_width;
    fh=(float)font_height;


    for ( loop1 = 0; loop1 < 128; loop1++ )
        {
	    float Tx = ( float )( loop1 % 16 ) /16.0f ;
	    float Ty = 1 - ( float )( loop1 / 16 ) /8.0f;
	    #define TYDIFF (fh/128)//(1.0f /8.0f)
	    #define TXDIFF (fw/128)//( 1.0f /16.0f)
	    glNewList( FontBase[CurrentFontID] + loop1 , GL_COMPILE );

		glBegin( GL_QUADS );
		glTexCoord2f( Tx, Ty - TYDIFF );
		glVertex2i( 0, 0 );
		glTexCoord2f( Tx + TXDIFF, Ty - TYDIFF); ///		glTexCoord2f( cx+font_width, cy );
		glVertex2i( font_width, 0 );
		glTexCoord2f( Tx + TXDIFF, Ty );//		glTexCoord2f( cx+font_width, cy );
		glVertex2i( font_width,font_height);
		glTexCoord2f( Tx , Ty  ); //		glTexCoord2f( cx, cy  );
		glVertex2i( 0, font_height);
	/*
		glTexCoord2f( Tx, Ty - TDIFF );//	        glTexCoord2f( cx , cy );
		glVertex2i( 0, 0 );
		glTexCoord2f( Tx + TDIFF, Ty - TDIFF); ///		glTexCoord2f( cx+font_width, cy );
		glVertex2i( font_width, 0 );
		glTexCoord2f( Tx + TDIFF, Ty );//		glTexCoord2f( cx+font_width, cy );
		glVertex2i( font_width, font_height);
		glTexCoord2f( Tx , Ty  ); //		glTexCoord2f( cx, cy  );
		glVertex2i( 0, font_height );
	  */  
		  glEnd();
	     	glTranslatef( (float)font_width, 0, 0 );
	    glEndList( );
        }
}

int StackFont[8];
int StackFontLevel=0;
void PushFont()
{
	if(StackFontLevel==0) printf("warning...!! StakFont : top!!\n");
	else{
		StackFont[StackFontLevel]=CurrentFontID;
		StackFontLevel++;
	}
}

void PopFont()
{
	CurrentFontID=StackFont[StackFontLevel];
	StackFontLevel--; 
}

SetFont(int f)
{
    
}

// ̹  3D Ʈ ϴ°.
// Alpha==1.0 ϶ 100% ,  100%
// Alpha==0.0   100% 
inline int __DrawStrXY(int x,int y,char *string)   
{
	int len, i;                                                                                                             
	if( string == NULL) return 0;                                                                                             

	glEnable( GL_TEXTURE_2D );            
	glMatrixMode(GL_MODELVIEW);        
	glLoadIdentity( );                       /* Reset The Modelview Matrix   */
	
//	glColor4f(1.0, 1.0, 1.0,0.2); 
//	glColor4f(1.0, 0.0, 0.0,2.0); 
	// Doesn't work!!     glRasterPos2i(x,ScreenHeight - y -12);

	// glBindTexture( GL_TEXTURE_2D, FontBase[CurrentFontID] );
	glBindTexture( GL_TEXTURE_2D, FontTexture );
	glTranslated( x, PanelHeight - y - FontHeight[CurrentFontID], 0 );               
	glListBase( FontBase[CurrentFontID] -32  ); 

//    	glDisable(GL_DEPTH_TEST);      
	glEnable(GL_BLEND);		
//	glDisable(GL_BLEND);		
//	glBlendFunc(GL_SRC_ALPHA,GL_ONE);    
//	glBlendFunc(GL_ONE,GL_ZERO);   //  ׳ ° 
//	glBlendFunc(GL_ONE,GL_ONE);   
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);

//	glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);    
//	glBlendFunc(GL_SRC_ALPHA, GL_SRC_ALPHA_SATURATE);
//	GL_SRC_ALPHA_SATURATE
//	glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR);    
//	glBlendFunc(GL_SRC_COLOR,GL_ONE);    
//	glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_COLOR);    
//	glBlendFunc(GL_DST_COLOR,GL_ONE_MINUS_DST_COLOR);    
//	glBlendFunc(GL_ONE_MINUS_DST_ALPHA,GL_ONE);    
//	glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE);    
//	glBlendFunc(GL_DST_COLOR,GL_);    
//	glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE);    
//	glBlendFunc(GL_SRC_ALPHA,GL_ONE);    

	len = (int) strlen(string);  
	glCallLists( len, GL_UNSIGNED_BYTE, string );
	glLoadIdentity();
	return FontWidth[CurrentFontID]*len; 
}

inline int __DrawStrScaleXY(int x,int y,float scale,char *string)   
{
	int len, i;                                                                                                             
	if( string == NULL) return 0;                                                                                             

	glEnable( GL_TEXTURE_2D );     
	
	// Doesn't work!!     glRasterPos2i(x,ScreenHeight - y -12);
	glMatrixMode(GL_MODELVIEW);        
	glBindTexture( GL_TEXTURE_2D, FontTexture );
	glTranslatef( x, PanelHeight - y - FontHeight[CurrentFontID], 0 );               
	glScalef(scale,scale,scale);

	
	glListBase( FontBase[CurrentFontID] -32  ); 

	glEnable(GL_BLEND);		
//	glBlendFunc(GL_ONE,GL_ZERO);   //  ׳ ° 
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);

	len = (int) strlen(string);  
	glCallLists( len, GL_UNSIGNED_BYTE, string );

	glMatrixMode(GL_MODELVIEW);        
	glLoadIdentity();
	
	glDisable(GL_BLEND);		
	glBlendFunc(GL_ONE,GL_ONE);   
	glDisable( GL_TEXTURE_2D );               /* Enable Texture Mapping       */
	return FontWidth[CurrentFontID]*len; 
}


InitLibFont()
{
	LoadTextureFont();
	floatBuildFont();
}

    
    
