#include "define.h"
#include "core.h"
#include "math.h"
#include "draw.h"
#include "load.h"
/*

extern struct {
	char 	name[32];
	int  	id ;
	int	joint_n;
	int 	time;
	int 	start;
	int 	end;
	int 	frame_n;
	Key 	**frame;  //this will be  frame[joint_number ][ sequence_key ].translate[0] ;
	//Key	*frame;
}   loaded_Ani[512];
extern int loaded_Ani_n;
//Maximum 


extern int NextKeyTime,NextKey,KeyState;

*/

void Joint_AddChild(Joint *j,Joint *jc)
{
/*	Joint **tmp;
	int n;
	n=j->child_n + 1;
	tmp=xmalloc(sizeof(Joint *)*n); 
	tmp[j->child_n]=jc;
	
	if(
	j->child=tmp;
	*/

	if (j->child_n >j->child_memory_n ) DEBUG(" too many child !!Joint");
	j->child[j->child_n]=jc;
	j->child_n++;
}

void Joint_IncVertexMemory(Joint *j)
{
	Vertex **tmp;
	int n,size;

	n=j->vertex_n + 1;
	
	size=j->vertex_n * sizeof(char *);
	tmp=xmalloc(sizeof(char *)*n);

//	if(size!=0)
        memcpy(tmp,j->vertex,size);

	j->vertex=tmp;
	free(j->vertex);
}

void Joint_makeVertexMemory(Joint *j,int n)
{
	j->vertex=xmalloc(sizeof(char *)*n); // ??

	j->vertex_id=xmalloc(sizeof(int)*n);
	j->vertex_memory_n=n;
//DEL !! free(j->vertex);
//	OK();
}


void Joint_frame(Joint *j,int n)
{
	int i;
//	if( j->frame_n < n ) return;

	for(i=0 ; i< j->vertex_n; i++)
	{
					
			
	}

}


void Joint_ClusterTransfrom(Joint *j,int n)
{
	int i;

//	if( j->frame_n < n ) return;

	for(i=0 ; i< j->vertex_n; i++)
	{
					
			
	}

}



void Joint_AddVertex(Joint *j,Vertex *v)
{

	j->vertex[j->vertex_n]=v;
	j->vertex_n++;
	
}


Joint * Joint_Init(Joint *j)
{
	j->child_n=0;
	j->vertex_n=0;
	j->vertex_memory_n=0;
	j->child_memory_n=8;
	j->rotate[0]=0;
	j->rotate[1]=0;
	j->rotate[2]=0;
	j->translate[0]=0;
	j->translate[1]=0;
	j->translate[2]=0;
    //DEL 	j->child=xmalloc(sizeof(Joint *)*8);  
	j->parent=NULL;
	//j->key=0;
}


Joint * NewJoint()
{
	Joint *j;
    	j=xmalloc(sizeof(Joint));  
	
	Joint_Init(j);
	return j;
}
                                                                                          
// you can build the joint matrix:^M                                                            
// - rotate an identity matrix by the rotation values of the joint^M                            
// - set the translation of the matrix to the position values.^M                                

// the same for key matrices^M                                                                  
// the key matrices animate the reference matrices, so you have to multiply them,^M             
// to get the final local joint matrix.  The get the final global joint matrix,^M               
// you have to multiply them by their parents.              




Joint_Draw2(Shape *model)
{
	Joint	*joint;
	Joint	*jc,*jp;
	Key	*frame,*jp_frame;
	int   	key,i,j;  
	
	float 	add_position[3]={0,0,0};

	key=0;

    	glDisable(GL_DEPTH_TEST);
	glPushMatrix();
//	glTranslatef(model->x,model->y,model->z);
	glDisable(GL_TEXTURE_2D);


	glColor4f(1.0, 0.0, 0.0,1.0); 

	
	glPointSize(7);
	
	if(model->joint_n>54) ERROR("joint n = %d",model->joint_n);
	
	for(i=0;i< model->joint_n;i++)
	{
		joint= &model->joint[i]; 
		
		frame= model->joint[i].frame; 

/*		printf("rotate= %f %f %f ",frame[key].rotate[0],
					frame[key].rotate[1],
					frame[key].rotate[2]);
	
		printf("translate= %f %f %f \n",frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);
*/
		if(joint->child_n>10) ERROR("joint error = %d",joint->child_n);
			glBegin(GL_POINTS);
			glVertex3f(	frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);

			glEnd(); 
		
		
	}


	glPointSize(1);
	glPopMatrix();

    	glEnable(GL_DEPTH_TEST);
}


//DELETE
int NextKeyTime=0;
int NextKey=0;
int KeyState=1;


float xaxis[3]={ 5,0,0};
float yaxis[3]={ 0,5,0};
float zaxis[3]={ 0,0,5};

//Shape_DrawCenter(Shape *shape)
Object_DrawCenter(Object *obj)
{
	int   	i,j;  
	float	matrix[4][4];
	float 	xpoint[3];	
	float 	ypoint[3];	
	float 	zpoint[3];	
	float 	opoint[3];
	
	float	translate[3];
	float	rotate[3];
	
	int 	key;
	
	
	glPointSize(8);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(obj->center);
	glVertex3f(0,0,0);
	glEnd();
    	glEnable(GL_DEPTH_TEST);
	
	return ;


	vectorAdd(xpoint,translate);
	vectorAdd(ypoint,translate);
	vectorAdd(zpoint,translate);
	vectorCopy(opoint,translate);
	glColor4f(1.0, 1.0, 1.0,1.0); 
	
	glPointSize(1);
	glBegin(GL_LINES);
	
	glVertex3fv(opoint);
	glVertex3fv(xpoint);
	glVertex3fv(opoint);
	glVertex3fv(ypoint);
	glVertex3fv(opoint);
	glVertex3fv(zpoint);
	
	glEnd(); 

	glPointSize(7);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(xpoint);

	
	glColor4f(0.0, 1.0, 0.0,1.0); 
	glVertex3fv(ypoint);
	
	glColor4f(0.0, 0.0, 1.0,1.0); 
	glVertex3fv(zpoint);
	glEnd(); 
			
	glPointSize(1);
}


Joint_DrawAxis(Joint  *joint)
{
	Joint	*jc,*jp;
	Key	*frame,*jp_frame;
	int   	i,j;  
	float	matrix[4][4];
	float 	xpoint[3];	
	float 	ypoint[3];	
	float 	zpoint[3];	
	float 	opoint[3];
	
	float	translate[3];
	float	rotate[3];
	
	int 	key;
	
	//key=NextKey;
	key=0;
    	glDisable(GL_DEPTH_TEST);
	
//	printf("*joint=%x \n",joint);
	frame=joint->frame;


// 	AngleMatrix(joint->frame[key].mRe, matrix);
/*
	printf("rotate= %f %f %f \n",frame[key].rotate[0],
					frame[key].rotate[1],
					frame[key].rotate[2]);
	printf("translate= %f %f %f \n",frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);

*/

//	Matrix_vectorRotate(matrix,xaxis,xpoint);
	Matrix_vectorRotate(joint->mRelativeFinal,xaxis,xpoint);
	Matrix_vectorRotate(joint->mRelativeFinal,yaxis,ypoint);
	Matrix_vectorRotate(joint->mRelativeFinal,zaxis,zpoint);

//	Matrix_vectorRotate(matrix,xaxis,xpoint);
//	Matrix_vectorRotate(matrix,yaxis,ypoint);
//	Matrix_vectorRotate(matrix,zaxis,zpoint);


	translate[0]=joint->mAbsolute[0][3];
	translate[1]=joint->mAbsolute[1][3];
	translate[2]=joint->mAbsolute[2][3];
	
	vectorAdd(xpoint,translate);
	vectorAdd(ypoint,translate);
	vectorAdd(zpoint,translate);
	vectorCopy(opoint,translate);

/*	printf("translate= %f %f %f \n",frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);
	printf("translateX= %f %f %f \n",joint->frame[key].translate[0],
					joint->frame[key].translate[1],
					joint->frame[key].translate[2]);
*/

	glColor4f(1.0, 1.0, 1.0,1.0); 
	
	glPointSize(1);
	glBegin(GL_LINES);
	
	glVertex3fv(opoint);
	glVertex3fv(xpoint);
	glVertex3fv(opoint);
	glVertex3fv(ypoint);
	glVertex3fv(opoint);
	glVertex3fv(zpoint);
	
	glEnd(); 

	glPointSize(7);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(xpoint);

	
	glColor4f(0.0, 1.0, 0.0,1.0); 
	glVertex3fv(ypoint);
	
	glColor4f(0.0, 0.0, 1.0,1.0); 
	glVertex3fv(zpoint);
	glEnd(); 
			

//	vectorAdd(

	glPointSize(1);
//	glPopMatrix();

    	glEnable(GL_DEPTH_TEST);
}

int DELShape_nextKeySimpleLoop(Shape	*model)
{

//	if(KeyState==0) return NextKey;
	
	if(NextKeyTime>20)
	{
		// need correction !! 
		//if(NextKey > model->frame_n-2) NextKey=0;
		//else NextKey++;
		NextKeyTime=0;
	}
	NextKeyTime+=iDeltaTime;
	
//	return NextKey;
}


#define ANI


// localǥ 
Shape_DrawJoint(Shape *model)
{
	Joint	*joint;
	Joint	*jc,*jp;
	int   	i,j;  



    	glDisable(GL_DEPTH_TEST);
//	glPushMatrix();
//	glTranslatef(model->x,model->y,model->z);
	glDisable(GL_TEXTURE_2D);

	glColor4f(1.0, 1.0, 1.0,1.0); 

	glBegin(GL_LINES);
	for(i=0;i< model->joint_n;i++)
	{
		joint= &model->joint[i]; 

		if(joint->child_n>10) ERROR("joint error = %d",joint->child_n);

		for(j=0;j< joint->child_n;j++){
			jc=joint->child[j];
			glVertex3f(joint->mAbsolute[0][3],
				joint->mAbsolute[1][3],
				joint->mAbsolute[2][3]);
			glVertex3f(jc->mAbsolute[0][3],
				jc->mAbsolute[1][3],
				jc->mAbsolute[2][3]);
		}


	}
	glEnd(); 


	glPointSize(4);
	for(i=0;i< model->joint_n;i++)
	{
		joint= &model->joint[i]; 
		//Joint_DrawAxis(joint);

		if(joint->child_n>10) ERROR("joint error = %d",joint->child_n);

		glBegin(GL_POINTS);
		glVertex3f(	joint->mAbsolute[0][3],
				joint->mAbsolute[1][3],
				joint->mAbsolute[2][3]);
			
		glEnd(); 


	}
	glPointSize(1);
    	glEnable(GL_DEPTH_TEST);
}



extern int Flag_DrawJoint;

Object_DrawJoint(Object *obj)
{
	Joint	*joint;
	Joint	*shape_joint;
	Joint	*jc,*jp;
	Shape	*shape;
	int   	i,j;  
	int 	pid;
	int	cid;	

	if(!Flag_DrawJoint) return;

	shape=obj->shape;

    	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glDisable( GL_LIGHTING);

	glColor4f(1.0, 1.0, 1.0,1.0); 

	
	glBegin(GL_LINES);
	for(i=0;i< shape->joint_n;i++)
	{
		joint= &obj->joint[i]; 
		shape_joint=&shape->joint[i];
		pid=shape->joint[i].parent_id; 
		
		if(shape_joint->child_n>10) ERROR("joint error = %d",shape_joint->child_n);

		for(j=0;j< shape_joint->child_n;j++){
			
			cid=shape_joint->child[j]->id;
			jc=&obj->joint[cid];

			glVertex3f(joint->mAbsolute[0][3],
				joint->mAbsolute[1][3],
				joint->mAbsolute[2][3]);
			glVertex3f(jc->mAbsolute[0][3],
				jc->mAbsolute[1][3],
				jc->mAbsolute[2][3]);
		}


	}
	glEnd(); 


	glPointSize(4);
	for(i=0;i< shape->joint_n;i++)
	{
		joint= &obj->joint[i]; 
		//Joint_DrawAxis(joint);

		if(joint->child_n>10) ERROR("joint error = %d",joint->child_n);

		glBegin(GL_POINTS);
		glVertex3f(	joint->mAbsolute[0][3],
				joint->mAbsolute[1][3],
				joint->mAbsolute[2][3]);
			
		glEnd(); 


	}
	glPointSize(1);
    	glEnable(GL_DEPTH_TEST);
}



// ǥ
void XObject_DrawJoint(Object *obj)
{
///	glTranslatef(obj->x,obj->y,obj->z);
	Shape_DrawJoint(obj->shape);
}



//  Լ 
Shape_JointTransform(Shape *model)
{
	Joint	*joint;
	Joint	*jc,*jp;
	Key	*frame,*jp_frame;
	int   	key,i,j;  

	if(model ==NULL) return;
	//shpae   ߻ϹǷ object  next_key Ѵ.
	key=model->nextKey;
   

	for(i=0;i< model->joint_n;i++)
	{
		float v1[3];
		float matrix[4][4];
	
		joint= &model->joint[i]; 
	//	frame= model->joint[i].frame; 
	//	frame=Shape_getFrame(model,i);


		// mRelative[3][3] Ȱ  init ֱ⸸ϸȴ. 
		// mReference ٲپ. 
		
		// Űκ Ʈ  
		AngleMatrix(frame[key].rotate, matrix);
		matrix[0][3]=frame[key].translate[0];
		matrix[1][3]=frame[key].translate[1];
		matrix[2][3]=frame[key].translate[2];

		// ִ¹ ʵǳ ?  -> ˵...
		R_ConcatTransforms (joint->mReference, matrix, joint->mRelativeFinal);
		
		if(joint->parent!=NULL)
		{
			//mAbsolute Ǿ.  -> ???
			R_ConcatTransforms (joint->parent->mAbsolute,  joint->mRelativeFinal, joint->mAbsolute);
		}
		else 	
			memcpy (joint->mAbsolute, joint->mRelativeFinal, sizeof (float [4][4] ));


	}

	// ƮŬ  Ʈ ؽ  ƮѴ.
	for(i=0;i< model->joint_n;i++)
	{
		Joint 	*joint;
		Vertex 	*v;
		int	id;
		float 	v1[3],v2[3];
		
		joint= &model->joint[i]; 

		for(j=0; j < joint->vertex_n;j++)
		{
			
			id=joint->vertex_id[j];
			v=&model->vertex0[id];
			v1[0]=v->x;
			v1[1]=v->y;
			v1[2]=v->z;

			//ERROR("&v->x =%d &v->y=%d &v->z %d \n",&v->x,&v->y,&v->z);
			
			// Ʈóϸ  ??
			Matrix_vectorTransform(joint->mAbsolute,v1,v2);
			//Matrix_vectorTransform(joint->mFinal,v1,v2);

			model->vertex[id].x=v2[0];
			model->vertex[id].y=v2[1];
			model->vertex[id].z=v2[2]; 
	


		}

	}
}

// shape joint  ʵǰ Object Ѵ.
// object joint ؼ  Ʈ߻Ų.  

//  obj->vertex  
// ex) Animation_getJointFrame(ü,joint);
// ex) Animation_getJointFrame(ü,joint);

//̽ ,   
extern Shape *terror;
void Animation_JointTransform(Animation *ani,Joint *joints)
{
	Joint	*joint,*shape_joint;
	Key	*frame;
	float 	matrix[4][4];
	float 	mRelativeFinal[4][4];
	int   	key,i,j;  
	int	pid;

	Shape *shape;
	shape=ani->shape;

	if(shape==NULL) ERROR("????");
  	//̷   if(ani->which<0 || ani->nextKey <0 ) return 0; 
	
	key=ani->nextKey;
	if(key<0) return;
	
	for(i=0;i< shape->joint_n;i++)
	{
		pid=shape->joint[i].parent_id; 
		
		frame=Animation_getJointFrame(ani,i);
		
		// ****  matrix ִϸ̼ǰ̴. 
		// Űκ Ʈ 
		// *** ̰ ׻ ϴϱ ĳ !!
		AngleMatrix(frame[key].rotate, matrix);
		matrix[0][3]=frame[key].translate[0];
		matrix[1][3]=frame[key].translate[1];
		matrix[2][3]=frame[key].translate[2];

		if(shape==terror && i==0){
			//޸ ̰ϴ°
			matrix[0][3]=0;
		//	joint->mRelativeFinal[1][3]=0;
		//	joint->mRelativeFinal[2][3]=0;
		}


		//ȸ ִ¹ ʵǳ ?  -> ˵...
		// mReference   shape->joint ҷ´.
		// *** shape->mReference ʱȭ vertex ⺻ġ ű  
		// frame->matrix   ִϸ̼Ǵܰ 
		//  matrix պָ ϴ  ĥִ.
		// mReference ׻ ϴ !! ׷  ?
		R_ConcatTransforms (shape->joint[i].mReference, matrix, mRelativeFinal);
		
		if(pid >= 0)
		{
			R_ConcatTransforms (joints[pid].mAbsolute,  mRelativeFinal, joints[i].mAbsolute);
		}
		else 	{
			memcpy (joints[i].mAbsolute, mRelativeFinal, sizeof (float [4][4] ));
		}
	}

}

Key test_frame[128];

Object_clearframe(Object *obj)
{
	int i;
	for(i=0;i< 128;i++)
	{
		obj->frame[i].rotate[0]=0; 
		obj->frame[i].rotate[1]=0;
		obj->frame[i].rotate[2]=0;
		obj->frame[i].translate[0]=0;
		obj->frame[i].translate[1]=0;
		obj->frame[i].translate[2]=0;
	}
}


clear_joint(Object *obj)
{
	int i,j;
	Shape *shape;
	Joint *joint;
	shape=obj->shape;

	for(i=0;i< shape->joint_n;i++)
	{
		joint=&obj->joint[i]; 

		for(j=0;j<4;j++) // obj->joint ʱȭ 
		{
			joint->mAbsolute[j][0]=0;
			joint->mAbsolute[j][1]=0;
			joint->mAbsolute[j][2]=0;
			joint->mAbsolute[j][3]=0;
		} 
		obj->frame[i].rotate[0]=0; 
		obj->frame[i].rotate[1]=0;
		obj->frame[i].rotate[2]=0;
		obj->frame[i].translate[0]=0;
		obj->frame[i].translate[1]=0;
		obj->frame[i].translate[2]=0;
	}
}


// 
Animation_JointSynthesis(Animation *ani,Joint *joints)
{
	Joint	*joint,*shape_joint;
	Key	*frame;
	int   	key,i,j;  
	int	pid;

	Shape *shape;
	shape=ani->shape;

	if(shape==NULL) ERROR("????");
	if(shape!=terror) return;
	
	key=ani->nextKey;
	
	for(i=0;i< shape->joint_n;i++)
	{
		frame=Animation_getJointFrame(ani,i);
		
//		memcpy (&test_frame[i], &frame[key], sizeof (Key));

		test_frame[i].rotate[0]=frame[key].rotate[0]; 
		test_frame[i].rotate[1]=frame[key].rotate[1]; 
		test_frame[i].rotate[2]=frame[key].rotate[2]; 
		test_frame[i].translate[0]=frame[key].translate[0]; 
		test_frame[i].translate[1]=frame[key].translate[1]; 
		test_frame[i].translate[2]=frame[key].translate[2]; 
	}

}


void Animation_JointSynthesis2(Animation *ani,Joint *joints,int j1,int j2,Key *ani_frame)
{
	Key	*frame;
	int   	key,i,j;  
	float 	rotate,translate;
	int 	num;
	float   rotate_max=RADIAN(5);

	key=ani->nextKey;
	if(key<0) return;

	
//	ani_frame=ani->frame;

	for(i=j1;i<= j2;i++)
	{
		num=ani->leftTime/20;
		frame=Animation_getJointFrame(ani,i);

		
		rotate=frame[key].rotate[0]-ani_frame[i].rotate[0]; 
//		printf("rotate_diff=%f \n",rotate);
		ani_frame[i].rotate[0]+=rotate/(1+num); 
		rotate=frame[key].rotate[1]-ani_frame[i].rotate[1]; 
		ani_frame[i].rotate[1]+=rotate/(1+num); 
		rotate=frame[key].rotate[2]-ani_frame[i].rotate[2]; 
		ani_frame[i].rotate[2]+=rotate/(1+num); 
	
/*		translate=frame[key].translate[0]-ani_frame[i].translate[0]; 
		ani_frame[i].translate[0]+=translate/(1+num);
		translate=frame[key].translate[1]-ani_frame[i].translate[1]; 
		ani_frame[i].translate[1]+=translate/(1+num);
		translate=frame[key].translate[2]-ani_frame[i].translate[2]; 
		ani_frame[i].translate[2]+=translate/(1+num); */
		ani_frame[i].translate[0]=frame[key].translate[0]; 
		ani_frame[i].translate[1]=frame[key].translate[1]; 
		ani_frame[i].translate[2]=frame[key].translate[2]; 
}


}

Animation_JointSynthesis3(Animation *ani,Joint *joints,int j1,int j2,Key *ani_frame)
{
	Key	*frame;
	int   	key,i,j;  
	float 	rotate,translate;
	int 	num;
	float   rotate_max=RADIAN(5);

	key=ani->nextKey;
	if(key<0) return;

	// ζʷ̼ 
	for(i=j1;i<= j2;i++)
	{
		num=ani->leftTime/24;
		frame=Animation_getJointFrame(ani,i);
		
		rotate=frame[key].rotate[0]-ani_frame[i].rotate[0]; 
		ani_frame[i].rotate[0]+=rotate/(1+num); 
		rotate=frame[key].rotate[1]-ani_frame[i].rotate[1]; 
		ani_frame[i].rotate[1]+=rotate/(1+num); 
		rotate=frame[key].rotate[2]-ani_frame[i].rotate[2]; 
		ani_frame[i].rotate[2]+=rotate/(1+num); 
	
/*		translate=frame[key].translate[0]-ani_frame[i].translate[0]; 
		ani_frame[i].translate[0]+=translate/(1+num);
		translate=frame[key].translate[1]-ani_frame[i].translate[1]; 
		ani_frame[i].translate[1]+=translate/(1+num);
		translate=frame[key].translate[2]-ani_frame[i].translate[2]; 
		ani_frame[i].translate[2]+=translate/(1+num); */
		ani_frame[i].translate[0]=frame[key].translate[0]; 
		ani_frame[i].translate[1]=frame[key].translate[1]; 
		ani_frame[i].translate[2]=frame[key].translate[2]; 
	}


}



// ð Ȱ  ϴ° ϳ..
// ̰ ðغ Ű 
void Animation_JointSynthesis4(Animation *ani,Joint *joints,int j1,int j2,Key *ani_frame)
{
	Key	*frame;
	int   	key,i,j;  
	int 	num;
	float 	rotate,translate;
	float   delta_rotate;
	float   rotate_max=RADIAN(1);
	float   rotate_small;

	key=ani->nextKey;
	if(key<0) return;

	
	for(i=j1;i<= j2;i++)
	{
		num=ani->leftTime/33;
		frame=Animation_getJointFrame(ani,i);
		
		// !!
		rotate=frame[key].rotate[0]-ani_frame[i].rotate[0]; 
		num=  rotate / rotate_max;
		//printf("rotate_max=%f  num=%d\n",rotate_max,num); exit(0);
		if(num<0) num=-num;
		ani_frame[i].rotate[0]+=rotate/(num+1); 
		
		rotate=frame[key].rotate[1]-ani_frame[i].rotate[1]; 
		num=  rotate / rotate_max;
		if(num<0) num=-num;
///		if(num==0) num=1;
		ani_frame[i].rotate[1]+=rotate/(num+1); 
		
		rotate=frame[key].rotate[2]-ani_frame[i].rotate[2]; 
		num=  rotate / rotate_max;
		if(num<0) num=-num;
		ani_frame[i].rotate[2]+=rotate/(num+1); 
	
		ani_frame[i].translate[0]=frame[key].translate[0]; 
		ani_frame[i].translate[1]=frame[key].translate[1]; 
		ani_frame[i].translate[2]=frame[key].translate[2]; 
	}

}





Animation_JointTransform2(Animation *ani,Joint *joints,Key *ani_frame)
{
	Joint	*joint; 	
	//	*shape_joint;
	Key	*frame;
	float 	matrix[4][4];
	float 	mRelativeFinal[4][4];
	int   	key,i,j;  
	int	pid;

	Shape *shape;
	shape=ani->shape;

	if(shape==NULL) ERROR("????");
  	//̷   if(ani->which<0 || ani->nextKey <0 ) return 0; 
	
	key=ani->nextKey;
	if(key<0) return;
	
 	if(shape!=terror) return;
	

	for(i=0;i< shape->joint_n;i++)
	{
		pid=shape->joint[i].parent_id; 
		
		// ****  matrix ִϸ̼ǰ̴. 
		// Űκ Ʈ 
		// *** ̰ ׻ ϴϱ ĳ !!
		AngleMatrix(ani_frame[i].rotate, matrix);
		matrix[0][3]=ani_frame[i].translate[0];
		matrix[1][3]=ani_frame[i].translate[1];
		matrix[2][3]=ani_frame[i].translate[2];

		// ̷ Ǵ° ? -> ִϸ̼ ۽ ̰ع !
		if(shape==terror && i==0){
			//޸ ̰ϴ°
			matrix[0][3]=0; //xǥ 
		//	matrix[1][3]=0; //xǥ 
		//	matrix[2][3]=0; //xǥ 
		//	joint->mRelativeFinal[1][3]=0;
		//	joint->mRelativeFinal[2][3]=0;
		}


		// ȸ ִ¹ ʵǳ ?  -> ˵...
		// mReference   shape->joint ҷ´.
		// *** shape->mReference ʱȭ vertex ⺻ġ ű  
		// frame->matrix   ִϸ̼Ǵܰ 
		//  matrix պָ ϴ  ĥִ.
		// mReference ׻ ϴ !! 
		R_ConcatTransforms (shape->joint[i].mReference, matrix, mRelativeFinal);
		
		if(pid >= 0)
			R_ConcatTransforms (joints[pid].mAbsolute,  mRelativeFinal, joints[i].mAbsolute);
		else 	
			memcpy (joints[i].mAbsolute, mRelativeFinal, sizeof (float [4][4] ));
	}

}


Animation_JointTransform_upper(Animation *ani,Joint *joints)
{
	Joint	*joint,*shape_joint;
	Key	*frame,*jp_frame;
	float 	matrix[4][4];
	float 	mRelativeFinal[4][4];
	int   	key,i,j;  

	int	pid;

	Shape *shape;
	shape=ani->shape;

	if(shape==NULL) ERROR("????");
	if(shape!=terror) ERROR("????xxxx");
	
	key=ani->nextKey;
	
	for(i=2;i< 38;i++)
	{
	
		shape_joint= &shape->joint[i]; 
		joint= &joints[i]; 
		frame=Animation_getJointFrame(ani,i);

		// ****  matrix ִϸ̼ǰ̴. 
		// Űκ Ʈ 
		// *** ̰ ׻ ϴϱ ĳ !!
		AngleMatrix(frame[key].rotate, matrix);
		matrix[0][3]=frame[key].translate[0];
		matrix[1][3]=frame[key].translate[1];
		matrix[2][3]=frame[key].translate[2];

		// ̷ Ǵ° ?
		if(shape==terror && i==0){
			//޸ ̰ϴ°
			matrix[0][3]=0;
		//	joint->mRelativeFinal[1][3]=0;
		//	joint->mRelativeFinal[2][3]=0;
		}


		R_ConcatTransforms (shape_joint->mReference, matrix, mRelativeFinal);
		pid=shape_joint->parent_id;
		if(pid >= 0)
		{
			R_ConcatTransforms (joints[pid].mAbsolute,  mRelativeFinal, joint->mAbsolute);
		}
		else 	{
			memcpy (joint->mAbsolute, mRelativeFinal, sizeof (float [4][4] ));
		}
	}



}


// callby:
int Shape_VertexTransform(Shape *shape,Joint *joints,Vertex *vertex)
{
	Joint	*joint,*shape_joint;
	int   	key,i,j;  

	// ƮŬ  Ʈ ؽ  ƮѴ.
	//   object  ڱ ǥϱؼ 
	// Object vertex0 ־Ѵ. 
	// ƮŬ  Ʈ ؽ  ƮѴ.
	for(i=0;i< shape->joint_n;i++)
	{
		Joint 	*joint;
		Vertex 	*v;
		int	id;
		float 	v1[3],v2[3];
		
		joint= &joints[i]; 
		shape_joint= &shape->joint[i];


		for(j=0; j < shape_joint->vertex_n;j++)
		{
			id=shape_joint->vertex_id[j];
			v=&shape->vertex0[id];
			
			Matrix_vectorTransform(joint->mAbsolute,&v->x,v2);

			vertex[id].x=v2[0];
			vertex[id].y=v2[1];
			vertex[id].z=v2[2]; 
			vertex[id].u=v->u;  //̰׻žƴѰ ?
			vertex[id].v=v->v;
		}

	}

}


int Object_VertexTransform(Object *obj)
{
	Shape_VertexTransform(obj->shape,obj->joint,obj->vertex);
}	

int Object_JointTransform3(Object *obj)
{
	Animation_JointTransform(&obj->animation,obj->joint);
}

//,ռ 
int Object_JointTransform4(Object *obj)
{
	Animation_JointTransform2(&obj->animation,obj->joint,obj->frame);
}


//
// Object->joint Ѵ.
int DEL_Object_JointTransform2(Object *obj)
{
	
	Joint	*joint,*shape_joint;
	Key	*frame,*jp_frame;
	Shape 	*shape;
	float matrix[4][4];
	float matrix2[4][4];

	int	pid;
	int   	key,i,j;  

	shape=obj->shape; // body

	if(shape ==NULL) return;
  	//del if(obj->animationKey<0 || obj->nextKey <0 ) return 0; 


	//d key=obj->nextKey;
	//obj->joint[0]->parent=NULL;
	for(i=0;i< shape->joint_n;i++)
	{
	
		joint= &obj->joint[i]; 
		shape_joint= &shape->joint[i]; 
		frame=Object_getJointFrame(obj,i);

		// Űκ Ʈ 
		//̰ matrix  ̸  ° ڳ !!
		AngleMatrix(frame[key].rotate, matrix);
		matrix[0][3]=frame[key].translate[0];
		matrix[1][3]=frame[key].translate[1];
		matrix[2][3]=frame[key].translate[2];

		// ̷ Ǵ° ?
		if(i==0){
			//޸ ̰ϴ°
			matrix[0][3]=0;
		//	joint->mRelativeFinal[0][3]=0;
		//	joint->mRelativeFinal[1][3]=0;
		//	joint->mRelativeFinal[2][3]=0;
		}


		AngleMatrix(joint->rotate, joint->mRelative);
		joint->mRelative[0][3]=joint->translate[0];
		joint->mRelative[1][3]=joint->translate[1];
		joint->mRelative[2][3]=joint->translate[2];


		// ִ¹ ʵǳ ?  ->  ˵...
		// mReference matrix  shape.joint ҷ ´ obj->joint 
		// mReference *matrix =׻ ϴ !!
		R_ConcatTransforms (shape_joint->mReference, matrix, matrix2);
		R_ConcatTransforms (matrix2,joint->mRelative, shape_joint->mRelativeFinal);
		
	//	memcpy (shape_joint->mRelativeFinal,matrix, sizeof (float [4][4] ));
			// ̰ shape_joint->mAbsolute ̰͵ ؾ 
		//if(shape_joint->parent!=NULL)
		pid=shape_joint->parent_id;

		if(pid >= 0)
		{
			//R_ConcatTransforms (shape_joint->parent->mAbsolute,  shape_joint->mRelativeFinal, shape_joint->mAbsolute);
			R_ConcatTransforms (shape->joint[pid].mAbsolute,  shape_joint->mRelativeFinal, shape_joint->mAbsolute);
			memcpy (joint->mAbsolute, shape_joint->mAbsolute, sizeof (float [4][4] ));
		}
		else 	{
			memcpy (shape_joint->mAbsolute, shape_joint->mRelativeFinal, sizeof (float [4][4] ));
			memcpy (joint->mAbsolute, shape_joint->mRelativeFinal, sizeof (float [4][4] ));
		}
	}

}



// 1. vertex ġ Ʈϱ ʱȭѴ. =>  ؽ ű⳪ ?
//   
// 2. shape->joint ->mReference  ʱȭ Ѵ.  
// 2. shape->joint ->mAbsolute  ʱȭ Ѵ.  
// 3. ʱȯ ؽ vertex0[] ȴ. 
void Shape_VertexInit(Shape *shape)
{
	Joint	*joint;
	Joint	*jc,*jp;
	int   	key,i,j;  
	
	key=0;
    
	for(i=0;i< shape->joint_n;i++)
	{
		joint= &shape->joint[i]; 

		AngleMatrix(joint->rotate, joint->mReference);
		//shape_joint
		joint->mReference[0][3]=joint->translate[0];
		joint->mReference[1][3]=joint->translate[1];
		joint->mReference[2][3]=joint->translate[2];
	

		if(joint->parent!=NULL)
		{
			R_ConcatTransforms (joint->parent->mAbsolute, joint->mReference, joint->mAbsolute);
		}	
		else {
			memcpy (joint->mAbsolute,joint->mReference,sizeof (float [4][4]));
		}

	}


	// ƮŬ( Ʈ ؽ)  ƮѴ.
	for(i=0;i< shape->joint_n;i++)
	{
		Joint 	*joint;
		Vertex 	*v;
		int	id;
		float 	v1[3],v2[3];
		
		joint= &shape->joint[i]; 

		for(j=0; j < joint->vertex_n;j++)
		{
			
			id=joint->vertex_id[j];
			v=&shape->vertex0[id];
			//v=&model->vertex0[id];
			v1[0]=v->x;
			v1[1]=v->y;
			v1[2]=v->z;

			v1[0]-=joint->mAbsolute[0][3];
			v1[1]-=joint->mAbsolute[1][3];
			v1[2]-=joint->mAbsolute[2][3];
			
			//v->x-=joint->mAbsolute[0][3];v->y-=joint->mAbsolute[1][3];v->z-=joint->mAbsolute[2][3];
			//ERROR("&v->x =%d &v->y=%d &v->z %d \n",&v->x,&v->y,&v->z);
			Matrix_vectorIRotate(joint->mAbsolute,v1,v2);
		
			shape->vertex0[id].x=v2[0];
			shape->vertex0[id].y=v2[1];
			shape->vertex0[id].z=v2[2];
		}
	} 
//	for(i=0;i< model->joint_n ; i++)
//			joints[i].frame= xmalloc(  sizeof(Key) * 1  );

}



void Shape_IncTriangleMemory(Shape *shape)
{

    int size,new_size,n,triangle_n;
    int left;

    Triangle *tri;
    triangle_n=shape ->triangle_n;
    
    left=shape->triangle_memory_n - triangle_n;
    if(left >10) return;


    n= 256 - left  + triangle_n;

    //    DEBUG("addtri");    
    size=sizeof(Triangle) * triangle_n;
    new_size=sizeof(Triangle) * n ;

    tri= xmalloc(new_size);

    if(size!=0)
        memcpy(tri,shape->triangle,size);

    free(shape->triangle);

    shape->triangle=tri;
    shape->triangle_memory_n=n;
    
}


void Shape_MakeTriangleMemory(Shape *s,int n)
{	
	if(s->triangle_n != 0) 
		ERROR(" I can't !!");

	if(s->triangle_memory_n==0){
		s->triangle=xmalloc(sizeof(Triangle)*n);        
		return ;
	}

	if(s->triangle_memory_n>n) return;
	
	
	if(s->triangle_memory_n<n){
  		free(s->triangle);
		s->triangle=xmalloc(sizeof(Triangle)*n);        
	}

}




Shape *New_Shape()
{
	
	Shape *obj;
	int size;
	obj=xmalloc(sizeof(Shape));  //  load_3df("x29.3df",x29);  

	obj->level=0;
	obj->FrameID=999;
	obj->vertex_n=0;
	obj->polygon_n=0;
	obj->triangle_n=0;
	obj->vertex=NULL;
	obj->triangle=NULL;
	obj->polygon=NULL;
	obj->joint=NULL;
	obj->x=0, obj->y=0, obj->z=0;

	strcpy(obj->name,"null");

	obj->triangle_memory_n=0;
	obj->polygon_memory_n=0;

	obj->shape_n=0;

	obj->rotate[0]=0;
	obj->rotate[1]=0;
	obj->rotate[2]=0;
	obj->translate[0]=0;
	obj->translate[1]=0;
	obj->translate[2]=0;

	
	obj->animation=NULL;
	obj->key=0;
	obj->ani_n=0;
	obj->flag=0;

	Shape_IncTriangleMemory(obj);

	return obj;
} 

//			model->vertex[id].x=v1[0];
//			model->vertex[id].y=v1[1];
//			model->vertex[id].z=v1[2];


//			v1[0]-=joint->mAbsolute[0][3];
//			v1[1]-=joint->mAbsolute[1][3];
//			v1[2]-=joint->mAbsolute[2][3];
	
//			v->x-=joint->mAbsolute[0][3];
//			v->y-=joint->mAbsolute[1][3];
//			v->z-=joint->mAbsolute[2][3];
			
//			Matrix_vectorTransform(joint->mAbsolute,v1,&model->vertex[j].z);
//			
///			Matrix_vectorTransform(joint->mAbsolute,v2,&model->vertex[id].x);
//			Matrix_vectorRotate(joint->mRelative,v1,&model->vertex[id].x);

/*			Matrix_vectorRotate(joint->mAbsolute,v1,v2);
			
			v2[0]+=joint->mAbsolute[0][3];
			v2[1]+=joint->mAbsolute[1][3];
			v2[2]+=joint->mAbsolute[2][3];
*/

