#include "ui.h"

Font *font;
int window_height=0;

void setFont(Font *f)
{
	font=f;
}
void setWindowHeight(int h)
{
	window_height=h;
}

int getWindowHeight()
{
	return	window_height;
}

void drawPoint(float x,float y,float z) //  ׸ 
{
	glBegin( GL_POINTS );
	glVertex3f( x, y,z );
	glEnd();
}

int drawString(int x,int y,const char *str)
{
	return font->drawString(x,y,str);
}


void setColor(char r,char g,char b,char a)
{
	glColor4ub(r,g,b,a);
}

void drawRectLine(int x,int y,int w,int h)
{
	y=window_height-y-h;

	glBegin(GL_LINE_LOOP);
	glVertex2i(x,y); // 1
	glVertex2i(x+w, y); //2
	glVertex2i(x+w,y + h);
	glVertex2i(x,y + h);
	glEnd();
}


void drawRect(int x,int y,int w,int h)
{
	//glRecti(x,window_height-y,x+w,window_height-y-h); // no alpha ?
	//return;
	glBegin(GL_QUADS);
	glVertex2i(x,window_height-y); // 1
	glVertex2i(x,window_height-y - h);
	glVertex2i(x+w, window_height-y - h);
	glVertex2i(x+w, window_height-y); //2
	glEnd();
}

