`timescale 1ns / 1ps

module module1(rst, clk,en,inp,out1,out2,out3,out4,out5,out6,out7,out8,out9,out10,
				cnt32_out,cnt30_out,cnt10_out,cnt8_out,block_mean_addr, block_mean,block_mean_vaild,frame_end
			  );
	input rst, clk,en;
	input [7:0] inp;
	output [17:0] out1,out2,out3,out4,out5,out6,out7,out8,out9,out10;
	output [4:0] cnt32_out,cnt30_out;
	output [3:0] cnt10_out;
	output [2:0] cnt8_out;
	output [6:0] block_mean_addr;
	output [7:0] block_mean;
	output block_mean_vaild;
	output frame_end;
	
	reg [7:0] block_mean;
	reg block_mean_vaild;
	wire acc_en1,acc_en2,acc_en3,acc_en4,acc_en5,acc_en6,acc_en7,acc_en8,acc_en9,acc_en10;
	reg acc_clear1,acc_clear2,acc_clear3,acc_clear4,acc_clear5,
		 acc_clear6,acc_clear7,acc_clear8,acc_clear9,acc_clear10;
//	wire frame_end;
	
	acc acc1 (clk,acc_clear1 ,acc_en1 ,inp, out1);
	acc acc2 (clk,acc_clear2 ,acc_en2 ,inp, out2);
	acc acc3 (clk,acc_clear3 ,acc_en3 ,inp, out3);
	acc acc4 (clk,acc_clear4 ,acc_en4 ,inp, out4);
	acc acc5 (clk,acc_clear5 ,acc_en5 ,inp, out5);
	acc acc6 (clk,acc_clear6 ,acc_en6 ,inp, out6);
	acc acc7 (clk,acc_clear7 ,acc_en7 ,inp, out7);
	acc acc8 (clk,acc_clear8 ,acc_en8 ,inp, out8);
	acc acc9 (clk,acc_clear9 ,acc_en9 ,inp, out9);
	acc acc10(clk,acc_clear10,acc_en10,inp, out10);
	
////assign acc_rst1 = /*(rst),*/ acc_clear1 ,
////	   acc_rst2 = /*(rst),*/ acc_clear2 ,	
////       acc_rst3 = /*(rst),*/ acc_clear3 ,
////       acc_rst4 = /*(rst),*/ acc_clear4 ,
////       acc_rst5 = /*(rst),*/ acc_clear5 ,
////       acc_rst6 = /*(rst),*/ acc_clear6 ,
////       acc_rst7 = /*(rst),*/ acc_clear7 ,
////       acc_rst8 = /*(rst),*/ acc_clear8 ,
////       acc_rst9 = /*(rst),*/ acc_clear9 ,
////       acc_rst10 =/*(rst);*/ acc_clear10;
////
	cnt32 cnt32(clk,rst,en,cnt32_out,carry32);
	cnt10 cnt10(clk,rst,carry32,cnt10_out,carry10);
	cnt30 cnt30(clk,rst,carry10,cnt30_out,carry30);
	cnt8 cnt8(clk,rst,carry30,cnt8_out,);
	cnt80 cnt80(clk,rst,block_mean_vaild,block_mean_addr,carry80);
//	ram ram_block_mean1(clk,block_mean,block_mean_stored1,block_mean_vaild,block_mean_addr);
	assign frame_end = carry80;
	
	assign   acc_en1= (en & cnt10_out==0)  ? 1'b1 : 1'b0,
  			 acc_en2= (en & cnt10_out==1)  ? 1'b1 : 1'b0,
  			 acc_en3= (en & cnt10_out==2)  ? 1'b1 : 1'b0,
  			 acc_en4= (en & cnt10_out==3)  ? 1'b1 : 1'b0,		
  			 acc_en5= (en & cnt10_out==4)  ? 1'b1 : 1'b0,
  			 acc_en6= (en & cnt10_out==5)  ? 1'b1 : 1'b0,
  			 acc_en7= (en & cnt10_out==6)  ? 1'b1 : 1'b0,
  			 acc_en8= (en & cnt10_out==7)  ? 1'b1 : 1'b0,
  			 acc_en9= (en & cnt10_out==8)  ? 1'b1 : 1'b0,
			 acc_en10=(en & cnt10_out==9)  ? 1'b1 : 1'b0;
	
always@(posedge clk or negedge rst)
	if(!rst)
		 begin
		 	block_mean<=0;
		 	block_mean_vaild<=0;
		 	acc_clear1 <=0 ;
			acc_clear2 <=0 ;
			acc_clear3 <=0 ;
			acc_clear4 <=0 ;
			acc_clear5 <=0 ;
			acc_clear6 <=0 ;
			acc_clear7 <=0 ;
			acc_clear8 <=0 ;
			acc_clear9 <=0 ;
  			acc_clear10<=0 ;
		 	end
	else if (cnt30_out==29 & cnt32_out==31)
		begin
			block_mean_vaild <= 1;
			case(cnt10_out)
				0: begin block_mean <= out1[17:10] ;acc_clear1 <=0 ;end   // Acc   !rst 
				1: begin block_mean <= out2[17:10] ;acc_clear2 <=0 ;end
				2: begin block_mean <= out3[17:10] ;acc_clear3 <=0 ;end
				3: begin block_mean <= out4[17:10] ;acc_clear4 <=0 ;end
				4: begin block_mean <= out5[17:10] ;acc_clear5 <=0 ;end
				5: begin block_mean <= out6[17:10] ;acc_clear6 <=0 ;end
				6: begin block_mean <= out7[17:10] ;acc_clear7 <=0 ;end
				7: begin block_mean <= out8[17:10] ;acc_clear8 <=0 ;end
				8: begin block_mean <= out9[17:10] ;acc_clear9 <=0 ;end
				9: begin block_mean <= out10[17:10];acc_clear10<=0 ;end
			endcase
		end
	else	
		begin
			acc_clear1 <=1 ;
			acc_clear2 <=1 ;
			acc_clear3 <=1 ;
			acc_clear4 <=1 ;
			acc_clear5 <=1 ;
			acc_clear6 <=1 ;
			acc_clear7 <=1 ;
			acc_clear8 <=1 ;
			acc_clear9 <=1 ;
  			acc_clear10<=1 ;
       		block_mean_vaild <=0;
		end 
		                           
endmodule       
	
	
	
	
//module ram(clk,inp, out, we, address); //////////////////////// ޸1
//    input clk;
//    input [7:0] inp;
//    output [7:0] out;
//    input we;
//    input [6:0] address;
//   parameter RAM_WIDTH = 8;
//   parameter RAM_ADDR_BITS = 7;
//   reg [RAM_WIDTH-1:0] test_ram [(2**RAM_ADDR_BITS)-1:0];
//   wire [RAM_WIDTH-1:0] out;
//   wire [RAM_ADDR_BITS-1:0] address;
//   wire [RAM_WIDTH-1:0] inp;
//   always @(posedge clk)
//      if (we)
//         test_ram[address] <= inp;
//   assign out = test_ram[address];   
//endmodule  ///////////////////////////////////////
	            
module acc(clk,rst,en,inp,out); //  ###########################################
	input clk, rst,en; //Ŭ, , ο̺
	input [7:0] inp;   // 8bit Է
	output [17:0] out;  // 18bit 
	reg [17:0] out;
always@(posedge clk or negedge rst)
	begin       
		if(!rst) begin out <= 0; end    // negative Reset 
		else if (en)		
		    out <=out+inp;
		else out <= out;
	end         
endmodule       // #########################################################################
                
                
module cnt8(clk,rst,en,out,carry); // 8 ī ###########################################
	input clk, rst,en;
	output [2:0] out;
	output carry;
	reg [2:0] out;
	wire q7;    
always@(posedge clk)
	begin       
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q7) out <=0;
		else out <=out+1;
	end         
assign q7 = (out==7);
assign carry = q7 & en;
endmodule       // #########################################################################
                
module cnt10(clk,rst,en,out,carry); // 10 ī ###########################################
	input clk, rst,en;
	output [3:0] out;
	output carry;
	reg [3:0] out;
	wire q9;    
always@(posedge clk)
	begin       
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q9) out <=0;
		else out <=out+1;
	end         
assign q9 = (out==9);
assign carry = q9 & en;
endmodule       // #########################################################################
                
module cnt32(clk,rst,en,out,carry);  // 32 ī  ####################################
	input clk, rst,en;
	output [4:0] out;
	output carry;
	reg [4:0] out;
	wire q31;   
always@(posedge clk)
	begin       
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q31) out <=0;
		else out <=out+1;
	end         
assign q31 = (out==31);
assign carry = q31 & en;
endmodule       // #########################################################################
                
module cnt30(clk,rst,en,out,carry); // 30 ī ###########################################
	input clk, rst,en;
	output [4:0] out;
	output carry;
	reg [4:0] out;
	wire q29;   
always@(posedge clk)
	begin       
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q29) out <=0;
		else out <=out+1;
	end         
assign q29 = (out==29);
assign carry = q29 & en;
endmodule       // #########################################################################
                
module cnt80(clk,rst,en,out,carry); // 80 ī ###########################################
	input clk, rst,en;
	output [6:0] out;
	output carry;
	reg [6:0] out;
	wire q79;   
always@(posedge clk)
	begin       
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q79) out <=0;
		else out <=out+1;
	end         
assign q79 = (out==79);
assign carry = q79 & en;
endmodule       // #########################################################################
