#include "define.h"
#include <stdarg.h>


#ifndef _CORE_
#define _CORE_
//#define TRUE 1
//#define FALSE 0
// ȭ  ̸   մϴ.
//  ϸ,  ̿  մϴ.

extern unsigned char user_name[128];

extern int arg_server;
extern int arg_fs;
extern int ScreenWidth,ScreenHeight,HalfScreenWidth,HalfScreenHeight;
extern int print_info_show,print_help_show;
extern int is_pilotView,RenderMode;
extern int fps,min_fps;
extern int InputLineMode;


// TIME 
extern int t,T0;
extern Uint32 iDeltaTime;
extern float fDeltaTime;
extern unsigned int FrameID;

extern Uint32 testTime,t0,t1,tx,tn;
extern Uint32 glTime,glTimeT,glt0,glt1;
extern Uint32 threadTime,threadTimeT,tt0,tt1;
Uint32 totalTime,totalTime0,totalTime1,totalTimeT;

// 콺 Ŀ  ó ġ   ϰ ʱȭմϴ.
extern int Mouse_ox , Mouse_oy;

// ʱ ġκ  Ÿ   ϰ ʱȭմϴ.
extern int Mouse_diffx , Mouse_diffy;

// 콺 Ͱ  ϴ  &ʱȭմϴ.
extern int is_mouseMove;

extern int ox, oy;   // main.c  ̰ ־ϴ.
extern int win;      // main.c....

extern SDL_Joystick *joystick;
extern SDL_Event event;  // main.c  .
extern SDL_Surface *sdl_screen;


extern float pil;


extern GLfloat Xrot,xrot,Yrot,Zrot;
extern GLfloat current_pitch,current_heading,current_x,current_y,current_z;

extern float pitch_cos,pitch_sin,heading_cos,heading_sin;



extern float Mouse_sens_diffx,Mouse_sens_diffy;
extern float Mouse_sens;
extern float Camera_z;


// WIN32 !!!
#undef 	near 
#undef 	far

extern struct s_Frust {
    float left,right,bottom,top;
    float near3,far2;
    float near2;
    float width,height;
    float LB[3],LT[3],RB[3],RT[3];
    float nL[3],nT[3],nB[3],nR[3];
} Frustrum;



typedef struct {
    int n;	    
    Object *object;
     void   *pre;
     void   *next;
} ObjectList;


ObjectList *current_objectlist;
ObjectList *first_objectlist;
//ObjectList *visible_object_list;


extern Object  *Objects[MAX_OBJECTS];
extern Object  *player;
extern Object  *Camera,*Camera2,*Camera1;

extern int Object_n,Objects_n;


#define MAX_TEXTURES 64
extern int Textures[MAX_TEXTURES];
extern int Texture_n;
#define init_object 	New_Object
#define insert_object 	Object_InsertList
#define remove_object 	Object_Remove


#define MISSILE_SMOKE 	0
#define SKY		1
#define GROUND		2
#define TERRORIST	3
#define STAR		4
#define PARTICLE	5

extern Cell  	*List_BlockCellsSorted[1024];
extern Cell 	*BlockCells_inFOV[1024*1024*2];
extern int	     BlockCells_inFOV_N;    
extern int	     BlockCells_Hit_N;    
extern int	     BlockCells_inFOVUnit_N;
extern Cell 	*octree_top;


extern int	ObjectsInFOV_n; 	// used 
extern Object   *List_ObjectsInFOV[MAX_OBJECTS]; //FOVȿ  objectƮ 



extern Object 	*map;
extern int 	visiable_polygon_n;
extern int 	draw_polygon_n;


extern int 	zbuffer_width;
extern int 	zbuffer_hegiht;
extern float 	zbuffer_depth;
extern 	float 	matrix_rotate90_y[4][4];
#endif

#define ZBUFFER_WIDTH 128
#define ZBUFFER_HEIGHT 96


//==================== misc function ==========================
void 	remove_ext(char *fname);
char 	*basename(const char *filename);
char 	*GetDirName(char *filename);
char 	*get_pahtname(char *filename);
void 	*xmalloc (size_t size);
int 	checkFile(char *filename);
void 	strlowcase(char *s);
int 	strcasecmp2(const char *s1, const char *s2);
int 	vsscanf2 (const char *s,const char *format, va_list arg);
int 	vsscanf3(const char *s,const char *fmt, va_list va);


//===================== sound ================================
int 	LoadWave2(char *file);
void 	Object_soundPlayLoop(Object *obj,int id);
void 	Object_soundPlay(Object *obj,int id);

//=============================================================

void 	Object_Position(Object *obj,float x,float y,float z);

Shape 	*New_Shape();


void 	Shape_add_triangle_tex(Shape *obj,int id[3],Position2D texcoord[3],int tex_id);
void 	Shape_add_triangle_dynamic(Shape *model,Triangle *new_triangle);
void 	Shape_Name(Shape *obj,char *name);
void  	Shape_InsertToObject(Shape *,Object *obj);

Object 	*New_Object(char *name);
Vertex 	*New_Vertex();

Polygon *New_Polygon();
void 	Polygon_AddVertex(Polygon *p,Vertex *v);


void 	add_tpolygon(Object *obj,int n,int *id,Position2D *TexCoord);
int 	add_vertex(Object *obj,float x,float y,float z);

void 	Object_MoveFoward(Object *obj,float fDistance);
void 	Object_MoveSideRight(Object *obj,float distance);
void 	Object_setDirection2point(Object *obj,vector dest[3]);
void	Object_setDirection2Object(Object *obj,Object *dst_obj);
void 	Object_rotate(Object *obj,float angle,float up[3]);
void 	Object_Addheading(Object *obj,float angle);
void 	Object_Addpitch(Object *obj,float f);
void 	Object_ViewAddpitch(Object *obj,float f);

void 	rotateX(Position *p,float th);
void 	rotateY(Position *p,float th);

inline void Xrotation(vector *vs,float th);
inline void Yrotation(vector *vs,float th);

void 	TriangleCopy(Triangle *triangle,Triangle *new_triangle);
void  	PolygonCopy(Polygon *p1,Polygon *p2);

void 	Triangle2Polygon(Triangle *t,Polygon *p);
int 	Polygon2Triangle(Polygon *p,Face *t);
int 	PolygonSortVertex(Polygon *p);

int 	Polygon_checkVertex(Polygon *p,Vector *v);
void 	roundVertex(Vector *v);

inline void vectorRotationView(vector *vs);

inline void  Draw_TriangleZbuffer(Triangle *tri);

inline void Shape_AddPolygon(Shape *shape,Polygon *p);
inline void Polygon_AddVertex(Polygon *p,Vertex *v);

Think 	*Object_Think(Object *obj);

float 	getHeading(float o_dir[3]);
float 	getPitch(float o_dir[3]);

char 	*get_pahtname(char *name);
