
#define ColorWhite(); 	glColor3ub(255,255,255);
#define ColorGreen(); 	glColor3ub(120,255,120);
#define ColorRed(); 	glColor3ub(255,0,0);


#define RED 		0
#define BLUE 		1
#define GREEN 		2
#define LIGHTGREEN 	3
#define WHITE 		4

typedef struct {
    float fx,fy,fz;
    int x,y;
    int *px,*py;
    int Width,Height;
    int show;
    int SlidingKey;
    void (*Do)();
} Panel;


Panel *New_Panel(int x,int y,int width,int height,void (*Do));
void Panel_Show(Panel *p);
void Panel_Current( Panel *p );



typedef struct {
    int show;
    char *item[16];
    void (*callback)(int);
} NumMenu;


NumMenu *New_NumMenu(char *str[],void (*callback));
void NumMenu_Core();


int Draw_CharXY(int x,int y,char ch);
int Draw_StringXY(int x,int y,char *string);	// basis !!!

int DrawPrintfXY(int x,int y, const char *fmt, ... );
int DrawPrintf(const char *fmt, ... );

void DrawLine(int x1,int y1,int x2,int y2);
void DrawAll2D();

void DrawPoint(int x,int y); //  ׸ 
void DrawRectBlend(int x,int y,int width,int height);


