#define VER 	0.1
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>

#include <gtkgl/gtkglarea.h>
#include <GL/gl.h>

#include "base.c"
#include "gtkutil.c"

int ScreenWSize=256;
int ScreenHSize=256;


GtkWidget *window,*glarea,*TopScreen,*SideScreen,*BirdViewScreen;
GtkWidget *fixed_main,*fixed_menu,*menu,*menu_items,*root_menu,
	  *menu_bar,*vbox,*hbox;
GtkWidget *menu_LoadObject,*menu_LoadMap;

GtkWidget *vbox_HotKeyIcon,*button;

GLdouble object_pitch=20,object_heading=-19,object_z=50;
float object_distance=10;
Object *TempObject;


void LoadObject( GtkWidget        *w,                                                         
                  GtkFileSelection *fs )                                                        
{                                                                                               
    g_print ("ddd%s\n", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));  

    TempObject=init_object("hill1");
//    load_texture("./data/ground.bmp",TempObject);
    load_off("./data/hill1.off",TempObject);
    insert_object(TempObject);

}                                                                                               

void SaveMap()
{
    


}

  

void ViewAllObject()
{
    char list[32][64];

}



DealMenuitem(GtkWidget *w)

{
    if(w==menu_LoadObject)
    {
	printf("menu itemp LoadObject !!\n");   
	creat_file_selector_titile("title",LoadObject);
	return;
    }

if(w==menu_LoadMap)
    printf("menu itemp LoadMap !!\n");   
if(w==NULL)
    printf("NULL !!\n");   
}



#define B2F(b)  	((float)b/255)

ClearBackColor(){
   glClearColor(B2F(36),B2F(75),B2F(105),1);
   glClear(GL_COLOR_BUFFER_BIT);
}


draw_axes(void)
{
    glColor3ub(255, 0, 0);
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(1.0, 0.0, 0.0);
/*    glVertex3f(0.75, 0.25, 0.0);
    glVertex3f(0.75, -0.25, 0.0);
    glVertex3f(1.0, 0.0, 0.0);
    glVertex3f(0.75, 0.0, 0.25);
    glVertex3f(0.75, 0.0, -0.25);
    glVertex3f(1.0, 0.0, 0.0);*/
    glEnd();
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(0.0, 1.0, 0.0);
/*    glVertex3f(0.0, 0.75, 0.25);
    glVertex3f(0.0, 0.75, -0.25);
    glVertex3f(0.0, 1.0, 0.0);
    glVertex3f(0.25, 0.75, 0.0);
    glVertex3f(-0.25, 0.75, 0.0);
    glVertex3f(0.0, 1.0, 0.0);*/
    glEnd();
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(0.0, 0.0, 1.0);
/*    glVertex3f(0.25, 0.0, 0.75);
    glVertex3f(-0.25, 0.0, 0.75);
    glVertex3f(0.0, 0.0, 1.0);
    glVertex3f(0.0, 0.25, 0.75);
    glVertex3f(0.0, -0.25, 0.75);
    glVertex3f(0.0, 0.0, 1.0);*/
    glEnd();

    glColor3ub(255, 255, 0);
    glRasterPos3f(1.1, 0.0, 0.0);
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, 'x');
    glRasterPos3f(0.0, 1.1, 0.0);
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, 'y');
    glRasterPos3f(0.0, 0.0, 1.1);
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, 'z');
}



gint TopScreen_init(GtkWidget *widget)
{
  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, 500.0);
//      glOrtho(0,100, 100,0, -1,1);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      gluLookAt(0.0,object_distance,0.0,0.0,0.0,0.0,1.0,0.0,0.0);
    }
  return TRUE;
}


gint SideScreen_init(GtkWidget *widget)
{
  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, 500.0);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      gluLookAt(0.0,0,object_distance,0,0,0,0,1,0.0);
    }
  return TRUE;
}


/* When glarea widget size changes, viewport size is set to match the new size */
gint reshape(GtkWidget *widget, GdkEventConfigure *event)
{
  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
    }
  return TRUE;
}

gint BirdViewScreen_init(GtkWidget *widget)
{
  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
//      glOrtho(0,100, 100,0, -1,1);
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1, 500.0);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
    }
  return TRUE;
}





/* When widget is exposed it's contents are redrawn. */
gint draw(GtkWidget *widget, GdkEventExpose *event)
{
  /* Draw only last expose. */
  if (event->count > 0)
    return TRUE;

  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {

       ClearBackColor();
      glPushMatrix();
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glViewport(0,0, 80, 80);
      glTranslatef(0,0,-2.1);
      draw_axes();
      glPopMatrix();

      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      draw_objects();

      /* Swap backbuffer to front */
      gtk_gl_area_swapbuffers(GTK_GL_AREA(widget));

    }

  return TRUE;
}

gint BirdViewScreen_draw(GtkWidget *widget, GdkEventExpose *event)
{
  /* Draw only last expose. */
  // printf("expose event !!\n");
  if (event->count > 0)
   return TRUE;


  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {

  	ClearBackColor();
  //    glClearColor(0,0,0,1);
    //  glClear(GL_COLOR_BUFFER_BIT);

      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glViewport(0,255-80, 80, 80);
      glTranslatef(0,0,-2.1);
      glRotatef(object_pitch,1,0,0);
      glRotatef(object_heading,0,1,0);     // mouse_x
      draw_axes();


      glLoadIdentity();
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      glTranslatef(0,0,-object_distance);  // First

//    glRotated(roll,0,0,1);       glRotatef(0,0,0,1);
      glRotatef(object_pitch,1,0,0);     // mouse_y
      glRotatef(object_heading,0,1,0);     // mouse_x

//      printf("pitch= %f  heading=%f \n",object_pitch,object_heading);
      draw_objects();

      /* Swap backbuffer to front */
      gtk_gl_area_swapbuffers(GTK_GL_AREA(widget));

    }

  return TRUE;
}


int Mouse_x,Mouse_y;

static gint motion_notify_event( GtkWidget *widget,
                                 GdkEventMotion *event )
{
  int x, y;
  float diff_x,diff_y;
  GdkModifierType state;

 if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;


      state = event->state;
    }

      diff_y= (float)(y - Mouse_y)/40;
      diff_x= (float)(x - Mouse_x)/40;
//      printf("x=%d, y=%d \n",x,y);

    if (state & GDK_BUTTON1_MASK ){
      	object_pitch+=diff_y;
	object_heading+=diff_x;
//	printf("motion_notify_event()\n Drag x=%d\n");
//      	printf("object_heading=%f\n",object_heading);
      	gtk_widget_draw(widget,NULL);
    }
    if (state & GDK_BUTTON3_MASK ){

        object_distance+= diff_y/25;
//       printf("motion_notify_event() 3 Drag\n");
         gtk_widget_draw(widget,NULL);
     }

     return TRUE;
}



static gint button_press_event( GtkWidget      *widget,
                                GdkEventButton *event )
{

  if (event->button){
    Mouse_x = event->x;
    Mouse_y = event->y;

//    printf("button_press_event() x=%d , y=%d \n",Mouse_x,Mouse_y);
  }
    return TRUE;
}


static gint key_press_event( GtkWidget      *widget,
                                GdkEventButton *event )
{
/*	GdkEventKey *key;
               guint state, keyval;
        gbool keystate;
                 GdkEventButton *button;
        GdkEventMotion *motion;
               key = (GdkEventKey *)event;
            state = key->state;
        keyval = key->keyval;
        keystate = (((*(gint *)event) == GDK_KEY_PRESS) ? TRUE : FALSE);
        if(keyval == GDK_Escape)
        {
             if(!keystate)
             {
                    gdk_flush();
                    gdk_pointer_ungrab(key->time);
                    gdk_flush();
                    while(gdk_pointer_is_grabbed())
                        { gdk_pointer_ungrab(GDK_CURRENT_TIME); gdk_flush(); }
                }
                status = TRUE;
            }
            else if((keyval == GDK_Alt_L) ||
                    (keyval == GDK_Alt_R)
            )
*/
    return TRUE;
}




system_init()
{

      TempObject=init_object("hill1");
//      load_texture("./data/ground.bmp",TempObject);

      load_off("./data/hill1.off",TempObject);

      insert_object(TempObject);

}

init_menu()
{
  menu_bar = gtk_menu_bar_new ();
  gtk_widget_show (menu_bar);
  gtk_box_pack_start (GTK_BOX (vbox), menu_bar, FALSE, FALSE, 0);


//  gtk_container_add(GTK_CONTAINER(window),GTK_WIDGET(fixed_main));
  menu=gtk_menu_new();
            /* Create a new menu-item with a name... */
  menu_LoadObject = menu_items = gtk_menu_item_new_with_label ("load object");
  gtk_menu_append (GTK_MENU (menu), menu_items);
  gtk_signal_connect_object (GTK_OBJECT (menu_items), "activate",
		    GTK_SIGNAL_FUNC (DealMenuitem), GTK_OBJECT (menu_items));
  gtk_widget_show (menu_items);


  menu_LoadMap = menu_items = gtk_menu_item_new_with_label ("load map");
  gtk_menu_append (GTK_MENU (menu), menu_items);
  gtk_signal_connect_object (GTK_OBJECT (menu_items), "activate",
			GTK_SIGNAL_FUNC (DealMenuitem),GTK_OBJECT (menu_items));
  gtk_widget_show (menu_items);


  root_menu = gtk_menu_item_new_with_label ("Load");
  gtk_widget_show (root_menu);
  gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), root_menu);


  gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);


  root_menu = gtk_menu_item_new_with_label ("Save");
  gtk_widget_show (root_menu);
  gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), root_menu);
    /* Now we specify that we want our newly created "menu" to be the menu
     * for the "root menu" */

}

init_HotKeyIcon()
{

  vbox_HotKeyIcon = gtk_vbox_new (FALSE, 0);
//  gtk_widget_ref (vbox_HotKeyIcon);
//gtk_object_set_data_full (GTK_OBJECT (Test), "vbox_HotKeyIcon", vbox_HotKeyIcon,
//                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_HotKeyIcon);


  gtk_box_pack_start (GTK_BOX (hbox), vbox_HotKeyIcon, FALSE, TRUE, 0);


  gtk_widget_set_usize (vbox_HotKeyIcon, 25, -2);


  button = gtk_button_new_with_label ("V");
//  gtk_widget_ref (button);
//gtk_object_set_data_full (GTK_OBJECT (Test), "icon_button", icon_button,
//                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox_HotKeyIcon), button, FALSE, FALSE, 0);

  button = gtk_button_new_with_label ("P");
//  gtk_widget_ref (button);
//gtk_object_set_data_full (GTK_OBJECT (Test), "button16", button16,
//                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox_HotKeyIcon), button, FALSE, FALSE, 0);


  button = gtk_button_new_with_label ("O");
//  gtk_widget_ref (button);
//gtk_object_set_data_full (GTK_OBJECT (Test), "button17", button17,
//                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox_HotKeyIcon), button, FALSE, FALSE, 0);

}

init_screen()
{
  int attrlist[] = {
    GDK_GL_RGBA,
    GDK_GL_RED_SIZE,1,
    GDK_GL_GREEN_SIZE,1,
    GDK_GL_BLUE_SIZE,1,
    GDK_GL_DOUBLEBUFFER,
    GDK_GL_NONE
  }; 		
  /* Connect signal handlers */
  /* Redraw image when exposed. */
   /* Create new OpenGL widget. */
  glarea= GTK_WIDGET(gtk_gl_area_new(attrlist));
  TopScreen = GTK_WIDGET(gtk_gl_area_new(attrlist));
  SideScreen = GTK_WIDGET(gtk_gl_area_new(attrlist));
  BirdViewScreen = GTK_WIDGET(gtk_gl_area_new(attrlist));

  gtk_widget_show(GTK_WIDGET(TopScreen));
  gtk_widget_show(GTK_WIDGET(SideScreen));
  gtk_widget_show(GTK_WIDGET(BirdViewScreen));

  /* set minimum size */
  gtk_widget_set_usize(GTK_WIDGET(TopScreen), 255,255);
  gtk_widget_set_usize(GTK_WIDGET(SideScreen), 255,255);
  gtk_widget_set_usize(GTK_WIDGET(BirdViewScreen), 255,255);


  fixed_main = gtk_fixed_new ();
  gtk_widget_ref (fixed_main);
  gtk_object_set_data_full (GTK_OBJECT (window), "fixed_main", fixed_main,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_box_pack_start (GTK_BOX (hbox), fixed_main, FALSE, FALSE, 2);

  gtk_widget_show (fixed_main);


  gtk_fixed_put (GTK_FIXED (fixed_main), TopScreen, 1, 0);
  gtk_fixed_put (GTK_FIXED (fixed_main), SideScreen, ScreenWSize+2 , 0);
  gtk_fixed_put (GTK_FIXED (fixed_main), BirdViewScreen,ScreenWSize+2, ScreenHSize+2);

}


init_screen_signal()
{
  gtk_signal_connect(GTK_OBJECT(TopScreen), "key_press_event",
		     GTK_SIGNAL_FUNC(key_press_event), NULL);

  gtk_signal_connect(GTK_OBJECT(TopScreen), "expose_event",
		     GTK_SIGNAL_FUNC(draw), NULL);
  /* When window is resized viewport needs to be resized also. */
  gtk_signal_connect(GTK_OBJECT(TopScreen), "configure_event",
		     GTK_SIGNAL_FUNC(reshape), NULL);
  /* Do initialization when widget has been realized. */
  gtk_signal_connect(GTK_OBJECT(TopScreen), "realize",
		     GTK_SIGNAL_FUNC(TopScreen_init), NULL);

  gtk_signal_connect(GTK_OBJECT(SideScreen), "expose_event",
		     GTK_SIGNAL_FUNC(draw), NULL);
  gtk_signal_connect(GTK_OBJECT(SideScreen), "configure_event",
		     GTK_SIGNAL_FUNC(reshape), NULL);
  gtk_signal_connect(GTK_OBJECT(SideScreen), "realize",
		     GTK_SIGNAL_FUNC(SideScreen_init), NULL);

  gtk_signal_connect(GTK_OBJECT(BirdViewScreen), "expose_event",
		     GTK_SIGNAL_FUNC(BirdViewScreen_draw), NULL);
  gtk_signal_connect(GTK_OBJECT(BirdViewScreen), "configure_event",
		     GTK_SIGNAL_FUNC(reshape), NULL);
  gtk_signal_connect(GTK_OBJECT(BirdViewScreen), "realize",
		     GTK_SIGNAL_FUNC(BirdViewScreen_init), NULL);
  gtk_signal_connect (GTK_OBJECT (BirdViewScreen), "motion_notify_event",
                      (GtkSignalFunc) motion_notify_event, NULL);
  gtk_signal_connect (GTK_OBJECT (BirdViewScreen), "button_press_event",
		      (GtkSignalFunc) button_press_event, NULL);


  gtk_widget_set_events (GTK_WIDGET(BirdViewScreen), GDK_EXPOSURE_MASK|
//                         | GDK_LEAVE_NOTIFY_MASK
                          GDK_BUTTON_PRESS_MASK |
                          GDK_POINTER_MOTION_MASK
                         | GDK_POINTER_MOTION_HINT_MASK);

}


int main(int argc, char **argv)
{


  gchar *info_str;char buffer[512];

  /* Attribute list for gtkglarea widget. Specifies a
     list of Boolean attributes and enum/integer
     attribute/value pairs. The last attribute must be
     GDK_GL_NONE. See glXChooseVisual manpage for further
     explanation.
  */


  /* initialize gtk */
  gtk_init(&argc, &argv);

  /* Check if OpenGL is supported. */
  if (gdk_gl_query() == FALSE) {
    g_print("OpenGL not supported\n");
    return 0;
  }
  /* vendor dependent version info string */
  info_str = gdk_gl_get_info();
  g_print(info_str);
  g_free(info_str);


  /* Create new top level window. */
  window = gtk_window_new( GTK_WINDOW_TOPLEVEL);

  sprintf(buffer,"Version %f " ,VER);
  gtk_window_set_title(GTK_WINDOW(window), buffer);
  gtk_container_set_border_width(GTK_CONTAINER(window), 0);

  /* Quit form main if got delete event */
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_quit_add_destroy(1, GTK_OBJECT(window));



  /* Events for widget must be set before X Window is created */

	
  /* put glarea into window and show it all */


  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_widget_show (vbox);


  init_menu();

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 5);
  gtk_widget_show (hbox);

  init_screen();
  init_screen_signal();


  init_HotKeyIcon();


  system_init();

  gtk_widget_show(GTK_WIDGET(window));
  gtk_main();

  /* You should always delete gtk_gl_area widgets before exit or else
     GLX contexts are left undeleted, this may cause problems (=core dump)
     in some systems.
     Destroy method of objects is not automatically called on exit.
     You need to manually enable this feature. Do gtk_quit_add_destroy()
     for all your top level windows unless you are certain that they get
     destroy signal by other means.
  */

  return 0;
}

