#include <stdarg.h>
#include <stdio.h>
#include "define.h"
//#include "load.h"
#include "core.h"
#include "math.h"
#include "gpf.c"
#include "sprite.c"




float FactorMap=1;
#define MAX_LOAD_TEX 1024
struct {
    int  is_active;
    char filename[32];
    GLuint  texture_id;
    int  width,height;
}   loadedtexture[MAX_LOAD_TEX]; //Maximum 

int Texture_n=0;

// future file format  "Simple Graphic Format"
GLuint LoadSGF(char *filename )
{

}

GLuint	texture=0;
GLuint LoadGPF(char *filename )
{
	GLuint	format,comps;
	GPF		*g;

	if ( g=GPF_fileload(filename) )
	{
		GLuint type;
		switch(g->format)
		{
			case GPF_RGBA:
				format= GL_RGBA; comps=4;
				break;
			case GPF_RGB: 
				format= GL_RGB; comps=3;
				break;
			default:
				ERROR("error");
		}

		if(!arg_server){ // ʿ.
			//	    DEBUG("type=%d,width=%d,height=%d\n",g->format,g->width,g->height);
			glGenTextures( 1, &texture );
			glBindTexture( GL_TEXTURE_2D, texture); 

			// glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);                                                     
			// glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);                                                     

			//BADimage why ?? -> ok 
			//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST) ;
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );                                               
			//DONT_DEL   glTexImage2D( GL_TEXTURE_2D, 0, comps, g->width, g->height, 0, format, GL_UNSIGNED_BYTE, g->data );                  
			if(gluBuild2DMipmaps(GL_TEXTURE_2D,comps,g->width,g->height,format,GL_UNSIGNED_BYTE,g->data)!=0)  
				ERROR("gluBuild2DMipmaps!");	    
		}
		else texture++;

		loadedtexture[Texture_n].texture_id=texture;
		loadedtexture[Texture_n].width=g->width;
		loadedtexture[Texture_n].height=g->height;
		if(texture==0)
			ERROR("texture_id=%d  Texture_n=%d",texture,Texture_n);

		Texture_n++;

		GPF_Remove(g);
		return texture;

	}
	else 
	{	
		ERROR( "Could not open image: %s: %s\n", filename,SDL_GetError( ) );
		return( FALSE );
	}

}


// id   εȣ ˾Ƴ. 
int Texture_getIndex(int id)
{
	int i;
 	for(i=0;i<Texture_n;i++)
	if(loadedtexture[i].texture_id ==id )
	{ 
	    	return i;
	}
	return 0;
}


int Texture_getWidth(int id)
{
	int index;
	index=Texture_getIndex(id);
	return loadedtexture[index].width;
}

int Texture_getHeight(int id)
{
	int index;
	index=Texture_getIndex(id);
	return loadedtexture[index].height;
}


// gl_texture_name Ѵ.
int LoadTextureFile(char *filename)
{
	int i,name;
	unsigned char *pixels;
	SDL_Surface *surface;
	char *pathname,bn[64];;

/*
	if(arg_server){
		loadedtexture[0].texture_id=0;
		loadedtexture[0].width=256;
		loadedtexture[0].height=256;
		return 0; 
	}
*/

	strcpy(bn,basename(filename));
	remove_ext(bn);

	// bn  = test.gpf
	strlowcase(bn);
	strcat(bn,".gpf");
	DEBUG("basename =%s",bn);

	//̹ εǾ ̶ Ʈ ִ ãƺ...
	for(i=0;i<Texture_n;i++)
		if(!strcmp(loadedtexture[i].filename,bn))
		{ 
			// OKARG("found %s texture name \n",bn);
			return loadedtexture[i].texture_id;
		}


	pathname=get_pahtname(bn);
	strcpy(loadedtexture[Texture_n].filename,bn);

	name = LoadGPF(pathname);
	OKARG("loaded  %s ",bn);
	return name;
}


char Word[128]; // for getWrapWord()

char buffer[1024];
// dont pass {  } 
//
char * getWrapWord(FILE *fd)
{
	char ch;
	int  i=0;
	int quat=0,comment=0;

	while(!feof(fd))
	{
		ch=fgetc(fd);
		switch(ch)
		{	
				
			case ' ': 
				if(quat==1) {
			   		Word[i++]=' ';
					break;
				}
				
			case '\n':
			case 0x0d:  //for dos 
			case '\t':
			case '[':
			case ']':
			case ')':
			case '(':
			case '=':
			
				if(i>0){
					Word[i]=0;
					return Word;
				}

				break;
			case '/' :
				
				ch=fgetc(fd);
				if(ch=='/') 
					fgets(buffer,sizeof(buffer),fd);
				else{
					Word[i++]='/';
					fseek(fd,-1,SEEK_CUR);
				}

				break;

			case '\"' :
				if(quat!=1){
					quat=1;
					break;
				}	
				else {
					Word[i]=0;
					return Word;
				}
				
		
			default :
			   Word[i++]=ch;
			 break;
			
		}

	
	}
	return Word;
}	


// ܾ  鹮->Ѱ 鹮ڷ ν
// Token  =,{,},  ٷ  Word νѴ.
char *getWord(FILE *fd)
{
	char ch;
	int  i=0;
	int quat=0,comment=0;

	while(!feof(fd))
	{
		ch=fgetc(fd);
		switch(ch)
		{	
				
			case ' ': 
				if(quat==1) {
			   		Word[i++]=' ';
					break;
				}
				
			case '\n':   // 0x0A
			case 0x0d:  //for dos 
			case '\t':
			case '[':
			case ']':
			case ')':
			case '(':
			case '=':
			case '{':
			case '}':
			
				if(i>0){
					Word[i]=0;
					return Word;
				}

				break;
			case '/' :
				
				ch=fgetc(fd);
				if(ch=='/') 
					fgets(buffer,sizeof(buffer),fd);
				else{
					Word[i++]='/';
					fseek(fd,-1,SEEK_CUR);
				}

				break;

			case '\"' :  // quat !
				if(quat!=1){
					quat=1;
					break;
				}	
				else {
					Word[i]=0;
					return Word;
				}
				
		
			default :
			   Word[i++]=ch;
			 break;
			
		}

	
	}
	return Word;
}	

char Token[128]; // 
char *getToken(FILE *fd)
{
	char ch;
	int  i=0;
	int quat=0,comment=0;

	while(!feof(fd))
	{
		ch=fgetc(fd);
		switch(ch)
		{	
			case ' ': 
				if(quat==1) {
			   		Token[i++]=' ';
					break;
				}
			case '\n':   // 0x0A
			case 0x0d:  //for dos 
			case '\t':
				if(i>0){
					Token[i]=0;
					return Token;
				}

				break;

			case '/' : // comment
				
				ch=fgetc(fd);
				if(ch=='/') 
					fgets(buffer,sizeof(buffer),fd);
				else{
					Token[i++]='/';
					fseek(fd,-1,SEEK_CUR);
				}

				break;

			case '\"' :
				if(quat!=1){
					quat=1;
					break;
				}	
				else {
					Token[i]=0;
					return Token;
				}
				

			case '{' :
			case '}' :
			case '=' :
					Token[i++]=ch;
					Token[i]=0;
					return Token;
				
			default :
			   	Token[i++]=ch;
			 	break;
			
		}
	}
	
	ERROR("end");
}
	
char *ch;


//fscanf2(FILE *fd,char *str,char *buffer,&material_n); // material_number 
    
fgets2(char *buffer,int size,FILE *fd)
{
    fgets(buffer,size,fd); // nodes
//    printf("fgets2:%s",buffer);
    if(strlen(buffer)==0) printf(" fgets2,zero str \n");
}



ffindstr(FILE *fd,char *str)
{
    char buffer[256],dummy[128];

    while(!feof(fd)){
	fgets(buffer,sizeof(buffer),fd); // nodes
	if(strstr(buffer,str))
	{     
///	    printf("ffindstr:found %s\n",str);
	    break;
	}
    }

}


int SessionValue=0;

//  Format : 
//  SessionName = Value 
//  {
// 	 index_number     field1 field2 field3 ... 
//  }
//
int OpenSession(FILE *fd,char *name)
{
	char *buff,*buff2;
   	char buffer[64]; 
//	fseek(fd,0,SEEK_SET);
//	DEBUGON();
//	while(!feof(fd))
	{
		buff=getWord(fd);
		if(!strcmp(name,buff)){
			buff=getWord(fd);
			buff2=getToken(fd);
			SessionValue=atoi(buff);
    			DEBUG("%s = %d ( %s ) %s \n",name,SessionValue,buff,buff2);
			DEBUGOFF();
//			OK();
    			//printf("%s = %d \n %s %s",name,SessionValue,buff,buffer);
			return 1;
		}
	}
    		//else DEBUG("buff= %s\n",buff);
    	DEBUG("buff= %s\n",buff);
	DEBUG("Not Found %s \n",name);
	return 0;
}


char *getSessionName()
{

}

int getSessionValue()
{ 	return SessionValue; 	}

int CloseSession(FILE *fd)
{
	
	getToken(fd);
	if('}'!=Token[0]) ERROR("not match [%s]",Token); // } 
//	printf("closesession=%s \n",getToken(fd));
	DEBUG("OK");
}

// hyun 0.14  MilkShape3D plugin 
// Ʈ:  scanf  ๮,TAB  鹮ó   
// no animation
void Shape_LoadRAX(Shape *shape,char *filename)
{
	int 		vertex_n,tex_coord_n,normal_n,material_n,joint_n;
	int 		child_joint_n;
	int 		dummy_int,i,j,k,n,node_n=0;
	int		texture_id[32];
	int 		vertex_id[3];
	int		joint_of_vertex[1024]; // enough

	char 		buffer[256],dummy[128];

	FILE 		*fd;
	Vertex 		*vertex; 
	Position2D 	*tex;
	Triangle 	*triangle;
	Joint 		*joints;
	


	if(!(fd=fopen(get_pahtname(filename),"rb"))) ERROR("can't open [%s]",filename);

	// Ʈ б 
	if(OpenSession(fd,"Bone")==1)
	{
		int parent_id,id,vertex_n;
		//JointHierarchy
		joint_n=getSessionValue();	
		shape->joint_n=joint_n;	


		joints= xmalloc( sizeof(Joint) * joint_n );  // continus joints

		for(i=0;i< joint_n ; i++)
			Joint_Init(&joints[i]);
			
		for(i=0;i< joint_n ; i++){
			
		//  index=  0   parent= -1  vertex_n=   0   //Bip01 
			getWord(fd); id=atoi(getWord(fd)); 
			getWord(fd); parent_id=atoi(getWord(fd)); 
			getWord(fd); vertex_n=atoi(getWord(fd)); 
//			printf("%d %d %d \n",id,parent_id,vertex_n);
		
			
			joints[i].id=id; // ** 
			
			if(parent_id!=-1){
				joints[i].parent= &joints[parent_id];
				joints[i].parent_id= parent_id;
				
				// child  . -> ???
				Joint_AddChild(	&joints[parent_id], &joints[i]);
			}
			else joints[i].parent_id= -1 ;

			Joint_makeVertexMemory(	&joints[i],vertex_n);
		}		
		CloseSession(fd);
	}

	//̰ MilkShape3D  ؽʱȭϱ ̴.
	if(OpenSession(fd,"Joint")==1)
	{
		int joint_n;
		joint_n=getSessionValue();	
		

		for(j=0;j< joint_n ; j++){
			fscanf(fd,"%d %f %f %f ",&n
					,&joints[j].translate[0]
					,&joints[j].translate[1]
					,&joints[j].translate[2]);
			fscanf(fd," %f %f %f ",  
					&joints[j].rotate[0],
					&joints[j].rotate[1],
					&joints[j].rotate[2]);
		
		}		
		CloseSession(fd);
	}


	if(OpenSession(fd,"Material")==1)
	{
		material_n=getSessionValue();	
		for(i=0;i< material_n ; i++){
			fscanf(fd,"%s %s",dummy,buffer);
			texture_id[i]=LoadTextureFile(buffer); 
		}
		CloseSession(fd);
	}
	else DEBUG("cant find Material!!");


	if(OpenSession(fd,"Vertex")==1)
	{
		int joint,v_n; 
		float u,v;

		vertex_n=getSessionValue();	
		
		//for vertex0
		//޸𸮱۹߻     object vertex ϰԵȴ.
		//  ??
		vertex = xmalloc( sizeof(Vertex) * vertex_n );
		shape->vertex = xmalloc( sizeof(Vertex) * vertex_n );

		//Vertex & UV_Map
		for(i=0;i< vertex_n ; i++){
			// index  x  y  z  u  v  joint_index
			fscanf(fd,"%d %f %f %f %f %f %d",&j,&vertex[i].x,&vertex[i].y,&vertex[i].z,&u, &v,&joint);
			shape->vertex[i].u=u,shape->vertex[i].v=-v;

			
			joint_of_vertex[i]=joint; 
			//joint Ŭ vertex ͷ ǥϴ°   ?
			// ¥ ?
			v_n=joints[joint].vertex_n;
			joints[joint].vertex[v_n]=&vertex[i]; // pointer
			joints[joint].vertex_id[v_n]=i; // int vertex_id 

			joints[joint].vertex_n++;
		
		}
		CloseSession(fd);
	}

	if(OpenSession(fd,"Triangle")==1)
	{
		int  	tex_id;
		int 	triangle_n;
		int	v_id[3];

		triangle_n=getSessionValue();

		Shape_MakeTriangleMemory(shape,triangle_n);
		triangle=shape->triangle;
		
		for(i=0; i< triangle_n ; i++)
		{
			// index   v1 v2 v3 texture_index
		//	fscanf(fd,"%d   %d %d %d %d",&j,&triangle[i].vertex_id[0],&triangle[i].vertex_id[1],&triangle[i].vertex_id[2],&tex_id);
			fscanf(fd,"%d   %d %d %d %d",&j,&v_id[0],&v_id[1],&v_id[2],&tex_id);
			//DEL  triangle[i].flag=TRIANGLE_FLAG_MODEL;
		
			triangle[i].vertex_id[0]=v_id[0];
			triangle[i].vertex_id[1]=v_id[1];
			triangle[i].vertex_id[2]=v_id[2];
			triangle[i].texture_id=texture_id[tex_id];
		
			//ghost 
			// ׳ ù° ﰢ Ʈ Ѵ.
			triangle[i].joint=  joint_of_vertex[v_id[0]];
			
			//̰ ۾.. make_triangle_norm(&triangle[i]);
			vectors2normal(&vertex[v_id[0]],&vertex[v_id[1]],&vertex[v_id[2]], triangle[i].normal);
		}
		
		shape->triangle_n=triangle_n;
		CloseSession(fd);
	}

	shape->joint=joints;
	shape->vertex0=vertex;
//DEL 	shape->vertex=vertex;
	shape->flag=TRIANGLE_FLAG_MODEL ; //RAX Shape̱⶧ !
	
	
	Shape_VertexInit(shape);
	fclose(fd);
	OKARG("[%s] ",filename);
}



Shape_LoadANI(Shape *model,char *filename)
{
	int 		joint_n;
	int 		child_joint_n;

	int  		frame_n;
	int 		i,j,k,n,count;

	float 		f,scale;
	char 		buffer[256],dummy[128];

	FILE 		*fd;
	Joint 		*joints;
	Key		*keys;


	if(!(fd=fopen(filename,"rb"))) ERROR("file open [%s]",filename);

	fscanf(fd,"%s %d",buffer,&frame_n);
	fscanf(fd,"%s %d",buffer,&joint_n);
	DEBUG(" frame_n=%d   joint_n=%d \n",frame_n,joint_n);

	joints=model->joint;
	if(joints==NULL) ERROR("joints null");
	
	// increse_frameKeyMem();
	for(i=0;i< joint_n ; i++)
		joints[i].frame= xmalloc(  sizeof(Key) * 120  );


	for(j=0;j<joint_n ;j++)
	{
		fscanf(fd,"%s %d",buffer,&count);
		fscanf(fd,"%s ",buffer); // {
		for(i=0;i< count; i++)
		{
			fscanf(fd,"%d %f %f %f ",&n
					,&joints[j].frame[i].translate[0]
					,&joints[j].frame[i].translate[1]
					,&joints[j].frame[i].translate[2]);
			fscanf(fd," %f %f %f ",  
					&joints[j].frame[i].rotate[0],
					&joints[j].frame[i].rotate[1],
					&joints[j].frame[i].rotate[2]);
		
			DEBUG(" %d %f %f %f %f %f %f",n,joints[j].frame[i].translate[0]
					,joints[j].frame[i].translate[1]
					,joints[j].frame[i].translate[2],
					joints[j].frame[i].rotate[0],
					joints[j].frame[i].rotate[1],
					joints[j].frame[i].rotate[2]);

		} 
		fscanf(fd,"%s",buffer); // }
		DEBUG("joint_n = %d ",j);
	}
	 
	model->frame_n=count;
	fclose(fd);
	OKARG("[%s] ",filename);
}

typedef struct  s_event {
	Uint32  msec;
	int	event;
	int	event_seq; 
} Event ;

	// example  
	// if(event==SOUND) playsound(event_seq);

struct {
	char 	name[32];
	int  	id ;
	int	joint_n;
	int 	time;
	int 	start;
	int 	end;
	int 	frame_n;
	Key 	**frame;  //this will be  frame[joint_number ][ sequence_key ].translate[0] ;

	//Key	*frame;
	//
	Uint32	DeltaTime;
	int 	event_n;
	Event	events[16];
	
}   loaded_Ani[1024];
int loaded_Ani_n=0;
//Maximum 


extern int NextKeyTime,NextKey,KeyState;

//  shape  ִϸ̼ 
// ° ִϸ̼ frame  j° jointּҸ  ????
//
Key *Shape_getFrame(Shape *shape,int j)
{
	return &loaded_Ani[shape->animationKey].frame[j][0];
}

//ӽԼ  ο Լʿ!!! 
// shape ڱ ٲ ߻ ->  
Key *Object_getJointFrame(Object *obj,int j)
{
//	return &loaded_Ani[obj->animationKey].frame[j][0];
}

//ִϸ̼  shape´ ʸ´ ȮҼճ ?
Key *Animation_getJointFrame(Animation *ani,int j)
{
	return &loaded_Ani[ani->which].frame[j][0];
}





// shape  n° animation  
int Object_setAnimation(Object *obj,int n)
{	
	Shape *shape;
	shape=obj->shape;
	if(shape->ani_n < n ) ERROR(" n=%d  no ani shape_ani_n=%d  ",n,shape->ani_n);
	//obj->animationKey=shape->animation[n]; 
	return shape->animation[n]; 
}

int Animation_setWhichAni(Animation  *ani,int n)
{	
	Shape *shape;
	shape=ani->shape;
	if(shape->ani_n < n ) ERROR(" n=%d  no ani shape_ani_n=%d  ",n,shape->ani_n);
	ani->which=shape->animation[n]; 
	return shape->animation[n]; 
}


Key *Shape_getAnimationFrame(Shape *shape,int n)
{
	return &loaded_Ani[shape->animation[n]].frame[0][0];
}




int Animation_check(Animation *ani,int which)
{
	if(ani->action==which && ani->state==ANI_PLAYING) { 	return 1;}
	return 0;
}
// good mecahnism
// shpae ־ ° ִϸ̼   ٵ .
int Animation_Play(Animation *ani,int which,int irq,void *func)
{
	int ret=0;
//	if(ani->action==which && ani->state==ANI_PLAYING) { 		return;}
	if (!ani->IE) ret=1;
	if(ani->action==which && ani->state==ANI_PLAYING) ret= 1;

	if( ani->state==ANI_STOP) ret=0;

	if( ret) return 0;

	ani->state=ANI_PLAYING;
	ani->IE=irq;
	ani->nextKey=0;
	ani->Time=0;
	ani->leftTime=0;
	ani->CallFunc=func;
	ani->action=which;
	Animation_setWhichAni(ani,which); //maybe IDLE
	return 1;
}

// 
int Animation_PlayForce(Animation *ani,int which,int irq,void *func)
{
	ani->state=ANI_PLAYING;
	ani->IE=irq;
	ani->nextKey=0;
	ani->Time=0;
	ani->leftTime=0;
	ani->CallFunc=func;
	ani->action=which;
	Animation_setWhichAni(ani,which); //maybe IDLE
	return 1;
}

int Animation_setShape(Animation *ani,Shape *shape)
{
	ani->state=ANI_INIT;
	ani->IE=INTERUPT_ENABLE;
	ani->nextKey=0;
	ani->Time=0;
	ani->leftTime=0;
	ani->CallFunc=NULL;
	ani->shape=shape;
	Animation_setWhichAni(ani,0); //maybe IDLE
	return 1;
}

// ??? 
void Object_setShape(Object *obj,Shape *shape)
{
	if(shape==NULL) ERROR("this mean Object_setShape() should call after init_shape!!!");
	obj->shape=shape;

	if(shape->animation != NULL)
	{
		Animation_setShape(&obj->animation,shape);
	//ӽ 
		Animation_setShape(&obj->animation_upper,shape);
		Animation_setShape(&obj->animation_lower,shape);
	}

}

int Object_PlayAni5(Object *obj,int n,int irq)
{
	Animation_Play(&obj->animation,n,irq,NULL);
}


int Object_PlayAni3(Object *obj,int n,int irq,void *func)
{
	Animation_Play(&obj->animation,n,irq,func);
}




// ߰:  animationKey ´ Ȯؾϴµ 
// 	 shape ٲ .
// 	 
//  ߰ 
// ð ؼ Ű ȴ.GOOD
int delObject_nextKeyFoward(Object *obj)
{
	Shape	*shape;
	int 	Akey;
	int 	nextKey;

	shape=obj->shape;
	if(shape==NULL) return 0; 	// no animation model
//	if(obj->animation_state==ANI_END) 	return 0;
//	printf("333.obj->nextKey=%d  %d\n",obj->nextKey,obj->animation_state);
	
	if(Akey < 0) { 
		return 0;
	}
	
	//if(obj->nextKey< 0) ERROR("nextKey<0");

}


int test_time;
// callback objʿ
int Animation_nextKeyFoward1(Animation *ani,Object *obj)
{
	Shape	*shape;
	int 	Akey;
	int 	nextKey;
	Uint32	deltaTime,leftTime;
	
	shape=ani->shape;
	if(shape==NULL)	ERROR("non shape !!");

	if(ani->state!=ANI_PLAYING){
		ani->nextKey=0;
		//ERROR("ddd2");
		return;  	
	}
	
	Akey=ani->which;
	if(Akey < 0) { 
		ERROR("ddd3");
		return 0;
	}
	
	if(ani->nextKey< 0) ERROR("nextKey<0");


	deltaTime=loaded_Ani[Akey].DeltaTime;
	ani->leftTime=leftTime;
	ani->nextKey=nextKey;

	//ڵ Ѱ frameġ..
	if(nextKey >= loaded_Ani[Akey].frame_n -1 )  
	{	
		// 0  ̹Ƿ frame_n -1 ̴ 
		ani->nextKey=loaded_Ani[Akey].frame_n-1; // Ű ʱȭؾѴ.
		ani->state=ANI_END; // ִϸ̼ ѹ ÷̳.
		ani->IE=1; // ͷƮ 
		if(ani->CallFunc!=NULL) // callbackԼ ȣ 
			ani->CallFunc(obj);

		ani->CallFunc=NULL; 
		return ani->nextKey;
	}
	return ani->nextKey;
}



int Animation_nextKeyFoward(Animation *ani,Object *obj)
{
	Shape	*shape;
	int 	Akey;
	int 	nextKey;
	Uint32	deltaTime,leftTime;
	
	shape=ani->shape;
	if(shape==NULL)	ERROR("non shape !!");

	Akey=ani->which;

	//ANI_END
	if(ani->state!=ANI_PLAYING){
	// if animation == END then nextKey is the last key !!
	//	ani->nextKey=0;
		ani->nextKey=loaded_Ani[Akey].frame_n-1; // Ű ʱȭؾѴ.
		DEBUG("ddd2");
		return;  	
	}
	
	if(Akey < 0) { 
		ERROR("ddd3");
		return 0;
	}
	if(ani->nextKey< 0) ERROR("nextKey<0");
	
	deltaTime=loaded_Ani[Akey].DeltaTime;
	/*
	if(deltaTime<200 && ani->nextKey==0) 
	{
		nextKey=0;
		leftTime=200-ani->Time;
	} */

	// óŰ üŰ 
	// οִϸ̼ǽŽ 
	if(ani->nextKey==0 && ani->Time==0) {
		ani->testBit=1;
		test_time=1000;
		nextKey=0;
	}

	if( ani->testBit==1){
		test_time -=iDeltaTime; 
		if(test_time<0)
		{	ani->testBit=0;
			ani->Time=1;

		}
		leftTime=test_time; 
	}

	ani->testBit=0;
	//Ű ϱ 
	if( ani->testBit==0){
		ani->Time+=iDeltaTime;
		nextKey=ani->Time/(deltaTime);
		leftTime=deltaTime - (ani->Time%deltaTime); //  leftTime : Ű ð 
	}

	ani->leftTime=leftTime;
	ani->nextKey=nextKey;

	//ڵ Ѱ frameġ..
	if(nextKey >= loaded_Ani[Akey].frame_n -1)  
	{	
		// 0  ̹Ƿ frame_n -1 ̴ 
		ani->nextKey=loaded_Ani[Akey].frame_n-1; // Ű ʱȭؾѴ.
		ani->state=ANI_END; // ִϸ̼ ѹ ÷̳.
		ani->IE=1; // ͷƮ 
		if(ani->CallFunc!=NULL) // callbackԼ ȣ 
			ani->CallFunc(obj);
		ani->CallFunc=NULL; 
		return ani->nextKey;
	}
	return ani->nextKey;

}


int Object_nextKeyFoward2(Object *obj)
{
	Animation_nextKeyFoward(&obj->animation,obj);
}



//Shape_LoadANI2(Shape *model,char *filename)
int LoadANI(char *filename)
{
	int 		joint_n;
	int  		frame_n;
	int 		i,j,k,n,count;
	char 		buffer[256],dummy[128];
	FILE 		*fd;
	Joint 		*joints;
	Key		**frame;


	if(!(fd=fopen(get_pahtname(filename),"rb"))) ERROR("file open [%s]",filename);

	fscanf(fd,"%s %d",buffer,&frame_n);
	fscanf(fd,"%s %d",buffer,&joint_n);
	DEBUG(" frame_n=%d   joint_n=%d \n",frame_n,joint_n);

	frame= xmalloc(  sizeof(void *) * joint_n );
	for(j=0;j<joint_n;j++)
		frame[j]= xmalloc(  sizeof(Key) * frame_n );

///	printf(" size =%d \n",sizeof(Key) * frame_n *joint_n );
	
	loaded_Ani[loaded_Ani_n].frame_n=frame_n;
	loaded_Ani[loaded_Ani_n].joint_n=joint_n;
	loaded_Ani[loaded_Ani_n].frame=frame;
	

	for(j=0;j<joint_n;j++)
	{
		fscanf(fd,"%s %d",buffer,&count);
		DEBUG("%s %d",buffer,count);
		fscanf(fd,"%s ",buffer); // {
		for(i=0;i< count; i++)
		{
			fscanf(fd,"%d %f %f %f ",&n
					,&frame[j][i].translate[0]
					,&frame[j][i].translate[1]
					,&frame[j][i].translate[2]);
			fscanf(fd," %f %f %f ",  
					&frame[j][i].rotate[0],
					&frame[j][i].rotate[1],
					&frame[j][i].rotate[2]);
		
			DEBUG(" %d %f %f %f %f %f %f",n
					,frame[j][i].translate[0],frame[j][i].translate[1]
					,frame[j][i].translate[2],frame[j][i].rotate[0]
					,frame[j][i].rotate[1],frame[j][i].rotate[2]);

		//	frame[j][i]
		} 
		fscanf(fd,"%s",buffer); // }
		DEBUG("joint_n = %d ",j);
	}
	fclose(fd);
	loaded_Ani_n++;
	OKARG("[%s] ",filename);

	return loaded_Ani_n-1;
}


void Shape_LoadModel(Shape *shape,char *filename)
{

	FILE 		*fd;
	char 		buffer[64],buffer1[64],buffer2[64];
	int		i,j,k,n;
	
	
	shape->flag=TRIANGLE_FLAG_MODEL;

	if(shape==NULL) 
		shape=New_Shape();

	if(!(fd=fopen(get_pahtname(filename),"rb"))) ERROR("can't open [%s]",filename);


	if(OpenSession(fd,"Shape")==1)
	{
		int index;
		float t[3];
		n=getSessionValue();	
		fscanf(fd,"%d   %s %f %f %f",&index,buffer,&t[0],&t[1],&t[2]);
		Shape_LoadRAX(shape,buffer);
	
		shape->translate[0]=t[0];  // offset 
		shape->translate[1]=t[1];
		shape->translate[2]=t[2];
	//	printf("%d   %s %f %f %f\n",index,buffer,t[0],t[1],t[2]);
		CloseSession(fd);
	}else ERROR("cant find Shape Session!!");


	if(OpenSession(fd,"Ani")==1)
	{
		int index;
		int time;
		int animation_n;
		
		n=getSessionValue();
		shape->animation=xmalloc(sizeof(int)*n); //׳ staticҲ.
		
		for(i=0;i<n;i++)
		{
			fscanf(fd,"%d   %s %d",&index,buffer,&time);
			animation_n=LoadANI(buffer);
			shape->animation[i]=animation_n;

			loaded_Ani[animation_n].DeltaTime=time/loaded_Ani[animation_n].frame_n;
			
			shape->ani_n++;
		}
		
		shape->animationKey=shape->animation[0];
		CloseSession(fd);
		
	}else ERROR("cant find Ani Session!!");

	if(OpenSession(fd,"Anicorrectx")==1)
	{
		int joint_idx;
		Key **frame;
		int frame_n;
		float translate[3],rotate[3];
		n=getSessionValue();
		
		for(i=0;i<n;i++)
		{
			fscanf(fd,"%d   %f  %f  %f %f %f %f ",&joint_idx,
					&translate[0],&translate[1],&translate[2],
					&rotate[0],&rotate[1],&rotate[2]);
			
		}
			
		for(i=0;i<shape->ani_n;i++)
		{
			frame=loaded_Ani[shape->animation[i]].frame;
			frame_n=loaded_Ani[shape->animation[i]].frame_n;
			
			for(k=0;k<frame_n;k++)
			{
				frame[joint_idx][k].translate[0]+=translate[0]; 
				frame[joint_idx][k].translate[1]+=translate[1]; 
				frame[joint_idx][k].translate[2]+=translate[2]; 
				frame[joint_idx][k].rotate[0]+=rotate[0]; 
				frame[joint_idx][k].rotate[1]+=rotate[1]; 
				frame[joint_idx][k].rotate[2]+=rotate[2]; 
			}

		}
		
		CloseSession(fd);
	}



	if(OpenSession(fd,"event01")==1)
	{
	
	} // else ERROR("cant find event Session!!");

	fclose(fd);
	OKARG("[%s] ",filename);
}


/*
	for(j=0;j<frame_n;j++)
	{
		fscanf(fd,"%s %d",buffer,&n);
		// printf(" str=%s   n=%d \n",buffer,n);
		fscanf(fd,"%s ",buffer); // {
		for(i=0;i< joint_n ; i++)
		{
			fscanf(fd,"%d %f %f %f ",&n
					,&joints[i].frame[j].translate[0]
					,&joints[i].frame[j].translate[1]
					,&joints[i].frame[j].translate[2]);
		//	printf("%d %f %f %f ",n	,joints[i].frame[j].translate[0]
		//			,joints[i].frame[j].translate[1]
		//			,joints[i].frame[j].translate[2]);
//			printf(" i=%",i,n);
		//	printf(" i=%d   *joint=%x\n",i,&joints[i]);
			fscanf(fd," %f %f %f ",  
					&joints[i].frame[j].rotate[0],
					&joints[i].frame[j].rotate[1],
					&joints[i].frame[j].rotate[2]);
			
					fscanf(fd," %f %f %f ",  
					&joints[i].Orient[0],
					&joints[i].Orient[1],
					&joints[i].Orient[2]); 
		} 
		fscanf(fd,"%s",buffer); // }
	}


*/

int parsing_line(char *buffer)
{
	int length,i;
	/*	
		length=strlen(buffer);

		for(i=0;i<length;i++)
		{

		switch(buffer[i])
		{
		case '(':
		case ')':
		case '\"':
		buffer[i]=' ';
		break;
		case '/' :

		buffer[i]=0;

		length=strlen(buffer);
		if(length!=0) {
		buffer[i]='\n';
		buffer[i+1]=0;
		}
		break;

		default :
		break;

		}


		}

		length=strlen(buffer);
		if(length!=0)
		fputs(buffer,fd2);
		}
		*/

	
}



//const char string[] = "words separated by spaces -- and, punctuation!";
//const char delimiters[] = " .,;:!-";
//char *token, *cp;

FILE *parsing_fd;
char  record_name[64];
char  record_valueString[64];
int   record_valueInt;

char field_Sting[32][64];



void test_find(FILE *fd,char c)
{

	char ch;
	while(!feof(fd))
	{
		ch=fgetc(fd);
		if(ch==c) 
			return ;
	}
}	



char * getWordNoWrap(FILE *fd)
{
	char ch;
	int  i=0;

	while(!feof(parsing_fd))
	{
		ch=fgetc(fd);
		switch(ch)
		{
			case '\t':
			case ' ': 
			case ')':
			case '=':
			case '(':

				if(i>0){
					Word[i]=0;
					return Word;
				}

				break;
			case '/' :
			      //	fgets();
				break;

			case '\n':
				return 0;

			default :
			   Word[i++]=ch;
			 break;
			
		}

	
	}
	return Word;
}	



char * getWordBuffer(char *buf)
{
	char ch;
	int  i=0;

	while(buf[i])
	{
		ch=buf[i++];
		switch(ch)
		{
			case '\n':
			case '\t':
			case ' ': 
			case ')':
			case '=':
			case '(':

				if(i>0){
					Word[i]=0;
					return Word;
				}

				break;
			case '/' :
			      	//fgets();
				break;

			default :
			   Word[i++]=ch;
			 break;
			
		}

	
	}
	return Word;
}	


int getNextLineField()
{
		int count,i;
		fgets(buffer,sizeof(buffer),parsing_fd );
		for(i=0;i<count;i++)
		strcpy(&field_Sting[i][0],getWordNoWrap(parsing_fd));

		
		if(field_Sting[i][0]=='}') return 0;
		else return 1;

}


//  ° ??
int getNextRecordKey(FILE *fd)
{
	strcpy(record_name,getWrapWord(fd));
	strcpy(record_valueString,getWrapWord(fd));
	record_valueInt=atoi(record_valueString);

}


int parsing_Init(FILE *fd)
{
	parsing_fd=fd;

}


int parsing_stream(FILE *fd)
{
	
	int length,i;
	length=strlen(buffer);


//	cp = strdupa (string);                /* Make writable copy.  */
//	token = strtok (cp, delimiters);      /* token => "words" */
//	token = strtok (NULL, delimiters);    /* token => "separated" */
//	token = strtok (NULL, delimiters);    /* token => "by" */
//	token = strtok (NULL, delimiters);    /* token => "spaces" */
//	token = strtok (NULL, delimiters);    /* token => "and" */
//	token = strtok (NULL, delimiters);    /* token => "punctuation" */
//	token = strtok (NULL, delimiters);    /* token => NULL */

	for(i=0;i<length;i++)
	{

		switch(buffer[i])
		{
			case '(':
			case ')':
			case '\n':
			      buffer[i]=' ';
			break;
			case '/' :
							
			      	buffer[i]=0;

				length=strlen(buffer);
				if(length!=0) {
					buffer[i]='\n';
			      		buffer[i+1]=0;
				}
			break;

			default :
			 break;
			
		}
		
			
	}
		
	length=strlen(buffer);
//	if(length!=0)		fputs(buffer,fd2);
    




}

// ʾ° 
Object_LoadRawX(Object *obj,char *filename)
{
	int 	vertex_n,polygon_n,tex_coord_n,normal_n,object_n=0,material_n=0,
	    	joint_n;
	int 	child_joint_n;

    	int		tex_n;
    	int 	dummy_int,i,j,k,n,skeleton_n=0,node_n=0;

    	int	texture_id[32];
    	int 	int2[3],vertex_id[3];
    	float 	f,scale;
    	char 	buffer[256],dummy[128];
    	Vertex 	*vertex; 
    	Position2D 	texcoord[3];
   
    	FILE 		*fd;
    	Position2D 	*tex;
    	Face 		face;
    	Joint 		*joints;
	Shape	*shape;

    	shape=New_Shape();
	 
//? what is this    model->is_vertex_id=0;

    if(!(fd=fopen(filename,"r"))) error("Shape_Loadrawx: [%s]",filename);



    //Shape
    getWrapWord(fd);
    getWrapWord(fd);
    getWrapWord(fd); // {

    
    strcpy(buffer,getWrapWord(fd)); // vertex 
    vertex_n=atoi(getWrapWord(fd)); // value
    
    vertex = xmalloc( sizeof(Vertex) * vertex_n );

//    if(strcmp(Word,"vertex")) 
// printf("XXX:%s %s\n",record_name,record_valueString);


    printf("%s %d\n",buffer,vertex_n);
    
	getWrapWord(fd); // {

    	for(i=0;i< vertex_n ; i++){
	    fscanf(fd,"%d %f %f %f",&j,&vertex[i].x,&vertex[i].y,&vertex[i].z);
	  //Shape_add_vertex_dynamic(model,vertex);
    	}

    	getWrapWord(fd); // }

 
    	//UV_Map
   	strcpy(buffer,getWrapWord(fd)); 
    	tex_coord_n=atoi(getWrapWord(fd)); // value
	
	tex  = xmalloc(  sizeof(Position2D) * tex_coord_n  );

    	getWrapWord(fd); // {
	
	for(i=0;i< tex_coord_n ; i++){
	    fscanf(fd,"%d %f %f", &dummy_int ,&tex[i].x ,&tex[i].y); 
	}
    	getWrapWord(fd); // }
	
	
	//Texture
	fscanf(fd,"%s %d",buffer,&tex_n);
    	printf("%s %d \n",buffer,tex_n);

	fscanf(fd,"%s",buffer); // {
	for(i=0;i<tex_n;i++){
		
		fscanf(fd,"%s %s",dummy,buffer); // TEXTURE_FILE
    		printf("%s %s \n",dummy,buffer);

		texture_id[i]=LoadTextureFile(buffer); 
		
		//Faces 
		fscanf(fd,"%s %d",buffer,&dummy_int); 
    		//printf("%s %d \n",buffer,dummy_int);
		for(j=0;j<dummy_int;j++)
			fscanf(fd,"%d ",k); // Faces 

	}
	
	fscanf(fd,"%s",buffer); // }
	


    	free(vertex);
	free(tex);

	
	fclose(fd);
     	
	OKARG("[%s] ",filename);

    if(1) exit(0);

}


 

Plane   plane[32];
Plane 	AdjacentPlane[32]; //DEL
                                                                             
struct                                                                                            
{                                                                                                         
    	int texture_id;
	float uoff,voff;
	float uscale,vscale;
	Vector  nU,nV;
	float nu[3],nv[3];
	float uoffwidth;
	float voffheight;
	float widthuscale;
	float heightvscale;

} planetex[32];


int 	plane_n=0;
int     high_poly_n=0;



void roundVertex(Vector *v)
{	
	int i;
	float f,f2;

	if(v->x>0) 	
		f=v->x+0.5;
	else f=v->x-0.5;
	i=f;

	
//	f=i;
	v->x=i;
//	if(f2!=f)
//	DEBUG("v->x=%e	f=%f i=%d   f2=%f",v->x,f,i,f2 );
//	DEBUG("v->x=%f	f2=%f ",v->x,f2);


	if(v->y>0) 	
		f=v->y+0.5;
	else f=v->y-0.5;
	i=f;
	
	
	v->y=i;

	if(v->z>0) 	
		f=v->z+0.5;
	else f=v->z-0.5;
	i=f;
	v->z=i;
	
	
//	f2=rintf(v->x);
//	v->y=rintf(v->y);
//	v->z=rintf(v->z); 
}


//ߺȰ Ƴ 
int Polygon_checkVertex(Polygon *p,Vector *v)
{
	int i;

	for(i=0;i<p->vertex_n;i++)
	{
		if(0==v->x && 0==v->y &&   0==v->z )
		{
			DEBUG(" Vertex Zero Found");
		}

		if(p->vertex[i].x==v->x &&   p->vertex[i].y==v->y &&   p->vertex[i].z==v->z )
		{
		//	DEBUG("repeated value v=%f %f %f",v->x,v->y,v->z);
			return 0;
		}
			
	}

	return 1;
}

int Triangle_checkVertex(Triangle  *t,Vector *v)
{
	int i;

	for(i=0;i<3;i++)
	{
			
	}

	return 1;
}




//This will removed !!but  not yet 
//ߺǴ ֳ Ȯ 
int check2(Vector V[],int n)
{
	int i,j;
	float x,y,z;
	j=0;
	for(i=0;i<n;i++)
		
	{
		x=V[i].x;
		y=V[i].y;
		z=V[i].z;
		for(j=0;j<n;j++)
			
			if(V[j].x==x &&   V[j].y==y &&   V[j].z==z && i!=j )
			{
				DEBUGON();
				DEBUG("repeated valueXXXXXXXXXx  i=%d j=%d v=%f %f %f",i,j,x,y,z);
				exit(0);
				return 0;
			}
			
	}

	return 1;
}

void DEBUG_POLYGON(Polygon *p)
{
	int k;
	
	DEBUG(" ======================================");
//	DEBUG(" plane_n!= %d" ,plane_n);
	for(k=0;k<p->vertex_n;k++)
		DEBUG(" v=%f %f %f" ,p->vertex[k].x,p->vertex[k].y,p->vertex[k].z);
	DEBUG(" ======================================");

}


void DEBUGX(Vertex V[],int vertex_n)
{
	int k;
	
	DEBUG(" ======================================");
	DEBUG(" plane_n!= %d" ,plane_n);
	for(k=0;k<vertex_n;k++)
		DEBUG(" v=%f %f %f" ,V[k].x,V[k].y,V[k].z);
	DEBUG(" ======================================");

}


void test()
{
	Polygon p;

	p.vertex[0].x=-1380; p.vertex[0].y=633; p.vertex[0].z=2816;
	p.vertex[1].x=-1378;p.vertex[1].y=633; p.vertex[1].z=2816;
	p.vertex[2].x=-1368;p.vertex[2].y=633; p.vertex[2].z=2816;
	p.vertex[3].x=-32; p.vertex[3].y=633; p.vertex[3].z=1408;
	
//	if(ThreeVertexIsLine(&p.vertex[0],&p.vertex[1],&p.vertex[2])==1)
//		DEBUG("line !!");
//	else DEBUG("not");
	p.vertex_n=3;
//	PolygonSortVertex(&p);

	
	exit(0);
}

void PolygonCheckVertex(Polygon *p)
{
	

}

	
//  쵵 Ҵ return = 0 
//
// not yet proved !!
int  PolygonSortVertex(Polygon *p)
{
	int j,k,vertex_n;
	Vector V1,V2,V3,Center;
	
	int flag;
	int small;
	float smallest,angle;
	vertex_n=p->vertex_n;
	
	
	// Does This need ?	
	if(PolygonCheckIsLine(p)){
	//	DEBUG(" p -> is a line !!!");			
		return 0;
	}

//	PolygonCheckVertex(p);  鿡 ִ ˻ ->  

	VectorSetZero(&Center);
	for(j=0;j<vertex_n;j++)
		VectorAdd(&Center,&p->vertex[j]);
	VectorScale(&Center,(float)1/(float)vertex_n); //OK


	angle=0;

	for(j=0;j<vertex_n-2;j++) //
	{
		VectorSetVector(&V1,&p->vertex[j]);
		VectorSubtract(&V1,&Center);
		if(VectorNormalize(&V1)==0) {
			DEBUG(" Center= %f %f %f" ,Center.x,Center.y,Center.z);
			DEBUG(" V1 %f %f %f" ,V1.x,V1.y,V1.z);
			DEBUG(" V2 %f %f %f" ,V2.x,V2.y,V2.z);
			DEBUG_POLYGON(p);
			ERROR(" Normal lise ~~");
		}

		smallest=-2;
		small=-1;
		
		flag=0;
		angle=0;
		for(k=j+1;k<vertex_n;k++)
		{
			
			VectorSetVector(&V2,&p->vertex[k]);
			VectorSubtract(&V2,&Center);
			if(VectorNormalize(&V2)==0) {
				DEBUG(" Center= %f %f %f" ,Center.x,Center.y,Center.z);
				DEBUG(" V1 %f %f %f" ,V1.x,V1.y,V1.z);
				DEBUG(" V2 %f %f %f" ,V2.x,V2.y,V2.z);
				DEBUG_POLYGON(p);
				ERROR("???");
			}


			VectorCrossProduct(&V3,&V1,&V2);
			if(VectorDotProduct(&p->Normal,&V3)>0){
				
				angle=VectorDotProduct(&V1,&V2);
				
/*			this make error polygon ? why ? 
 *			->  because Long Long  rectanglular like line 
 *			    their angle  are almost -0.99999999 
 *				if(angle < -0.999){
					DEBUG(" WARNNING!! angle(%f) too low may be Line !!" ,angle);
					return 0;
			}
*/
				// does this  need ?  need!!
				if(angle==smallest ){
					DEBUG(" WARNNING!! angle==smallest , %f %f" ,angle,smallest);
					DEBUG(" Center= %f %f %f" ,Center.x,Center.y,Center.z);
					DEBUG(" V1 %f %f %f" ,V1.x,V1.y,V1.z);
					DEBUG(" V2 %f %f %f" ,V2.x,V2.y,V2.z);
					DEBUG_POLYGON(p);
					//return 0;
					exit(0);
				}
				
		
				flag=1;

				if(angle>smallest)
				{
					small=k;
					smallest=angle;
				}
				
			}


		}	
				
		//Robust Code
		//
/*		if(smallest < -0.9999){
			DEBUG(" smallest < -0.9999 !!  vertex_n=%d small=%d smallest=%g angle=%g",vertex_n,small,smallest,angle);
			DEBUG(" k=%d j=%d flag=%d",k,j,flag);
			DEBUG(" Center= %f %f %f" ,Center.x,Center.y,Center.z);
			DEBUG(" V1 %f %f %f" ,V1.x,V1.y,V1.z);
			DEBUG(" V2 %f %f %f" ,V2.x,V2.y,V2.z);
			DEBUG_POLYGON(p);
			
			return 0;
		} */
		
		if(small<1|| small>=vertex_n ){
			//
			// ٻ vertex ϰǴ 1 ϰ ̰ ɸ
			// ص 
			// 0.9999  are often angle 
			DEBUG(" SMALL<1 : vertex_n=%d small=%d smallest=%f angle=%f",vertex_n,small,smallest,angle);
			DEBUG(" k=%d j=%d flag=%d",k,j,flag);
			DEBUG(" Center= %f %f %f" ,Center.x,Center.y,Center.z);
			DEBUG(" V1 %f %f %f" ,V1.x,V1.y,V1.z);
			DEBUG(" V2 %f %f %f" ,V2.x,V2.y,V2.z);
			DEBUG_POLYGON(p);
			
			return 0;
		}
		else 
			VectorSwap(&p->vertex[j+1],&p->vertex[small]);
	}

	return 1;
}
	
// v11
// ⼭  Polygon Ǳ⶧ ϴ polygon ̰ óؾ 
// ƴϸ ϼ ʿ  polygon ãƳ...
int getPolygon2(Polygon *p,int i)
{

	int j,k,m,n,r,t=0;
	int legal;	
	float length,f;
	Vertex *nV;
	Vector V1,V2;
	float  nv[3],v1[3],v2[3];
	float nearest;

	float u,v;
	VectorSetVector(&p->Normal,&plane[i].normal);
	p->normal[0]=plane[i].normal.x;
	p->normal[1]=plane[i].normal.y;
	p->normal[2]=plane[i].normal.z;

	//  n ̷ Ʈ(귯)   ϱ 
	// 6 -> 8  (Ϲ)
	// 5ü -> 6  
	// ü -> 4 (ּ)
	for(j=0;j<plane_n-1;j++)  // plane_n -1 Right !! think !!
	{
		for(k=0;k<plane_n;k++)
		{
			if(i==j || i==k || j==k) continue;
			r=VectorIntersction3Plane(&V1,&plane[i],&plane[j],&plane[k]);
			//ϴ  
			if(r==0) continue;			

			legal=true;
	
			for(m=0;m<plane_n;m++){
				f=VectorDotProduct(&V1,&plane[m].normal);
				f-=plane[m].distance;
				if(f>EPSILON_MAP)  //if(f>0)
					legal=false;
			}
	
			if(legal)
			{
				//VectorScale(&V1,FactorMap);
				Polygon_AddVertex(p,&V1);
			}
			
		}
	}

	//ߺǴ ֳ Ȯ 
	check2(p->vertex,p->vertex_n);

	if(p->vertex_n >11 || p->vertex_n <3){
		DEBUGON();	
		DEBUG("  11< vertex_n <3  =  %d",p->vertex_n);
		DEBUGX(p->vertex,p->vertex_n);
		DEBUGOFF();	
	//	return 0;
		exit(0);
	}

	if(p->vertex_n >= plane_n ){
		DEBUGON();	
		// ̰ ߸ȰžƳ  5ü  6 ٺ 
		//if(plane_n==5 && p->vertex_n==4) { 	}else	
		DEBUG("WARNNING !! plane_n=%d   vertex_n=%d",plane_n,p->vertex_n);
		DEBUGX(p->vertex,p->vertex_n);
		exit(0);
		return 0;
	}

	if(PolygonSortVertex(p)==0) {
		ERROR(" Why ?");
		return 0;
	}
	
	//  PolygonSortVertex   ٲ ʵǳ ? -> 
	for(j=0;j<p->vertex_n;j++)
	{
		float u,v;
		v2[0]=p->vertex[j].x;
		v2[1]=p->vertex[j].y;
		v2[2]=p->vertex[j].z;

//		VectorSubtract(&V2,&V1);  // ̷ ֵǳ ?????
		//  uv v ȭ ߵǳ ? GLΰ ? -> ִ.
	//	v=VectorDotProduct(&V2,&planetex[i].nV)/planetex[i].heightvscale + planetex[i].voffheight;

		u=vectorDotProduct(v2,planetex[i].nu)/planetex[i].widthuscale + planetex[i].uoff;
		v=-vectorDotProduct(v2,planetex[i].nv)/planetex[i].heightvscale - planetex[i].voff;
		//DEBUG("u=%f",nV->u);DEBUG("v=%f",nV->v);
//		Polygon_AddVertex(p,nV);
		p->vertex[j].u=u;
		p->vertex[j].v=v;
	}



	if(planetex[i].texture_id==0) return 0;

	p->texture_id=planetex[i].texture_id;
	

	return 1;
}

	
getBrushLine(FILE *fd)
{
	float uoff,voff;
	float uscale,vscale;
	float width,height;
	int texture_id,index;
	float normal[3];
    	float v1[3],v2[3],v3[3],f;
	float nu[3],nv[3];	
	Vector V1,V2,V3,Normal;
	Vector nU,nV;

	float factor=1;
/* 
  ( -1184 1424 64 ) ( -1376 1424 64 ) ( -1376 1424 224 )
  SANDWLLDOOR [ 1 0 0 32 ] [ 0 0 -1 64 ]  0 			1 		1
		 tex_U		tex_V	   tex_rotation		U_scale		V_scale

	 [ 0 1 0 -284 ] [ 0 0 -1 423 ] 0 	1.13	 0.72
*/
	// x => x , z => y , y => -z 
	v1[0]=atof(Word);
	v1[2]=-atof(getWrapWord(fd));
	v1[1]=atof(getWrapWord(fd));

	v2[0]=atof(getWrapWord(fd));
	v2[2]=-atof(getWrapWord(fd));
	v2[1]=atof(getWrapWord(fd));

	v3[0]=atof(getWrapWord(fd));
	v3[2]=-atof(getWrapWord(fd));
	v3[1]=atof(getWrapWord(fd));

//	map size !! 
/*	v1[0]*=FactorMap;v1[1]*=FactorMap;v1[2]*=FactorMap;
	v2[0]*=FactorMap;v2[1]*=FactorMap;v2[2]*=FactorMap;
	v3[0]*=FactorMap;v3[1]*=FactorMap;v3[2]*=FactorMap;
	V1.x=v2[0]-v1[0];V1.y=v2[1]-v1[1];V1.z=v2[2]-v1[2];
	V2.x=v3[0]-v1[0];V2.y=v3[1]-v1[1];V2.z=v3[2]-v1[2];
*/			
	//CW -> CCW
	vectors2normal(v1,v2,v3,normal);
	vector2Vector(&Normal,normal);
	vector2Vector(&V1,v1);

	PlaneSetNormalVertex(&plane[plane_n],&Normal,&V1);
	

	//texture name
	getWrapWord(fd);
	
	//if(strcasecmp(Word,"sky")==0 || strcasecmp(Word,"aaatrigger")==0 ||
	//
	
	if( strcasecmp2(Word,"aaatrigger")==0 || strcasecmp2(Word,"clip")==0 ||
		strcasecmp2(Word,"generic011")==0 || strcasecmp2(Word,"+0~fifties_lgt2")==0)
	{
		planetex[plane_n].texture_id=0;
		width=64;
		height=64;
	}
	else {

		texture_id=LoadTextureFile(Word);
		planetex[plane_n].texture_id=texture_id;
		index=Texture_getIndex(texture_id);
		width=(float)loadedtexture[index].width;
		height=(float)loadedtexture[index].height;
	}


//	[ 1 0 0 32 ] 	 
//	first 3 are texture axis' normal 
//	last  1 is offset or shift 
	nu[0]=atof(getWrapWord(fd));
	nu[2]=-atof(getWrapWord(fd));
	nu[1]=atof(getWrapWord(fd));
	uoff=atof(getWrapWord(fd));


//	[ 0 0 -1 64 ] 
	nv[0]=atof(getWrapWord(fd));
	nv[2]=-atof(getWrapWord(fd));
	nv[1]=atof(getWrapWord(fd));
	voff=atof(getWrapWord(fd));



	v1[0]=atof(getWrapWord(fd));  // obsolete reading
	uscale=atof(getWrapWord(fd))*FactorMap;
	vscale=atof(getWrapWord(fd))*FactorMap;


	vectorCopy(planetex[plane_n].nu,nu);
	vectorCopy(planetex[plane_n].nv,nv);


	planetex[plane_n].widthuscale=width*uscale;
	planetex[plane_n].heightvscale=height*vscale;
	planetex[plane_n].uoff=uoff/(width); 
	// normalize to 1(maximum)  eg)  width=255,uoff=128
	planetex[plane_n].voff=voff/(height);

}


struct {
	int deathmatch_n;
} info_map;

struct {
	float angles[3];
	float origin[3];
} info_player_deathmatch[64];

struct {
	float player_origin[3];
	float enemy_origin[3];
} info_holocaust;




// temp name 
void player_restart(Object *obj)
{
	int idx;

	if(info_map.deathmatch_n==0) ERROR("xxxxx");
	idx=rand()%info_map.deathmatch_n;

	obj->center[0]=info_player_deathmatch[idx].origin[0];
	obj->center[1]=info_player_deathmatch[idx].origin[1];
	obj->center[2]=info_player_deathmatch[idx].origin[2];
	
	obj->life_power=100;
	obj->falling_speed=0;
	obj->bullet_n=300;


	if(obj==player) Camera=player;

}

void Player_Restart(Object *obj)
{
	int idx;

	
	/*
	if(info_map.deathmatch_n==0) ERROR("xxxxx");
	idx=rand()%info_map.deathmatch_n;

	obj->center[0]=info_player_deathmatch[idx].origin[0];
	obj->center[1]=info_player_deathmatch[idx].origin[1];
	obj->center[2]=info_player_deathmatch[idx].origin[2];
	
	obj->life_power=100;
	obj->falling_speed=0;
	obj->bullet_n=300;
	*/
	
	if(obj==player) 
	//if(!strcmp(obj->name,"player")) 
	{
		obj->center[0]=info_holocaust.player_origin[0];
		obj->center[1]=info_holocaust.player_origin[1];
		obj->center[2]=info_holocaust.player_origin[2];
	}
	else{
		obj->center[0]=info_holocaust.enemy_origin[0];
		obj->center[1]=info_holocaust.enemy_origin[1];
		obj->center[2]=info_holocaust.enemy_origin[2];
	}
	//if(obj==player) Camera=player;
	obj->falling_speed=0;
	obj->bullet_n=300;
	obj->life_power=100;


}



void init_info_map()
{
	info_map.deathmatch_n=0;
}

int MAP_scanf(FILE *fd,char *name,char *fmt,...)
{
		
	va_list arg_ptr;                                                                              
	long int fpos;

	fpos= ftell (fd);
	va_start(arg_ptr, fmt); 

	while(!feof(fd))
	{
		getWrapWord(fd);
		if(!strcmp(Word,name))
		{
			getWrapWord(fd);
			vsscanf3(Word,fmt,arg_ptr);
//			sscanf(Word,fmt,arg_ptr);

			va_end(arg_ptr);
			return 1;
		}
		if(Word[0]=='}')
		{
			if(fseek(fd,fpos,SEEK_SET)!=0) DEBUGB("error fseek2");
			break;
		}
	}

	DEBUGB("cant find %s !",name);
	return 0;
}


// ڵ Ǽ   غ 
int  MAP_message(FILE *fd,char *message)
{
//	if(MAP_scanf(fd,"message","%s",message)==0) 
//		message=NULL;  // ްԵ ּҸ ִ  null̶ ־ȴ.

	return MAP_scanf(fd,"message","%s",message);
}

int  MAP_GET_targetname(FILE *fd,char *str)
{
	return MAP_scanf(fd,"targetname","%s",str);
}



void MAP_angles1(FILE *fd,float angles[3])
{
	getWrapWord(fd);
	if(!strcmp(Word,"angles"))
	{
		
		getWrapWord(fd);
//		printf("angles= %s \n",Word);	
		sscanf(Word,"%f %f %f",&angles[0],&angles[1],&angles[2]);
//		ERROR("for test");
	}
	else ERROR("not angle!!");

}


void MAP_angles(FILE *fd,float angles[3])
{
	MAP_scanf(fd,"angles","%f %f %f",&angles[0],&angles[1],&angles[2]);
}

void MAP_pitch(FILE *fd,float *angles)
{
	getWrapWord(fd);
	if(!strcmp(Word,"pitch"))
	{
		getWrapWord(fd);
//		printf("angles= %s \n",Word);	
		sscanf(Word,"%f ",angles);
//		ERROR("for test");
	}
	else ERROR("not angle!!");
}



void MAP_origin(FILE *fd,float value[3])
{
	int ret;
	ret=MAP_scanf(fd,"origin","%f %f %f",&value[0],&value[2],&value[1]);
	value[2]=-value[2];
	if(ret==0){
		value[0]=0;
		value[1]=0;
		value[2]=0;
	}
}

int MAP_info_player_deathmatch(FILE *fd)
{
	int n;

	n=info_map.deathmatch_n;

	MAP_angles(fd,info_player_deathmatch[n].angles);
	MAP_origin(fd,info_player_deathmatch[n].origin);
	info_map.deathmatch_n++;
}


int MAP_ambient_generic(FILE *fd)
{
	int n;
	int sound_id;
	char buffer[128];
	char name[128];
	char *filename;
	Object *obj;

	obj=New_Object("sound");

	MAP_scanf(fd,"targetname","%s",name); // "targetname" is Object name


	if(MAP_message(fd,buffer))// "message" is  wave filename 
	{
		filename=basename(buffer);
		sound_id=LoadWave2(filename);
		Object_soundPlayLoop(obj,sound_id);
	}

	MAP_origin(fd,obj->center);
	
	Object_InsertList(obj); 
}


int MAP_light(FILE *fd)
{
	int n;
	char name[128];
	float v[4];
	Object *obj;

	obj=New_Object("light");
	obj->effective_radius=5*METER;

	MAP_scanf(fd,"_light","%f %f %f %f",&v[0],&v[1],&v[2],&v[3]);
	MAP_origin(fd,obj->center);

	Object_InsertList(obj); 
}

int MAP_info_null(FILE *fd)
{
	int n;
	char name[128];
	float v[4];

	if(MAP_GET_targetname(fd,name))
	{
		if(!strcmp(name,"player"))
			MAP_origin(fd,info_holocaust.player_origin);
		else MAP_origin(fd,info_holocaust.enemy_origin);
	}

}


int MAP_light_environment(FILE *fd)
{
	int n;
	char name[128];
	float v[4];
	float angles[3];
	float pitch;
	
	Object *obj;

	obj=New_Object("light_environment");
	obj->effective_radius=METER*400;

	MAP_scanf(fd,"_light","%f %f %f %f",&v[0],&v[1],&v[2],&v[3]);
	MAP_pitch(fd,&pitch);
	MAP_angles(fd,angles);
	MAP_origin(fd,obj->center);

	Object_InsertList(obj); 
}



//  귯 ϴ  ...
// brush κ polygon ̾Ƴ.
Shape *map_shape;
int MAP_brush(FILE *fd)
{
	int brush_ok=0;
	int brush_n=0;
	int poly_n=0;
	int total_plane_n=0;
	int i;
	Polygon  *poly;


	brush_ok=0;
	plane_n=0;
	while(!feof(fd))
	{
		getWrapWord(fd);
		//printf("ddd=%s\n",Word);
		//end of brush
		if(Word[0]=='}'){ 
			brush_ok=1; 
			brush_n++;
			if(plane_n<4 || plane_n >10){
				//DEBUG("this  plane_n=%d \n",plane_n);
				ERROR("this  plane_n=%d \n",plane_n);
			}

			//ü
			if(plane_n==4 ){
				DEBUG("this  plane_n=%d \n",plane_n);
			}

			for(i=0;i<plane_n;i++)
			{
				poly=New_Polygon();
				//getPolygon
				if(getPolygon2(poly,i)){
					Shape_AddPolygon(map_shape,poly);
					//߿ octreeϸ鼭 ̹Ƿ 
					// ׳
					//n=Polygon2Triangle(poly,tri);  //fix -> ok
					//for(j=0;j<n;j++)   Shape_AddTriangleStatic(shape,&tri[j]);
				}
				Polygon_Remove(poly);
			}
			break; 
		}

		getBrushLine(fd);
		plane_n++;
		total_plane_n++;
	}

	return brush_n;
}


int check_map(char *filename)
{
	char buffer[64];
	strcpy(buffer,filename);
}

// :
// cell->shape ׳ Ѵ 
// ߿ ˸° εѴ.
//
new_compiled_octree(char *filename)
// octree_top
/// void MakeOctreeMap(Shape *m)
//  cell idο  ?
//new_compiled_octree(Cell *cell )
{
	char name[64];
	FILE *fd;

	strcpy(name,filename);
	remove_ext(name);
	strcat(name,".bin");
	
	if(!(fd=fopen(name,"wb"))) 
		ERROR(" can't %s file open !! ",filename);

		

	fclose(fd);
}


// Hammer MAP file loader 
// new ver 0.8  
// dirty,idiot code !! 
load_MAP_file(Object *obj,char *filename)
{
    	int i,j,k,n;

	char buffer[256],dummy[128];

	FILE *fd,*fd2;
	Triangle tri[16];
	
	int map_ok=0;
	int brush_ok=0;
	int entity_ok=0;

	int entity_n=0;
	int brush_n=0;
	int total_brush_n;
	int poly_n=0;
	int total_plane_n=0;

	init_info_map();
	
	map_shape=New_Shape();
	Shape_InsertToObject(map_shape,obj);
	Shape_SetName(map_shape,"map_name");

	// ??
	total_brush_n=check_map(filename);
	
	
	
	// *****  "rb" for WindowsX !!!
	//if(!(fd=fopen(get_pahtname(filename),"rb")))  // ʵ ??
	if(!(fd=fopen(filename,"rb"))) 
		ERROR(" can't %s file open !! ",filename);

	entity_ok=1;
	while(!feof(fd)){

		getWrapWord(fd);
		//New entity !!
		if(Word[0]=='{' && entity_ok==1)
		{
			entity_ok=0;
			//	brush_ok=1;
			Word[0]='?';

		}

		// brush end .
		//end of entity
		if(Word[0]=='}' && entity_ok==0) 
		{	
			entity_ok=1;		
			entity_n++;
		}

		// new  brush !!  귯ϰ쿡 
		if(Word[0]=='{' && entity_ok==0)
		{
			MAP_brush(fd);
			brush_ok=0;
		}


		//    	printf("new Entity\n");
		if(!strcmp(Word,"classname"))
		{
			getWrapWord(fd);
			//printf("record_name=%s   key=%s",Word,getWrapWord(fd));
			//OKARG("record_name=   key=%s",Word);
			if(!strcmp(Word,"worldspawn"))
			{

			}else 
			if(!strcmp(Word,"info_player_deathmatch"))
			{
				MAP_info_player_deathmatch(fd);
			}else 
			if(!strcmp(Word,"ambient_generic"))
			{
				MAP_ambient_generic(fd);
			}else 
			if(!strcmp(Word,"light"))
			{
				MAP_light(fd);
			}else 
			if(!strcmp(Word,"info_null"))
			{
				MAP_info_null(fd);
			}else 
			{
				
			}
		}
		if(!strcmp(Word,"origin"))
		{
			// getWrapWord(fd);
		}
	}

	if(entity_ok!=1) 
	{
		ERROR("entity error ");
		//	ERROR("entity %s error ",
	}
	//getNextRecordKey(fd);
	//printf("XXX:%s %s\n",record_name,record_valueString);
	fclose(fd);
	DEBUG("MAP: face_n=%d \n",map_shape->triangle_n);
	DEBUG("MAP: total_plane_n=%d",total_plane_n);    
	OK();
}



int getPolygon(Polygon *p,int i)
{

	int j,k;
//	int poly_n;
	Vector V1;
	int high_product_id;
	
	float high_product,product;
	float length;
	int next,start;
	Vertex *V;
	Line  line;
	
	VectorSetVector(&p->Normal,&plane[i].normal);

	high_product=-99;
	for(k=0;k<plane_n;k++)
	{
		
		product=VectorDotProduct(&plane[i].normal,&plane[k].normal);
		
		if(product>high_product && i!=k)
		{	
			high_product_id=k;
			high_product=product;
		}
			
	}

	next=high_product_id;
	start=next;
	
	for(;;)
	{
		
		Intersection_PlanePlane(&line,&plane[i],&plane[next]);

		high_product=-99;
		for(k=0;k<plane_n;k++)
		{
			
			if(next==k || k==i) continue;
			VectorIntersectionLinePlane(&V1,&line,&plane[k]);
			if(product>high_product && next!=k &&
			(VectorDotProduct(&V1,&plane[k].normal)>0))
//			&&(VectorDotProduct(&plane[i].normal,&AdjacentPlane[k].normal)>=0))
			{	
				high_product_id=k;
				high_product=product;
			}
			
		}
		
		V=New_Vertex();
		VectorIntersction3Plane(V,&plane[i],&plane[next],&plane[high_product_id]);

		Polygon_AddVertex(p,V);
		
		next=high_product_id;

		if(next==start) break;
	}	





}

	
int getPolygon5(Polygon *p,int i)
{

	int j,k;
//	int poly_n;
	Vector V1,V2;
	int high_product_id;
	
	float high_product,product;
	float length;
	int next,start;
	Vertex *V;

	VectorSetVector(&p->Normal,&plane[i].normal);

	high_product=-99;
	for(k=0;k<plane_n;k++)
	{
		
		product=VectorDotProduct(&plane[i].normal,&plane[k].normal);
		
		if(product>=high_product && i!=k)
		{	
			DEBUG("product=%f",product);		
			high_product_id=k;
			high_product=product;
		}
			
	}

	next=high_product_id;
	start=next;
	
//	while(1) 	// 
	DEBUG("next =%d",next);		
	for(j=0;j<plane_n-2;j++)
	{
			
		VectorCrossProduct(&V1,&plane[i].normal,&plane[next].normal);
		VectorSetVector(&V2,&V1);
		VectorAdd(&V2,&plane[i].normal);
		VectorAdd(&V2,&plane[next].normal);
		VectorNormalize(&V2);

//		DEBUG("V2=%f",VectorLength(&V2));	
		high_product=-99;
		for(k=0;k<plane_n;k++)
		{
			
			if(next==k || k==i) continue;
			product=VectorDotProduct(&V2,&plane[k].normal);
			if(product>high_product)// &&
//			(VectorDotProduct(&V1,&plane[k].normal)>0))
	//		&&(VectorDotProduct(&plane[i].normal,&plane[k].normal)>=0))
			{	
				high_product_id=k;
//			DEBUG("product=%f",product);		
				high_product=product;
			}
			
		}
		
		
		DEBUG("high_product_id =%d",high_product_id);		
		if(high_product==-99) DEBUG("999999999999");
		V=New_Vertex();
		VectorIntersction3Plane(V,&plane[i],&plane[next],&plane[high_product_id]);

		Polygon_AddVertex(p,V);
		
		next=high_product_id;

		if(j==plane_n) {}

		if(next==start){
			if(p->vertex_n<3) 
				DEBUG("Warnning!!!  poly->vertex_n=%d",p->vertex_n );		
			break;
		}
	}	


	
	



}


Shape_LoadRAX_OLD(Shape *model,char *filename)
{
    	int 	vertex_n,polygon_n,tex_coord_n,normal_n,object_n=0,material_n=0,
	    	joint_n;
	int 	child_joint_n;

    	int		tex_n;
    int 	dummy_int,i,j,k,n,skeleton_n=0,node_n=0;

    int		texture_id[32];
    int 	int2[3],vertex_id[3];
    float 	f,scale;
    char 	buffer[256],dummy[128];
    Vertex 	*vertex; 
    Position2D 	texcoord[3];
   
    FILE 	*fd;
    Position2D 	*tex;
    Face 	face;
    Joint 	*joints;
	 
//Modified    model->is_vertex_id=0;
    if(!(fd=fopen(filename,"r"))) error("Shape_LoadRAX: [%s]",filename);


    fgets2(buffer,sizeof(buffer),fd); // HEADER_TITLE
    fgets2(buffer,sizeof(buffer),fd); // VERSION
//    fscanf(fd,"%s %s",buffer,dummy);  
 

    //Shape 
    fscanf(fd,"%s %s",buffer,dummy);
    printf("%s %s \n",buffer,dummy);
    fscanf(fd,"%s",buffer); // {


    fscanf(fd,"%s %d",buffer,&vertex_n);
    printf("%s %d\n",buffer,vertex_n);

    fscanf(fd,"%s",buffer); // {
    vertex = xmalloc( sizeof(Vertex) * vertex_n );

    for(i=0;i< vertex_n ; i++){
	    fscanf(fd,"%d %f %f %f",&j,&vertex[i].x,&vertex[i].y,&vertex[i].z);
	  //Shape_add_vertex_dynamic(model,vertex);
    }

    	fscanf(fd,"%s",buffer); // }
 

    	//UV_Map
    	fscanf(fd,"%s %d",buffer,&tex_coord_n);
	tex  = xmalloc(  sizeof(Position2D) * tex_coord_n  );
	fscanf(fd,"%s",buffer); // {
	
	for(i=0;i< tex_coord_n ; i++){
	    fscanf(fd,"%d %f %f", &dummy_int ,&tex[i].x ,&tex[i].y); 
	}

	fscanf(fd,"%s",buffer); // }


	//Texture
	fscanf(fd,"%s %d",buffer,&tex_n);
    	printf("%s %d \n",buffer,tex_n);

	fscanf(fd,"%s",buffer); // {
	for(i=0;i<tex_n;i++){
		
		fscanf(fd,"%s %s",dummy,buffer); // TEXTURE_FILE
    		printf("%s %s \n",dummy,buffer);

		texture_id[i]=LoadTextureFile(buffer); 
		
		//Faces 
		fscanf(fd,"%s %d",buffer,&dummy_int); 
    		//printf("%s %d \n",buffer,dummy_int);
		for(j=0;j<dummy_int;j++)
			fscanf(fd,"%d ",k); // Faces 

	}

	fscanf(fd,"%s",buffer); // }


    	//Face
    	fscanf(fd,"%s %d",buffer,&polygon_n);
    	printf("%s %d \n",buffer,polygon_n);

	fscanf(fd,"%s",buffer); // {
   	for(i=0;i< polygon_n ; i++)
    	{
        	fscanf(fd,"%d  %d %d %d ",&j,&vertex_id[0],&vertex_id[1],&vertex_id[2]);
//	    	printf("%d v %d %d %d t %d %d %d\n",j,vertex_id[0],vertex_id[1],vertex_id[2],int2[0],int2[1],int2[2]); 

//        	fscanf(fd,"%c",&c);
//		if(c=='t') 
        	fscanf(fd,"%d %d %d ",	&int2[0],&int2[1],&int2[2]); 
//		else  fscanf(fd,"%d %d %d ",&int2[0],&int2[1],&int2[2]); 

		
	    for(j=0;j<3;j++) 
		face.vertex_id[j]=vertex_id[j];
	    
	    for(j=0;j<3;j++){ 
		face.vertex[j].x=vertex[vertex_id[j]].x;
		face.vertex[j].y=vertex[vertex_id[j]].y;
		face.vertex[j].z=vertex[vertex_id[j]].z;
	    }

	    for(j=0;j<3;j++) {
		face.TexCoord[j].x=tex[int2[j]].x;
	        face.TexCoord[j].y=tex[int2[j]].y;    
	    }

	    face.texture_name=texture_id[0]; //??
	    make_triangle_norm(&face);
//	    Shape_add_triangle_dynamic( model, &face);
	    Shape_AddTriangleStatic( model, &face);
    	}

	fscanf(fd,"%s",buffer); // }

	//Joints
    	fscanf(fd,"%s %d",buffer,&joint_n);
    	printf("%s %d \n",buffer,joint_n);
	fscanf(fd,"%s",buffer); // {
			
		joints = xmalloc(  sizeof(Joint) * joint_n  );
		model->joint_n=joint_n;
		model->joint=joints;
	/*
		for(i=0;i< joint_n ; i++){
	    		fscanf(fd,"%s ", &joints[i].name );
	    		fscanf(fd," %f %f %f "
					,&joints[i].Translate[0]
					,&joints[i].Translate[1]
					,&joints[i].Translate[2]); 
	    		fscanf(fd," %f %f %f ",  
					&joints[i].Rotate[0],
					&joints[i].Rotate[1],
					&joints[i].Rotate[2]);
	    		fscanf(fd," %f %f %f ",  
					&joints[i].Orient[0],
					&joints[i].Orient[1],
					&joints[i].Orient[2]);
		}
*/
	fscanf(fd,"%s",buffer); // }

    	//JointHierarchy
    	fscanf(fd,"%s ",buffer);
    	printf("%s \n",buffer);
	fscanf(fd,"%s",buffer); // {
			

		for(i=0;i< joint_n ; i++){
    			fscanf(fd,"%s %d",buffer,&child_joint_n);
//    			printf("%s %d \n",buffer,child_joint_n);
			joints[i].child_n=child_joint_n;

			for(j=0;j<child_joint_n;j++)
			{
				fscanf(fd,"%s ",buffer);
				for(k=0; k<joint_n;k++)
					if(!strcmp(joints[k].name,buffer)) break;
				
				joints[i].child[j]=&joints[k];
//				joint[i].child_id[j]=k;
			}
					

		}




	fscanf(fd,"%s",buffer); // }

	free(vertex);
	free(tex);
	
	fclose(fd);
	OKARG("[%s] ",filename);
}


void Shape_SaveC(Shape *m,char *filename)
{

    int vertex_n,triangle_n,dummy;
    Vertex *vertex;
    Triangle *tri;
    
    
    float v1[3],v2[3];
    char buffer[256];
    
    int i,j,n,id;
    FILE *fd;
    
    dummy=0;
    vertex_n=m->vertex_n;
    vertex=m->vertex;
   
    tri=m->triangle;
    
    triangle_n=m->triangle_n;
    
    
    if(!(fd=fopen(filename,"wb"))) ERROR("save_off:file save ");

    fprintf(fd,"// gl print by hyun  init version.\n");
    
    
    fprintf(fd,"void draw%s(){\n",filename);
    
    for(i=0;i<triangle_n;i++){
//	fprintf(fd,"%d ",tri[i].n);
	for(j=0;j<3;j++){
		id=tri[i].vertex_id[j];
		fprintf(fd,"\tglBegin(); ");
   		fprintf(fd,"\t\tglVertex3f(%f,%f,%f);\n",vertex[id].x,vertex[id].y,vertex[id].z);
		fprintf(fd,"\tglEnd(); ");
        }
	fprintf(fd,"\n ");
    }    
    fprintf(fd,"}");
    fclose(fd);
}

