
Uint32 flags=0;

void ScreenModeInit()
{
	Uint32 bpp;
	int value;
	int i;
	
	SDL_Rect **modes;

	/*	
		modes=SDL_ListModes(NULL, SDL_HWSURFACE| SDL_OPENGL  |SDL_RESIZABLE );

		if(modes == (SDL_Rect **)0){
		printf("No modes available!\n");
		exit(-1);
		}

		if(modes == (SDL_Rect **)-1){
		printf("All resolutions available.\n");
		}
		else{
		printf("Available Modes\n");
		for(i=0;modes[i];++i)
		printf("  %d x %d\n", modes[i]->w, modes[i]->h);
		}
		*/



	bpp=SDL_VideoModeOK(ScreenWidth, ScreenHeight, 16,  SDL_OPENGL|SDL_RESIZABLE    );
	if(!bpp){
		printf("Mode not available.\n");
		//	printf("SDL Recommends 640x480@%dbpp.\n", bpp);
		close_program();
	} 

	printf("Mode 2\n");

	flags|= SDL_OPENGL;
	
	sdl_screen = SDL_SetVideoMode(ScreenWidth, ScreenHeight,16,   flags);
	if (sdl_screen  == NULL ) {
		fprintf(stderr, "Unable to create OpenGL screen: %s\n", SDL_GetError());
		close_program();
	}

	OK();
}

void FullScreenMode()
{

	int w,h;

	//w=1024,h=768;	
	w=800,h=600;
	flags = SDL_FULLSCREEN;

	ScreenWidth=w;
	ScreenHeight=h;
	ox=HalfScreenWidth=ScreenWidth/2;
	oy=HalfScreenHeight=ScreenHeight/2;

	ScreenModeInit();   
}


void WindowScreenMode()
{

	int w,h;
	w=800,h=600;
	flags=0;

	if(arg_fs)
	{	
		w=1024,h=768;	
		flags|= SDL_FULLSCREEN; 
	}

	ScreenWidth=w;
	ScreenHeight=h;
	ox=HalfScreenWidth=ScreenWidth/2;
	oy=HalfScreenHeight=ScreenHeight/2;

	ScreenModeInit();   
}

void Init_SDL()
{

	int value;
	int w=320,h=240;
	char *text;


	if(SDL_Init(SDL_INIT_TIMER)<0) ERROR("SDL Timer");
	if(arg_server) return;
	if(SDL_Init(SDL_INIT_VIDEO)<0) ERROR("SDL Video init ");
//DEL if(SDL_Init(SDL_INIT_AUDIO)<0) ERROR("SDL Audio init ");

	Init_Audio();   
	InitJoyStick();

	WindowScreenMode();
	// FullScreenMode();
	SDL_WM_SetCaption("Stress Killer ver.TEST", NULL);


	if(0)
	{
 //   SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
//    SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 8 );
		SDL_GL_GetAttribute(SDL_GL_DOUBLEBUFFER,&value);
		printf("SDL_GL_DOUBLEBUFFER=%d\n",value);
		SDL_GL_GetAttribute(SDL_GL_DEPTH_SIZE,&value);
		printf("SDL_GL_DEPTH_SIZE=%d\n",value);
		SDL_GL_GetAttribute(SDL_GL_STENCIL_SIZE,&value);

		printf("SDL_GL_STENCIL_SIZE=%d\n",value);
		glGetIntegerv(GL_AUX_BUFFERS,&value);
	}
	
	SDL_WarpMouse(HalfScreenWidth,HalfScreenHeight); // 콺 Ŀ ȭ ߰ 
	SDL_ShowCursor(0);  // 콺 Ŀ  ߱
///	SDL_WM_GrabInput(SDL_GRAB_ON);
//	printf("grab=%d\n",SDL_WM_GrabInput(SDL_GRAB_QUERY));
	DEBUGGRAPHIC();

  
    	InitLibFont(); // extern 
    	OK();
}

void ScreenMode_Larger()
{
    if(ScreenWidth==800) return;

    switch(ScreenWidth)
    {
	case 200:
	ScreenWidth=300;
	ScreenHeight=240;

	case 300:
	ScreenWidth=640;
	ScreenHeight=480;

	break;

	case 640:
	ScreenWidth=800;
	ScreenHeight=600;
	break;

    }
    printf("plust key !!\n");
   ox=HalfScreenWidth=ScreenWidth/2;
   oy=HalfScreenHeight=ScreenHeight/2;

    ScreenModeInit();       
}

void ScreenMode_Smaller()
{
    if(ScreenWidth==200) return;

    switch(ScreenWidth)
    {
	case 300:
	ScreenWidth=200;
	ScreenHeight=150;
	break;

	case 640:
	ScreenWidth=300;
	ScreenHeight=240;
	break;

	case 800:
	ScreenWidth=640;
	ScreenHeight=480;
	break;

    }

   ox=HalfScreenWidth=ScreenWidth/2;
   oy=HalfScreenHeight=ScreenHeight/2;

    ScreenModeInit();       
}


void make_rc(char *filename)
{

       FILE *fd;
       if(!(fd=fopen(filename,"w"))){
                 printf("\"~/.mainrc\" make_rc() error  !!\n");
                 exit(-1);
        }

//        fprintf(fd,"168.188.25.254\n");
        fprintf(fd,"player\n");

        fclose(fd);
}


void load_local_rc()
{

	int i,j,n;
	char filename[128];
	char *ptr;
	FILE *fd;

#ifdef WIN32 	
	ptr=getenv("USERNAME");
	if(ptr==NULL) 
		strcpy(user_name,"windows9x_user");
	else 
		strcpy(user_name,ptr);

	strcat(user_name,"@");
	ptr=getenv("COMPUTERNAME");
	if(ptr==NULL) 
		strcat(user_name,"localhost");
	else
		strcat(user_name,ptr);

	ptr=getenv("OS");
	if(ptr!=NULL) 
	{
		strcat(user_name,":");
		strcat(user_name,ptr);
	}
	
#else
	ptr=getenv("USER");
	if(ptr==NULL) 
		strcpy(user_name,"windows_user?");
	else 
		strcpy(user_name,ptr);
	
	strcat(user_name,"@");

	ptr=getenv("HOSTNAME");
	if(ptr==NULL) 
		strcat(user_name,"localhost");
	else
		strcat(user_name,ptr);

	
	ptr=getenv("MACHTYPE");
	if(ptr!=NULL) 
	{
		strcat(user_name,":");
		strcat(user_name,ptr);
	} 

#endif

	
	n=strlen(user_name); 
	for(i=0;i<n;i++)
		if(user_name[i]>127) user_name[i]='?';

	
    /*
    ptr=getenv("HOME");
    strcpy(filename,ptr);
    strcat(filename,"/.mainrc");

    if(!(fd=fopen(filename,"r"))){
                 printf(
		    " \"~/.mainrc\" not exist !! \n "
		    " insert your ID in  \"~/.mainrc\"   \n");
                 make_rc(filename);
    }


    if(!(fd=fopen(filename,"r"))){
                 printf("\"~/.mainrc\" error !!\n");
                 exit(0);
    }
    fscanf(fd,"%s ",user_name);

    fclose(fd); */

    OK();
}


