#include "define.h"
#include <math.h>
#include "math.h"


float box_speed=0.0002;

/*
 *	 :	1.κͰ ̷ ̰ Ҽִ.
 *		2.Ѻͷ 翵 Ÿ, ΰ  ϳ غͷ
 *		   ̸ ˼ִ 
 *
 *	Ͱ:	1.κͰ ̷ 簢̱Ҽִ.
 *		2.κͿ  ͸ Ҽִ. 
 * */

/*
|A 	B 	C 	0 |	|1	0	0	Tx|
|D 	E 	F 	0 | X 	|0	1	0	Ty|
|G 	H 	I 	0 |	|0	0	1	Tz|
|0 	0 	0 	1 |	|0	0	0	1 |
=
|A	B	C	A*Tx+B*Ty+C*Tz  |
|D	E	F	A*Tx+B*Ty+C*Tz	|
|G	H	I	A*Tx+B*Ty+C*Tz 	|
|0	0	0	A*Tx+B*Ty+C*Tz 	|


|A 	B 	C 	0 |	|x|	|A*x+B*y+C*z|
|D 	E 	F 	0 | X 	|y|  =	|D*x+E*y+F*z|
|G 	H 	I 	0 |	|z|	|D*x+E*y+F*z|
|0 	0 	0 	1 |	|1|	|     1     |

|1	0	0	Tx|	|x|	|x+Tx|
|0	1	0	Ty| X 	|y|  =	|y+Ty| 
|0	0	1	Tz|	|z|	|z+Tz|
|0	0	0	1 |	|1|	| 1  |

cx=cos(x),sx=sine(x)

|1   0   0   0 |   |cy   0   sy   0|   | cy	0	sy	0 |
|0   cx -sx  0 |   |0    1   0    0|   |sx*sy	cx     -sx*cy	0 |
|0   sx  cx  0 | x |-sy  0   cy   0| = |-cx*sy	sx	cx*cy	0 |  
|0   0   0   1 |   |0    0   0    1|   |  0	0	0	1 | 
    X_rotate		Y_rotate	 

		 | cz -sz  0  0 |	|cy*cz	-cy*sz	sy	0 |
    (X * Y )  x  | sz  cz  0  0 | = 	|
		 |  0   0  0  0 | 	|
		 |  0   0  0  1 | 	|
*/

// glRotate(th,1,0,0);
//  1   0    0   0
//  0  cos -sin  0
//  0  sin  cos  0
//  0   0    0   1
//
// glRotate(th,0,1,0);
// cos  0   sin  0
//  0   1    0   0
//-sin  0   cos  0
//  0   0    0   1
//
// glRotate(th,0,0,1)
// cos -sin  0   0
// sin  cos  0   0
//  0    0   1   0
//  0    0   0   1



#ifdef OPTIMIZE 

#else

void VectorSet  (Vector *v1, float x,float y, float z)
{ 
	v1->x = x; 
	v1->y = y; 
	v1->z = z; 
} 
 
void vectorSet  (vector *v, float x,float y, float z)
{ 
	v[0] = x; 
	v[1] = y; 
	v[2] = z; 
} 

void vectorCopy (vec3_t out[3],vec3_t in[3]) 
{ 
	out[0] = in[0]; 
	out[1] = in[1]; 
	out[2] = in[2]; 
} 


#endif 

float vector4DotProduct (vec3_t *, vec3_t *); // ????
void Matrix_Add ( float in2[4][4],float in1[4][4])
{
	int i,j;
	for(i=0;i<4;i++)
	{
		in2[i][0]+=in1[i][0];
		in2[i][1]+=in1[i][1];
		in2[i][2]+=in1[i][2];
		in2[i][3]+=in1[i][3];
	}
}


void Matrix_Copy ( float out[4][4],float in[4][4])
//void Matrix_Copy ( float in[4][4],float out[4][4])
{
	int i,j;

	for(i=0;i<4;i++)
	{
		out[i][0]=in[i][0];
		out[i][1]=in[i][1];
		out[i][2]=in[i][2];
		out[i][3]=in[i][3];
	}
}

// function : ־  transposeѴ.
// ok, ӽ 
void Matrix_transposeV1(float matrix[4][4])
{
	int r,c;
	float tmp;
	
	for(r=0;r<4;r++)
		for(c=r;c<4;c++)
		{
			tmp=matrix[r][c];
			matrix[r][c]=matrix[c][r];
			matrix[c][r]=tmp;
		}
}

// hint:transPoseϸ ݴȸϴ M
void Matrix_transposeV2( GLfloat to[16], const GLfloat from[16] )
{
	to[0] = from[0];
	to[1] = from[4];
	to[2] = from[8];
	to[3] = from[12];
	to[4] = from[1];
	to[5] = from[5];
	to[6] = from[9];
	to[7] = from[13];
	to[8] = from[2];
	to[9] = from[6];
	to[10] = from[10];
	to[11] = from[14];
	to[12] = from[3];
	to[13] = from[7];
	to[14] = from[11];
	to[15] = from[15];
}



// function: İ ʵ
// [row][col] 
void Matrix_Mult ( float m1[4][4],float m2[4][4] , float out[4][4])
{
	int r,c;
	for(r=0;r<4;r++)
	   for(c=0;c<4;c++)
		out[r][c]=m1[r][0]*m2[0][c] + m1[r][1]*m2[1][c] + m1[r][2]*m2[2][c] + m1[r][3]*m2[3][c];
//	out[0][0]= m1[0][0]*m2[0][0] + m1[0][1]*m2[1][0] + m1[0][2]*m2[2][0] + m1[0][3]*m2[3][0];
}



void Matrix4D_Mult (float in1[4][4],  float in2[4][4], float out[4][4])
{
		//DotProduct(row[0],col[0]);Ҵ 
	out[0][0] = in1[0][0] * in2[0][0] + in1[0][1] * in2[1][0] + in1[0][2] * in2[2][0];
	out[0][1] = in1[0][0] * in2[0][1] + in1[0][1] * in2[1][1] + in1[0][2] * in2[2][1];
	out[0][2] = in1[0][0] * in2[0][2] + in1[0][1] * in2[1][2] + in1[0][2] * in2[2][2];
	out[0][3] = in1[0][0] * in2[0][3] + in1[0][1] * in2[1][3] + in1[0][2] * in2[2][3] + in1[0][3];
	out[1][0] = in1[1][0] * in2[0][0] + in1[1][1] * in2[1][0] + in1[1][2] * in2[2][0];
	out[1][1] = in1[1][0] * in2[0][1] + in1[1][1] * in2[1][1] + in1[1][2] * in2[2][1];
	out[1][2] = in1[1][0] * in2[0][2] + in1[1][1] * in2[1][2] + in1[1][2] * in2[2][2];
	out[1][3] = in1[1][0] * in2[0][3] + in1[1][1] * in2[1][3] + in1[1][2] * in2[2][3] + in1[1][3];
	out[2][0] = in1[2][0] * in2[0][0] + in1[2][1] * in2[1][0] + in1[2][2] * in2[2][0];
	out[2][1] = in1[2][0] * in2[0][1] + in1[2][1] * in2[1][1] + in1[2][2] * in2[2][1];
	out[2][2] = in1[2][0] * in2[0][2] + in1[2][1] * in2[1][2] + in1[2][2] * in2[2][2];
	out[2][3] = in1[2][0] * in2[0][3] + in1[2][1] * in2[1][3] + in1[2][2] * in2[2][3] + in1[2][3];
}


// TODO: ġı math.c 
// : ־ 3 ȸMϼ 
//       1.: axisԲȸѴ. 
void Matrix_angles(float m[16],float angles[3])
{
	/*
	__gluMakeIdentityf(m);	
	matrix_rotate(m,angles[0],1,0,0);
	matrix_rotate(m,angles[1],0,1,0);
	matrix_rotate(m,angles[2],0,0,1);
	return;
	*/
	float mx[16];
	glMatrixMode (GL_MODELVIEW); 
	glPushMatrix(); //  M 츮 
	glLoadIdentity();

	glRotatef(angles[0],1,0,0); 
	glRotatef(angles[1],0,1,0); 
	glRotatef(angles[2],0,0,1); 

	glGetFloatv(GL_MODELVIEW_MATRIX,mx); // ̰ ̳߿ °ų ó ?
	Matrix_transposeV2(m,mx);
	//Matrix_transposeV1(m);
	glPopMatrix();
	
}

//ӽ ̸ 
void Matrix_x(float m[16],float angle)
{
	float mx[16];
	glMatrixMode (GL_MODELVIEW); 
	glPushMatrix(); //  M 츮 
	glLoadIdentity();

	glRotatef(angle,1,0,0); 
	glGetFloatv(GL_MODELVIEW_MATRIX,mx); // ̰ ̳߿ °ų ó ?
	Matrix_transposeV2(m,mx);
	//Matrix_transposeV1(m);
	glPopMatrix();
}

// Matrix_y((float *)m,2*M_PI/16);
void Matrix_y(float m[16],float angle)
{
	float mx[16];
	glMatrixMode (GL_MODELVIEW); 
	glPushMatrix(); //  M 츮 
	glLoadIdentity();
	glRotatef(angle,0,1,0); 
	glGetFloatv(GL_MODELVIEW_MATRIX,mx); // ̰ ̳߿ °ų ó ?
	Matrix_transposeV2(m,mx);
	//Matrix_transposeV1(m);
	glPopMatrix();
}


// glRotate :
// counterclockwise rotation of angle degrees about the vector 
// from the origin(0,0,0) through the point (x, y, z).
// The current matrix (see glMatrixMode) is multiplied by this rotation matrix;
// with the product replacing the current matrix. 
// That is, if M (current matrix) and R(rotation matrix), 
// then M is replaced with M * R.
// ⼭ ü R  ܸܾ ? ->Ѱ

// : upͱ angleŭ v[3]͸ ȸŲ. (հα)
// : glRotate  ϰ .
//	angle ̸ ݽð,(-)̸ ð 
void vectorRotate(float v[3],float  up[3] ,float angle )
{
	float mx[16];
	float m[4][4];

	glPushMatrix(); //  M 츮 
	glMatrixMode (GL_MODELVIEW); 
	
	glLoadIdentity();
	glRotatef(angle,up[0],up[1],up[2]); 
	glGetFloatv(GL_MODELVIEW_MATRIX,mx); 
	glPopMatrix();

	Matrix_transposeV2((float*)m,mx);  //ʿ  glMatrix 迭 ٸ!
	Matrix_vectorMult(m,v);
}


// ***********̸ٲٱ matrixϱ vector ؾ ̵. 
// rotate by the inverse of the matrix
// ̻ϳ ׳ɰϱ  ȸ̶̳ ???
// ȸ transepose ٷ ȯΰ ?  ʿ!
void Matrix_vectorIRotate ( float m[4][4],vec3_t in1[3], vec3_t out[3])
{
	out[0] = in1[0]*m[0][0] + in1[1]*m[1][0] + in1[2]*m[2][0];
	out[1] = in1[0]*m[0][1] + in1[1]*m[1][1] + in1[2]*m[2][1];
	out[2] = in1[0]*m[0][2] + in1[1]*m[1][2] + in1[2]*m[2][2];
}


// rotate by the input matrix
void Matrix_vectorRotate ( float matirx[4][4],float in_v[3],  float  out[3])
{
	out[0] = vectorDotProduct(matirx[0], in_v);
	out[1] = vectorDotProduct(matirx[1], in_v);
	out[2] = vectorDotProduct(matirx[2], in_v);
//	out[3] = DotProduct(in1, in2[3]); // dosen't need 
}

//  m0, m1, m2, m3
//  m4, m5, m6, m7
//  m8, m9 ,m10,m11
//  m12 m13 m14 m15

// ޸𸮻 迭
// mat[0]= m0,m1,m2,m3;
// mat[1]= m4,m5,m6,m7;
// mat[2]= 

// matrix ϱ vector  vector !!!
//: 1. M vectorϴ° 
//	2. ȸ M  vectorȸ
void Matrix_vectorMult( float M[4][4],float in1[3])
{
	float v[3];

	v[0]=in1[0];
	v[1]=in1[1];
	v[2]=in1[2];

	in1[0] = vectorDotProduct(M[0],v); // m[0],m[1],m[2]
	in1[1] = vectorDotProduct(M[1],v); // m[3],m[4],m[5]
	in1[2] = vectorDotProduct(M[2],v);
//	out[3] = DotProduct(in1, in2[3]); // dosen't need 
}

void Matrix_vectorMultV3 ( float matirx[4][4],float in_v[3],  float  out[3])
{
	out[0] = vectorDotProduct(matirx[0], in_v);
	out[1] = vectorDotProduct(matirx[1], in_v);
	out[2] = vectorDotProduct(matirx[2], in_v);
//	out[3] = DotProduct(in1, in2[3]); // dosen't need 
}



// 3 .
// ʿ!
void Matrix_vectorTransform (float in2[4][4], vec3_t in1[3],  vec3_t out[3])
{
	// ó 
	out[0] = vectorDotProduct(in1, in2[0]) + in2[0][3];
	// ι° 
	out[1] = vectorDotProduct(in1, in2[1]) + in2[1][3];
	out[2] = vectorDotProduct(in1, in2[2]) + in2[2][3];
//	out[3] = vectorDotProduct(in1, in2[3]) + in2[3][3];
}

void Matrix_vectorTransform2 (float in2[4][4], vec3_t in1[3],  vec3_t out[3])
{
	// ó 
	out[0] = vectorDotProduct(in1, in2[0]) + in2[0][3];
	out[1] = vectorDotProduct(in1, in2[1]) + in2[1][3];
	out[2] = vectorDotProduct(in1, in2[2]) + in2[2][3];
//	out[3] = 1 
}


//  ݽð(CCW)Ѵ  angle Ȱ,x,y,z
//  Է° angles[3]   ȸ Ʈ M  
//  (Z*Y)*X then transpose = ? same ?
//   ,
void AngleMatrix (float angles[3], float (*matrix)[4] )
{
	float		angle;
	float		sr, sp, sy, cr, cp, cy;

	//  shoud be radian !
	angle = angles[2]; 	//* (M_PI*2 / 360); 
	sy = sin(angle);
	cy = cos(angle);
	angle = angles[1];	// * (M_PI*2 / 360);
	sp = sin(angle);
	cp = cos(angle);
	angle = angles[0];	// * (M_PI*2 / 360);
	sr = sin(angle);
	cr = cos(angle);

	// matrix = (Z * Y) * X
	matrix[0][0] = cp*cy;
	matrix[1][0] = cp*sy;
	matrix[2][0] = -sp;
	matrix[0][1] = sr*sp*cy+cr*-sy;
	matrix[1][1] = sr*sp*sy+cr*cy;
	matrix[2][1] = sr*cp;
	matrix[0][2] = (cr*sp*cy+-sr*-sy);
	matrix[1][2] = (cr*sp*sy+-sr*cy);
	matrix[2][2] = cr*cp;
	matrix[0][3] = 0.0;
	matrix[1][3] = 0.0;
	matrix[2][3] = 0.0;

}

//
// :  x,y,z  
// bug !!!
void 	AngleXYZMatrix (float *angles, float matrix[4][4] )
{
	float		angle;
	float		sx, sy, sz, cx, cy, cz;

	//  Degree to Radian ? why ?  => shoud be radian !
	angle = angles[2]; 
	sz = sin(angle);
	cz = cos(angle);
	angle = angles[1];	// * (M_PI*2 / 360);
	sy = sin(angle);
	cy = cos(angle);
	angle = angles[0];	// * (M_PI*2 / 360);
	sx = sin(angle);
	cx = cos(angle);

	// matrix =  (X * Y) * Z  by hyun
	matrix[0][0] = cy*cz;
	matrix[0][1] = -cy*sz;
	matrix[0][2] = sy;
	matrix[1][0] =  sx*sy*cz + cx*sz;
	matrix[1][1] = -sx*sy*sz + cx*cz;
	matrix[1][2] = -sx*cy;
	matrix[2][0] = (-cx*sy*cz+ sx*sz);
	matrix[2][1] = (cx*sy*sz + sx*cz);
	matrix[2][2] = cx*cy;
	matrix[3][0] = 0.0;
	matrix[3][1] = 0.0;
	matrix[3][2] = 0.0;

	matrix[3][3] = 1;
}


void AngleIMatrix (vec3_t angles[3], float matrix[4][4] )
{
	float		angle;
	float		sr, sp, sy, cr, cp, cy;
	
	angle = angles[2];// * (Q_PI*2 / 360);
	sy = sin(angle);
	cy = cos(angle);
	angle = angles[1];// * (Q_PI*2 / 360);
	sp = sin(angle);
	cp = cos(angle);
	angle = angles[0];// * (Q_PI*2 / 360);
	sr = sin(angle);
	cr = cos(angle);

	// matrix = (Z * Y) * X
	matrix[0][0] = cp*cy;
	matrix[0][1] = cp*sy;
	matrix[0][2] = -sp;
	matrix[1][0] = sr*sp*cy+cr*-sy;
	matrix[1][1] = sr*sp*sy+cr*cy;
	matrix[1][2] = sr*cp;
	matrix[2][0] = (cr*sp*cy+-sr*-sy);
	matrix[2][1] = (cr*sp*sy+-sr*cy);
	matrix[2][2] = cr*cp;
	matrix[0][3] = 0.0;
	matrix[1][3] = 0.0;
	matrix[2][3] = 0.0;
}



//  : A B  ************ ߿ mmx 3dnow غ.
//  (in1) x (in2) = (out)
//  how about  Matrix_catTransform()
void R_ConcatTransforms (float in1[4][4],  float in2[4][4], float out[4][4])
{
		//DotProduct(row[0],col[0]);
	out[0][0] = in1[0][0] * in2[0][0] + in1[0][1] * in2[1][0] + in1[0][2] * in2[2][0];
	out[0][1] = in1[0][0] * in2[0][1] + in1[0][1] * in2[1][1] + in1[0][2] * in2[2][1];
	out[0][2] = in1[0][0] * in2[0][2] + in1[0][1] * in2[1][2] + in1[0][2] * in2[2][2];
	out[0][3] = in1[0][0] * in2[0][3] + in1[0][1] * in2[1][3] + in1[0][2] * in2[2][3] + in1[0][3];
	out[1][0] = in1[1][0] * in2[0][0] + in1[1][1] * in2[1][0] + in1[1][2] * in2[2][0];
	out[1][1] = in1[1][0] * in2[0][1] + in1[1][1] * in2[1][1] + in1[1][2] * in2[2][1];
	out[1][2] = in1[1][0] * in2[0][2] + in1[1][1] * in2[1][2] + in1[1][2] * in2[2][2];
	out[1][3] = in1[1][0] * in2[0][3] + in1[1][1] * in2[1][3] + in1[1][2] * in2[2][3] + in1[1][3];
	out[2][0] = in1[2][0] * in2[0][0] + in1[2][1] * in2[1][0] + in1[2][2] * in2[2][0];
	out[2][1] = in1[2][0] * in2[0][1] + in1[2][1] * in2[1][1] + in1[2][2] * in2[2][1];
	out[2][2] = in1[2][0] * in2[0][2] + in1[2][1] * in2[1][2] + in1[2][2] * in2[2][2];
	out[2][3] = in1[2][0] * in2[0][3] + in1[2][1] * in2[1][3] + in1[2][2] * in2[2][3] + in1[2][3];
}


float get_distance_v2v(float A[3],float B[3])
{
	float distance;
	float v[3];
	vectorSubtractV3(A,B,v);
	return vectorLength(v);
} 


//    Ѵ 
//return :  
// easy !!
float vectorAngle(vector *v1,vector *v2)
{

	/*  
	 *   cos(angle)|v1||v2| = v1 dot v2 ̿ 
	 *   
	 *  
	 */
	float dot,angle;
	float len_v1,len_v2;

	len_v1=vectorLength(v1);
	len_v2=vectorLength(v2);

	//  κͻ  
	if(len_v2==0 || len_v1==0)
	{ 
		len_v2=1024;
		return 0;
	}
//	if(len_v1==0) len_v1=1024;
	
	dot=vectorDotProduct(v1,v2);
	dot=dot/(len_v1*len_v2);
	angle=acos(dot); // always > 0 
//	DEBUG("angle=%f,dot=%f,len_v1=%f,len_v2=%f",angle,dot,len_v1,len_v2);	
	return angle;
}


//־ҰͰ 
//ִ Լΰ ? Է¹޾ ȸŰ°Ͱ 
void  Angle_vectorRotate(float angle[3],vector *v)
{
	float matrix[4][4];
	AngleMatrix(angle,matrix);
	Matrix_vectorMult(matrix,v);
}




float  vectorLength(float v[3])
//inline float  vectorLength(float v[3])
{
	int		i;
	float	length;
	
   	length = (v[0]*v[0]+v[1]*v[1]+v[2]*v[2]); 

	if(length==0) return 0;

	if (length >-EPSILON && length < EPSILON) {
	//	DEBUGB("length is Zero = %f",length);
		return 0; 
	}
	length = sqrt (length);		// FIXME
	return length;
}



float VectorLength(Vector *v)
//inline float VectorLength(Vector *v)
{
	int		i;
	float		length;
		
	length = 0;
	length += v->x * v->x;
	length += v->y * v->y;
	length += v->z * v->z;

	if(length==0) return 0;
	
	if (length >-EPSILON && length < EPSILON) {
		DEBUG("length is Zero = %f",length);
		return 0; 
	}

	length = sqrt (length);		// FIXME

	return length;
}

// Need Otimize !!!  
// 2003/7/28 by hyun -> inline   
int  VectorNormalize (Vector *v)
//inline int  VectorNormalize (Vector *v)
{
	float	length;

	length = VectorDotProduct(v,v);
		
	if (length == 0) {
		DEBUG("Normalize : length is real Zero");
		return 0; 
	}
	if (length >-EPSILON && length < EPSILON) {
		DEBUG("length is Zero = %f",length);
		return 0; 
	}
	
	length = sqrt (length);
	VectorScale(v,(float)(1/length));
	return 1;
}

//proved!!
void vectorNormalize(float v[3]) 
{    
	GLfloat length= vectorLength(v); 	// sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]); 
//	if (length == 0.0) {	
	if ( length >-EPSILON && length < EPSILON) {
		// printf("normarlize:""zero length vector\n");    
		v[0]=0,v[1]=0,v[2]=0;
		return;
	}
	v[0] /= length; v[1] /= length; v[2] /= length; 
//	vectorScale(v,
}


void PlaneCopy (Plane *p1, Plane *p2) 
{ 
	memcpy(p1,p2,sizeof(Plane));
} 


//̰Ŷ ...
void  VectorCopy (Vertex *v1,Vertex *v2)
//inline void  VectorCopy (Vertex *v1,Vertex *v2)
{ 

	v1->x=v2->x;
	v1->y=v2->y;
	v1->z=v2->z;
	v1->u=v2->u;
	v1->v=v2->v;
	
}

//!!!!!!!!!!!!!!!! fix!! ???
 void 	Vector2vector(float v[3],Vector *V) 
//inline void 	Vector2vector(float v[3],Vector *V) 
{ 
    v[0]=V->x;
    v[1]=V->y;
    v[2]=V->z;

} 

 void 	vector2Vector(Vector *V,float v[3]) 
{ 
    V->x=v[0];
    V->y=v[1];
    V->z=v[2];
} 

 
void vectorScale (vec3_t v[3], float scale) 
{ 
	v[0] = v[0] * scale; 
	v[1] = v[1] * scale; 
	v[2] = v[2] * scale; 
} 


//  
void VectorScale (Vector *v1, float scale) 
{ 
	v1->x = v1->x*scale ; 
	v1->y = v1->y*scale ; 
	v1->z = v1->z*scale ; 
	v1->u = v1->u*scale ; 
	v1->v = v1->v*scale ; 
} 

 
 
void VectorAdd  (Vector *v1, Vector  *v2)
{ 
	v1->x = v1->x+v2->x; 
	v1->y = v1->y+v2->y; 
	v1->z = v1->z+v2->z; 
	v1->u = v1->u+v2->u; 
	v1->v = v1->v+v2->v; 
} 


 void VectorSubtract  (Vector *v1, Vector  *v2)
{ 
	v1->x = v1->x-v2->x; 
	v1->y = v1->y-v2->y; 
	v1->z = v1->z-v2->z; 
	v1->u = v1->u-v2->u; 
	v1->v = v1->v-v2->v; 
} 


void vectorSubtractV3 (vec3_t *va, vec3_t *vb,vec3_t *out) 
{ 
	out[0] = va[0]-vb[0]; 
	out[1] = va[1]-vb[1]; 
	out[2] = va[2]-vb[2]; 
} 
 

void vectorSubtract (vec3_t *va, vec3_t *vb) 
{ 
	va[0] = va[0]-vb[0]; 
	va[1] = va[1]-vb[1]; 
	va[2] = va[2]-vb[2]; 
} 
 
void vectorAdd (vec3_t out[3], vec3_t vb[3]) 
{ 
	out[0] = out[0]+vb[0]; 
	out[1] = out[1]+vb[1]; 
	out[2] = out[2]+vb[2]; 
} 

void vectorAddV3 (float a[3],float b[3],vec3_t out[3]) 
{ 
	out[0] = a[0]+b[0]; 
	out[1] = a[1]+b[1]; 
	out[2] = a[2]+b[2]; 
} 



void VectorSetZero (Vector *v1)
{ 
	v1->x = 0; 
	v1->y = 0; 
	v1->z = 0; 
	v1->u = 0; 
	v1->v = 0; 
} 

void VectorSetVector(Vector *v1, Vector *v2)
{ 
	v1->x = v2->x; 
	v1->y = v2->y; 
	v1->z = v2->z; 
	v1->u = v2->u; 
	v1->v = v2->v; 
} 


void VectorSwap(Vector *v1, Vector *v2)
{
	Vector temp;
	VectorCopy(&temp,v1);
	VectorCopy(v1,v2);
	VectorCopy(v2,&temp);
} 




//proved !!
void  VectorCrossProduct (Vector *r,Vector *v1, Vector  *v2)
{
    r->x = v1->y*v2->z - v1->z*v2->y;
    r->y = v1->z*v2->x - v1->x*v2->z;
    r->z = v1->x*v2->y - v1->y*v2->x;
}

//proved !!
//  
void vectorCrossProduct (float out[3],float v1[3], float  v2[3])
{
    out[0] = v1[1]*v2[2] - v1[2]*v2[1];
    out[1] = v1[2]*v2[0] - v1[0]*v2[2];
    out[2] = v1[0]*v2[1] - v1[1]*v2[0];
}

#define vectorDotProduct999(v1,v2) (v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2])
float vectorDotProduct (vec3_t *v1, vec3_t *v2)
{
	return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2];
}

float vector4DotProduct (vec3_t *v1, vec3_t *v2)
{
	return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2] + v1[3]*v2[3];
}


// Proved !!!!
float  VectorDotProduct (Vector *v1, Vector *v2)
{
	return v1->x *v2->x + v1->y*v2->y + v1->z*v2->z;
}


void normcrossprod(float v1[3], float v2[3], float out[3]) 
{ 
   GLint i, j; 
   GLfloat length;

   out[0] = v1[1]*v2[2] - v1[2]*v2[1]; 
   out[1] = v1[2]*v2[0] - v1[0]*v2[2]; 
   out[2] = v1[0]*v2[1] - v1[1]*v2[0]; 
   vectorNormalize(out); 
}


//  ?
void VectorThreeNormal(float v1[3], float v2[3],float v3[3], float out[3]) 
{ 
   GLint i, j; 
   GLfloat length;

   out[0] = v1[1]*v2[2] - v1[2]*v2[1]; 
   out[1] = v1[2]*v2[0] - v1[0]*v2[2]; 
   out[2] = v1[0]*v2[1] - v1[1]*v2[0]; 
   vectorNormalize(out); 
}
//  κ ϱ 
void vectors2normal(float v1[3], float v2[3],float v3[3], float out[3]) 
{ 
	float v4[3],v5[3];
    	v4[0]=v2[0]-v1[0];
    	v4[1]=v2[1]-v1[1];
    	v4[2]=v2[2]-v1[2];
    	v5[0]=v3[0]-v1[0];
    	v5[1]=v3[1]-v1[1];
    	v5[2]=v3[2]-v1[2];
    	vectorCrossProduct(out,v5,v4); // CW -> CCW
    	vectorNormalize(out);
}


//  κ ϱ 
// Ⱦ 
void Three2Normal(float v1[3], float v2[3],float v3[3], float out[3]) 
{ 
	vectors2normal(v1,v2,v3,out);   
}



void LineCopy(Line *L1,Line *L2)
{
	memcpy(L1,L2,sizeof(Line));
}


void LineSetVector(Line *l,Vector *v1, Vector *v2)
{
	Vector normal;

	VectorSetVector(&normal,v1);
	VectorSubtract(&normal,v2);
	VectorNormalize(&normal);

	VectorCopy(&l->normal,&normal);
	VectorCopy(&l->onPoint,v1);
}



//     ϱ 
int  VectorIntersectionLinePlane(Vector *v,Line *l,Plane *p)
{	
	float u,tmp;
	Vector v1,v2;
	
	VectorSetVector(&v1,&p->onPoint);
	VectorSubtract(&v1,&l->onPoint);

	
	u=VectorDotProduct(&p->normal,&v1);
	tmp=VectorDotProduct(&p->normal,&l->normal);
	
	if(tmp==0){
		DEBUG("VectorIntersectionLinePlane!! zero ");
		return 0;
	}
	u=u/tmp;

	
	VectorSetVector(v,&l->onPoint);
	VectorSetVector(&v2,&l->normal);
	VectorScale(&v2,u);


	VectorAdd(v,&v2);

/*	
	//texture !!
		du=T->vertex[n].u - vertex[m].u;
		dv=T->vertex[n].v - vertex[m].v;
		du=du/sqrt(du*du+dv*dv);
		dv=dv/sqrt(du*du+dv*dv);
			
*/
	return 1;

}


typedef struct sQUAT { 
	float qw; 
	float qx;
	float qy;
	float qz;
} QUAT;


typedef float QFLOAT;

quaternion_vector(float axis[3],float angle)
{
	float sin_a,cos_a;
	float X,Y,Z,W;
	//Given a rotation axis and angle, the following
	//algorithm may be used to generate a quaternion:
	vectorNormalize(axis);
	sin_a = sin( angle / 2 );
	cos_a = cos( angle / 2 );
	X    = axis[0] * sin_a;
	Y    = axis[1] * sin_a;
	Z    = axis[2] * sin_a;
	W    = cos_a;

}

quaternion_conjugate( QUAT *qr, QUAT *qa )
{
	qr -> qw =  qa -> qw;
	qr -> qx = -qa -> qx;
	qr -> qy = -qa -> qy;
	qr -> qz = -qa -> qz;
}

QFLOAT quaternion_magnitude( QUAT *qa )
{
	return( sqrt(qa->qw*qa->qw+
				qa->qx*qa->qx+ qa->qy*qa->qy+qa->qz*qa->qz) );
}

//  ̷ ϱ  by hyun
void  Intersection_PlanePlane(Line *l,Plane *p1,Plane *p2)
{	
	float d,tmp;
	float c1,c2;
	float n2,n1,n12;
	Vector v1,v2;
	
	n1=VectorDotProduct(&p1->normal,&p1->normal);
	n2=VectorDotProduct(&p2->normal,&p2->normal); 
	n12=VectorDotProduct(&p1->normal,&p2->normal); 
	d= n1 + n2 - (n12*n12);

	c1=( n2* p1->distance)  - (p2->distance * n12);
	c1/=d;
	

	c2=( n2* p2->distance)  - (p1->distance * n12);
	c2/=d;

	VectorSetVector(&v1,&p1->normal);
	VectorScale(&v1,c1);
	VectorSetVector(&v2,&p2->normal);
	VectorScale(&v2,c2);
	
	VectorAdd(&v1,&v2);

	VectorCrossProduct(&v2,&p1->normal,&p2->normal);

	VectorSetVector(&l->onPoint,&v1);
	VectorSetVector(&l->normal,&v2);
	

}

	
//   ̷ ϱ 
// Proved !! -> EPSILON 
int VectorIntersction3Plane(Vector *V,Plane *p1,Plane *p2,Plane *p3)
{
	float d;

	Vector Vtemp;
	VectorSet(V,0,0,0);
	
	VectorCrossProduct(&Vtemp,&p2->normal,&p3->normal);
	d=VectorDotProduct(&Vtemp,&p1->normal);	

	if(d==0){ //faster !!
//		DEBUG("zero!!!!!!!!! %f" ,d);
		return 0;
	}
	
	if(d > -EPSILON_MAP && d< EPSILON_MAP){
	//	DEBUG("zero!!!!!!!!! %f" ,d);
		return 0;
	}
	
	VectorScale(&Vtemp,p1->distance);
	VectorAdd(V,&Vtemp);

	VectorCrossProduct(&Vtemp,&p3->normal,&p1->normal);
	VectorScale(&Vtemp,p2->distance);
	VectorAdd(V,&Vtemp);
	
	VectorCrossProduct(&Vtemp,&p1->normal,&p2->normal);
	VectorScale(&Vtemp,p3->distance);
	VectorAdd(V,&Vtemp);

//	VectorCrossProduct(&Vtemp,&p2->normal,&p3->normal);

	VectorScale(V,1/d);	
	return 1;
	
}

void PlaneSetNormalVertex(Plane *P,Vector *N,Vector *v)
{

	// need change !!!
	VectorSetVector(&P->normal,N);
	VectorSetVector(&P->onPoint,v);
	P->distance=VectorDotProduct(N,v);
}
	

void make_triangle_norm(Triangle *tri) 
{ 
    GLint i, j; 
    vector v1[3],v2[3],*out;
    Vertex *vertex;

    vertex=tri->vertex;
    out	=tri->normal;


    v1[0]=vertex[1].x-vertex[0].x;
    v1[1]=vertex[1].y-vertex[0].y;
    v1[2]=vertex[1].z-vertex[0].z;

    v2[0]=vertex[2].x-vertex[0].x;
    v2[1]=vertex[2].y-vertex[0].y;
    v2[2]=vertex[2].z-vertex[0].z;

   out[0] = v1[1]*v2[2] - v1[2]*v2[1]; 
   out[1] = v1[2]*v2[0] - v1[0]*v2[2]; 
   out[2] = v1[0]*v2[1] - v1[1]*v2[0]; 

   vectorNormalize(out); 
}

   

//int TestIntersionPlane( const Plane &plane, const TVector &position,
//			const TVector &direction, double &lamda,
//			TVector &pNormal )

#define ZERO EPSILON
int TestIntersionTriangle(Triangle *tri,Vector *dir,Vertex *start)
{
    float  DotProduct;// = *tri->nx*  *dir->x  + *tri->ny * dir->y + *tri->nz * dir->z;


//    double DotProduct = direction.dot( plane._Normal );
    double l2;

    /* determine if ray paralle to plane */
    if ( ( DotProduct < ZERO ) && ( DotProduct > -ZERO ) ) 
	return 0;

//    l2 = ( plane._Normal.dot( plane._Position - position ) ) / DotProduct;

//    l2 = ( plane._Normal.dot( plane._Position - *start ) ) / DotProduct;
    if ( l2 < -ZERO )
	return 0;

//    pNormal = plane._Normal;
//    lamda = l2;
    return 1;

}



#define vec3_t float
#define CROSS(dest,v1,v2) \
          dest[0]=v1[1]*v2[2]-v1[2]*v2[1]; \
          dest[1]=v1[2]*v2[0]-v1[0]*v2[2]; \
          dest[2]=v1[0]*v2[1]-v1[1]*v2[0];
#define DOT(v1,v2) (v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2])
#define SUB(dest,v1,v2) \
          dest[0]=v1[0]-v2[0]; \
          dest[1]=v1[1]-v2[1]; \
          dest[2]=v1[2]-v2[2]; 


// 	The algorithm translates the origin of the ray and then changes the base to yield 
//	a vector (t u v)T, where t is the distance to the plane in which the triangle lies 
//	and (u,v) represents the coordinates inside the triangle.

//  dir = direction ũ ?
//  orig = 
int
    test_intersect_triangle
    (Triangle *tri,float dir[3],float orig[3],float p[3],float *distance)
    //(Triangle *tri,float dir[3],float orig[3],float *t,float *u,float *v,float *p)
{
    float t,u,v;
    float vert0[3], vert1[3],vert2[3];
    
    float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
    float det,inv_det;

  //  orig[0]= start->x;  orig[1]= start->y;  orig[2]= start->z;
  //    dir[0]=direct->x;   dir[1]=direct->y;   dir[2]=direct->z;

    vert0[0]=tri->vertex[0].x;
    vert0[1]=tri->vertex[0].y;
    vert0[2]=tri->vertex[0].z;

    vert1[0]=tri->vertex[1].x;
    vert1[1]=tri->vertex[1].y;
    vert1[2]=tri->vertex[1].z;

    vert2[0]=tri->vertex[2].x;
    vert2[1]=tri->vertex[2].y;
    vert2[2]=tri->vertex[2].z;


   /* find vectors for two edges sharing vert0 */
   SUB(edge1, vert1, vert0);
   SUB(edge2, vert2, vert0);

   /* begin calculating determinant - also used to calculate U parameter */
   CROSS(pvec, dir, edge2);

   /* if determinant is near zero, ray lies in plane of triangle */
   det = DOT(edge1, pvec);

#ifdef TEST_CULL           /* define TEST_CULL if culling is desired */
   if (det < EPSILON)
      return 0;

   /* calculate distance from vert0 to ray origin */
   SUB(tvec, orig, vert0);

   /* calculate U parameter and test bounds */
   u = DOT(tvec, pvec);
   if (u < 0.0 || u > det)
      return 0;

   /* prepare to test V parameter */
   CROSS(qvec, tvec, edge1);

    /* calculate V parameter and test bounds */
   v = DOT(dir, qvec);
   if (v < 0.0 || u + v > det)
      return 0;

   /* calculate t, scale parameters, ray intersects triangle */
   t = DOT(edge2, qvec);
   inv_det = 1.0 / det;
   t *= inv_det;
   u *= inv_det;
   v *= inv_det;
#else                    /* the non-culling branch */
   if (det > -EPSILON && det < EPSILON)     return 0;

   inv_det = 1.0 / det;
   /* calculate distance from vert0 to ray origin */
   SUB(tvec, orig, vert0);

   /* calculate U parameter and test bounds */
   u = DOT(tvec, pvec) * inv_det;
   if (u < 0.0 || u > 1.0)
     return 0;

   /* prepare to test V parameter */
   CROSS(qvec, tvec, edge1);

   /* calculate V parameter and test bounds */
   v = DOT(dir, qvec) * inv_det;
   if (v < 0.0 || u + v > 1.0)     return 0;

   /* calculate t, ray intersects triangle */
   t = DOT(edge2, qvec) * inv_det;
#endif
   	p[0]= orig[0] + dir[0]* t;
   	p[1]= orig[1] + dir[1]* t;
   	p[2]= orig[2] + dir[2]* t;

   *distance=t;
   return 1;
}


//  modified by hyun
//  line normal ũⰡ 1̾Ѵ ? 
//  p[3] 浹 
int test_intersect_triangle_line
    (Triangle *tri,line *line1,float p[3],float *distance)
{
	float t,u,v;
	float vert0[3], vert1[3],vert2[3];
	float *dir,*orig;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;


	dir=line1->normal;  // dir[0],dir[1],dir[2];
	orig=line1->onPoint;

	vert0[0]=tri->vertex[0].x;
	vert0[1]=tri->vertex[0].y;
	vert0[2]=tri->vertex[0].z;

	vert1[0]=tri->vertex[1].x;
	vert1[1]=tri->vertex[1].y;
	vert1[2]=tri->vertex[1].z;
	
	vert2[0]=tri->vertex[2].x;
	vert2[1]=tri->vertex[2].y;
	vert2[2]=tri->vertex[2].z;


	/* find vectors for two edges sharing vert0 */
	SUB(edge1, vert1, vert0);
	SUB(edge2, vert2, vert0);

	CROSS(pvec, dir, edge2);

	det = DOT(edge1, pvec);
	/* the non-culling branch */
	if (det > -EPSILON && det < EPSILON)
		return 0;
	inv_det = 1.0 / det;

	SUB(tvec, orig, vert0);

	u = DOT(tvec, pvec) * inv_det;
	if (u < 0.0 || u > 1.0)
		return 0;

	CROSS(qvec, tvec, edge1);

	v = DOT(dir, qvec) * inv_det;
	if (v < 0.0 || u + v > 1.0)
		return 0;

	t = DOT(edge2, qvec) * inv_det;
	p[0]= orig[0] + dir[0]* t;
	p[1]= orig[1] + dir[1]* t;
	p[2]= orig[2] + dir[2]* t;

	*distance=t;
	return 1;
}


//  #define TEST_CULL  
//  modified by hyun
//  line normal ũⰡ 1̾ϴ° ?  ->1̾Ѵ
//  line ĳ 
int test_intersect_triangle_line2(Triangle *tri,line *line1,float *distance)
{
	float vert0[3], vert1[3],vert2[3];
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float *dir,*orig;
	float t,u,v;


	dir=line1->normal;  // dir[0],dir[1],dir[2];
	orig=line1->onPoint;

	vert0[0]=tri->vertex[0].x;
	vert0[1]=tri->vertex[0].y;
	vert0[2]=tri->vertex[0].z;

	vert1[0]=tri->vertex[1].x;
	vert1[1]=tri->vertex[1].y;
	vert1[2]=tri->vertex[1].z;
	
	vert2[0]=tri->vertex[2].x;
	vert2[1]=tri->vertex[2].y;
	vert2[2]=tri->vertex[2].z;


	/* find vectors for two edges sharing vert0 */
	SUB(edge1, vert1, vert0);
	SUB(edge2, vert2, vert0);
	CROSS(pvec, dir, edge2);  // ﰢ  𼭸  Ͱ 

	det = DOT(edge1, pvec);  //  ﰢ Ѱ ˻ 
	
#ifdef TEST_CULL           /* define TEST_CULL if culling is desired */
	if (det < EPSILON)		return 0;
//	if (det > -EPSILON && det < EPSILON)	return 0;

	SUB(tvec, orig, vert0);

	u = DOT(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;

	CROSS(qvec, tvec, edge1);

	v = DOT(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = DOT(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	u *= inv_det;
	v *= inv_det;
#else                    /* the non-culling branch */
	if (det > -EPSILON && det < EPSILON)	return 0;
	inv_det = 1.0 / det;

	SUB(tvec, orig, vert0);

	u = DOT(tvec, pvec) * inv_det;
	if (u < 0.0 || u > 1.0)
		return 0;

	CROSS(qvec, tvec, edge1);

	v = DOT(dir, qvec) * inv_det;
	if (v < 0.0 || u + v > 1.0)
		return 0;

	t = DOT(edge2, qvec) * inv_det;
#endif

	*distance=t;
	return 1;
}


// CULL MODE    Ÿ÷ Ȯȵ ͻ !!
int test_intersect_triangle_line3(Triangle *tri,line *line1,float *distance)
{
	float *vert0,*vert1,*vert2;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float *dir,*orig;
	float t,u,v;


	dir=line1->normal;  // dir[0],dir[1],dir[2];
	orig=line1->onPoint;

	vert0=&tri->vertex[0].x;
	vert1=&tri->vertex[1].x;
	vert2=&tri->vertex[2].x;


	/* find vectors for two edges sharing vert0 */
	SUB(edge1, vert1, vert0);
	SUB(edge2, vert2, vert0);
	CROSS(pvec, dir, edge2);  // ﰢ  𼭸  Ͱ 

	det = DOT(edge1, pvec);  //  ﰢ Ѱ ˻ 
	
	if (det < EPSILON)		return 0;
	SUB(tvec, orig, vert0);

	u = DOT(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;

	CROSS(qvec, tvec, edge1);
	v = DOT(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = DOT(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	
	*distance=t;
	return 1;
}

//CULL MODE
int test_intersect_triangle_line4(float *verts[3],line *line1,float *distance)
{
	float *vert0,*vert1,*vert2;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float *dir,*orig;
	float t,u,v;


	dir=line1->normal;  // dir[0],dir[1],dir[2];
	orig=line1->onPoint;

	vert0=verts[0];
	vert1=verts[1];
	vert2=verts[2];


	/* find vectors for two edges sharing vert0 */
	SUB(edge1, vert1, vert0);
	SUB(edge2, vert2, vert0);
	CROSS(pvec, dir, edge2);  // ﰢ  𼭸  Ͱ 

	det = DOT(edge1, pvec);  //  ﰢ Ѱ ˻ 
	
	if (det < EPSILON)		return 0;
	SUB(tvec, orig, vert0);

	u = DOT(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;

	CROSS(qvec, tvec, edge1);
	v = DOT(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = DOT(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	
	*distance=t;
	return 1;

}





