
#define VECTOR(x) (float *)x
#define vec3_t float 

void 		VectorSwap(Vector *v1, Vector *v2);
void 		VectorSetZero (Vector *v1);
inline   void 	VectorSetVector(Vector *v1, Vector *v2);
void    	VectorSet(Vector *v1, float,float,float);

// DEL #define VertexCopy VectorCopy
inline	void 	VectorCopy (Vertex *v1,Vertex *v2);
inline	void 	VectorScale (Vector *v1, float scale) ;
inline	void 	VectorAdd  (Vector *v1, Vector  *v2);
inline	void 	VectorSubtract  (Vector *v1, Vector  *v2);
inline 	int 	VectorNormalize(Vector *V); 
inline 	float 	VectorLength(Vector *V);
inline	float 	VectorDotProduct (Vector *V1, Vector *V2);
inline  void 	VectorCrossProduct (Vector *r,Vector *v1, Vector  *v2);

float 		VectorLength(Vector *v);

inline	void 	LineSetVector(Line *l,Vector *v1, Vector *v2);
void 		LineCopy(Line *L1,Line *L2);

void 		vectorSet  (vector *v, float x,float y, float z); 	// OK
void 		vectorCopy (vec3_t out[3],vec3_t in[3]);  		// OK
void 		vectorScale (vec3_t v[3], float scale); 		// OK
inline void 	vectorAdd (vec3_t va[3], vec3_t vb[3]); 		// OK
void 		vectorAddV3 (float a[3],float b[3],vec3_t out[3]) ;
void 		vectorSubtract (vec3_t va[3], vec3_t vb[3]); 		// OK
	void	vectorSubtractV3 (vec3_t *va, vec3_t *vb,vec3_t *out) ; // OK
inline float 	vectorDotProduct (vec3_t *v1, vec3_t *v2);		
inline float	vectorLength(vector v[3]);
void 		vectorNormalize(float v[3]); 
float 		vectorAngle(vector *v1,vector *v2);
void 		vectorRotate(float v[3],float  up[3] ,float angle );


inline void 	vectorCrossProduct (float cross[3],float v1[3], float  v2[3]);

inline  void 	Vector2vector(float v[3],Vector *V) ;
inline  void 	vector2Vector(Vector *V,float v[3]) ;
void 		Matrix_transposeV2( GLfloat to[16], const GLfloat from[16] );


void 		PlaneSetNormalVertex(Plane *P,Vector *N,Vector *v);

void 		Three2Normal(float v1[3], float v2[3],float v3[3], float out[3]) ;
int 		VectorIntersction3Plane(Vector *V,Plane *p1,Plane *p2,Plane *p3);
int  		VectorIntersectionLinePlane(Vector *v,Line *l,Plane *p);
	
inline int      test_intersect_triangle (Triangle *tri,float dir[3],float orig[3],float p[3],float *d);
inline int 	test_intersect_triangle_line (Triangle *tri,line *line1,float p[3],float *distance);
inline int 	test_intersect_triangle_line2(Triangle *tri,line *line1,float *distance);
inline int 	test_intersect_triangle_line3(Triangle *tri,line *line1,float *distance);
inline int 	test_intersect_triangle_line4(float *verts[3],line *line1,float *distance);

void 		make_triangle_norm(Triangle *tri);
void 		AngleMatrix (float *angle, float (*matrix)[4] );
void 		AngleIMatrix (float angles[3], float matrix[4][4] );
void 		R_ConcatTransforms (float in1[4][4], float in2[4][4], float out[4][4]);
void 		Matrix_Add ( float in2[4][4],float in1[4][4]);
void 		Matrix_vectorRotate ( float in2[4][4],float in1[3],  float  out[3]);
void 		Matrix_vectorMult( float matrix[4][4],float in1[3]);
void 		Matrix_vectorMultV3 ( float matirx[4][4],float in_v[3],  float  out[3]);
void 		Matrix_vectorIRotate ( float in2[4][4],float in1[3],  float  out[3]);
void 		Matrix_vectorTransform (float in2[4][4], vec3_t in1[3],  vec3_t out[3]);
void 		Matrix_transpose(float matirx[4][4]);
void 		Matrix_angles(float m[16],float angles[3]);
void 		AngleXYZMatrix (float *angles, float (*matrix)[4] );

//ӽ 
void 	Matrix_y(float m[16],float angle);
void 	Matrix_x(float m[16],float angle);

float 		get_distance_v2v(float A[3],float B[3]);
