// draft by hyun  
// 
#include "define.h"
#include "core.h"
#include "network.h"

#include <SDL/SDL_thread.h>

TCPsocket 	tcp_socket;

IPaddress 	server_ip;
IPaddress 	server_udp_ipaddr;

Packet_UDP	packet_data;
Packet_UDP	*data_in;

//del Packet_Info	packet_info_out;
Packet_Info	*packet_info_in;

UDPpacket 	*udp_in, *udp_out;
Uint16 		udp_port;
//del Uint16 		server_udp_port; 

SDLNet_SocketSet  tcp_socket_set;
SDLNet_SocketSet  udp_socket_set;


//del int NetworkConnected=0;
int Network_TCP_Connected=0;
int Network_UDP_Connected=0;
// SERVER_INFO
int 	net_client_n=0;
Packet_Client_Info client[64];

// ̸ٲٱ 
char 	GameServer_ip[64];

int 	numused;



typedef struct {
	int	active;
	char	title[32];
	char 	address[32];
	char	version[32];
	int	player_n;
} Packet_SERVER_ITEM2 	PACK_STRUCT;


//*********************** test ************************
Packet_SERVER_ITEM game_server_list[128];
int game_server_n=0;

//char *server_list[]={ "168.188.129.194","127.0.0.1"};
//char *server_list[]={"168.188.44.66","222.98.176.89","127.0.0.1"};
//char *server_list[]={"168.188.44.66","127.0.0.1"};
//char *root_server[]={"168.188.44.66","127.0.0.1"};
//char *root_server[]={"jazz.ce.cnu.ac.kr","127.0.0.1"};

#ifdef WIN32
char *root_server[]={"127.0.0.1"};
#else
char *root_server[]={"168.188.129.194","127.0.0.1"};
#endif 

int run_server=0;
int start_connect_GameServer=0;    //Ӽ 

Object	*test_net_player=NULL;
int	local_player_uid=0;


char   string_err[30]="error??";

SDL_cond   *condvarMain;
SDL_cond   *condvarThread;
SDL_mutex  *mutex_tcp_socket_set;
SDL_Thread *thread;



// Network_SOCK draft by hyun
#define MAX_SOCKET 16

typedef struct s_connet {
	int		active;
	int		connecting;
	int 		connected;
	int  		try;
	int  		time;
	int  		error;
	int 		recevied;
	
	IPaddress 	ip;
	UDPsocket  	udp_socket;
	TCPsocket	tcp_socket;
	Uint16		recv_byte;
	Uint16		recv_size;

	char *host;
	Uint16 port;
	void *callback_connect;
	void *callback_disconnect;
	void *callback_recv;
	void *callback_fail;

	char		buffer[1024*16];  // 16kbyte
	void 		(*callback)(struct s_connet * ,void *,int );
//=====================================
	SDL_Thread 	*thread;
} Socket;

Socket sockets[MAX_SOCKET];
int socket_n=0;

Socket 	*sock_udp=NULL;  // udp
//char 		recv_buffer[MAXBUF];
//char 		*recv_buffer;


//, core ̵
Object * uid_getObject(int uid)
{
	int i;
	Object *obj;
	
	for(i=0;i<MAX_OBJECTS;i++)
	{
		obj=Objects[i];
		if(obj==NULL) continue;
		if(obj->uid == uid) return obj;
	}
	return NULL;
}

Object * id_getObject(int id)
{
	int i;
	Object *obj;
	
	for(i=0;i<MAX_OBJECTS;i++)
	{
		obj=Objects[i];
		if(obj==NULL) continue;
		if(obj->id != id) continue;
		return obj;
	}

	ERROR("null");
	return NULL;
}




char * uid_getName(int uid)
{
	int i;
	Object *obj;
		
	for(i=0;i<MAX_OBJECTS;i++)
	{
		obj=Objects[i];
		if(obj==NULL) continue;
		if(obj->uid == uid) return obj->name;
	}
	return string_err;
}


print_client_info()
{
	int i;
	
	DrawPrintf("address : %s   " ,GameServer_ip);
	DrawPrintf("%d players  \n" ,net_client_n);
	DrawPrintf("========================================================================\n");
	DrawPrintf("NAME                           seq     loss    misc    kill   death     \n");
	DrawPrintf("------------------------------------------------------------------------\n");
	
	for(i=0;i<net_client_n;i++)
		DrawPrintf("%-30s %-8d %-8d %-8d\n",
				uid_getName(client[i].uid),
				client[i].seq,client[i].loss,client[i].misc);



}




UDPsocket new_UDPsocket(Uint16 *port)
{
	UDPsocket udp_socket;
	*port=40000;
	while(1)
	{
		udp_socket=SDLNet_UDP_Open(*port);
		if(udp_socket==NULL) {
			Console_printf("SDLNet_UDP_Open: %s [%d]\n", SDLNet_GetError(),port);
			*port++;
		}
		else 	break;
		
	}

	return udp_socket;
}




int send_tcp2(TCPsocket sock, void *buff, Uint16 len )
{
	int i,result;
	Uint16 size;

	if(sock==NULL) ERROR("send_tcp2");

	size=len;
	SDLNet_TCP_Send(sock,&size,2); 
	result=SDLNet_TCP_Send(sock,buff,len); 
	if(result<len){
		ERROR("SDLNet_TCP_Send: %s\n",SDLNet_GetError());
		//printf("ERROR:SDLNet_TCP_Send: r=%d %s\n",result,SDLNet_GetError());
		close_program();
	}
	return result;
}



void init_server_Network();

void init_Network()  //
{
//	Network_Connect(); not stable!!
//
//	Dont use this func in here, the func very unstable now
//	initialize  varables...
//
	if(SDLNet_Init()==-1) {
		printf("SDLNet_Init: %s\n", SDLNet_GetError());
		exit(2);
	}

	init_Sockets();
	

	//Ŭ̾Ʈ udp_socket
	//del Cudp_socket=new_UDPsocket(&udp_port); 
//	Cudp_socket=SDLNet_UDP_Open(0); // already udp_socket;

	// allocate max packet
	if(!(udp_out=SDLNet_AllocPacket(65535)))
	{
		printf("SDLNet_AllocPacket: %s\n",SDLNet_GetError());
		exit(6);
	}
	if(!(udp_in=SDLNet_AllocPacket(65535)))
	{
		printf("SDLNet_AllocPacket: %s\n",SDLNet_GetError());
		exit(6);
	}
	
	tcp_socket_set=SDLNet_AllocSocketSet(MAX_SOCKET);
	if(!tcp_socket_set) 
		ERROR("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
	

	udp_socket_set=SDLNet_AllocSocketSet(MAX_SOCKET);	
	if(!udp_socket_set) 
		ERROR("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
	
	OK();
}


// what ? 
close_Network()
{
	int i;
		
	for(i=0;i<MAX_SOCKET;i++)
	{
	//	Socket_Del(&sockets[i]);
	}

	//if(Network_TCP_Connected!=TRUE) return ;
	//SDLNet_TCP_Close(tcp_socket);
}

send_test()
{
	char 	buffer2[1024];
	int len;
	int result;
	strcpy(buffer2,"test_player 1");
	len=strlen(buffer2);
	Console_printf("SDLNet_TCP_Send: size=%d\n",len);
	//	result=SDLNet_TCP_Send(tcp_socket,&packet_info,len); 
	result=SDLNet_TCP_Send(tcp_socket,buffer2,20); 
	//	result=SDLNet_TCP_Send(tcp_socket,"1234",5); 


	// add 1 for the NULL
	if(result<len){
		Console_printf("ERROR:SDLNet_TCP_Send: r=%d %s\n",result,SDLNet_GetError());
		exit(0);
	} 
	Console_printf("send message!!");
}

Uint32  seqence=1;
//del Uint32  send_udp_time=0;


// UDP mechanism !!
Object_send_packet(Object *obj)
{
	int result,numsent;
	int right_now=0;	
	int len;
	static int old_action=0;
	Packet_UDP	out;

	///	printf(" dddddddddddd 1 \n");
	if(Network_UDP_Connected!=TRUE) return;
	
	//  ߼ϳ ? 
	// **** 1. action ù߼
	//      2. hited ߻ 
	obj->packet_time+=iDeltaTime;
	if( obj->packet_time > 33  ) right_now=1; 
	if( obj->hited ) right_now=1; 
	if( obj->action_test !=obj->action_old ) right_now=1; 

	if( !right_now )  return;
	//send_udp_time >33
	obj->packet_time=0;

	// seq ġ 
	out.seq=seqence++;
	out.uid=obj->uid;
	vectorCopy(out.position,obj->center);
	vectorCopy(out.direction,obj->direction);
	vectorCopy(out.view_direction,obj->view_direction);
	vectorCopy(out.move_direction,obj->move_direction);
	vectorCopy(out.rotate,obj->rotate);

	out.move_speed=obj->move_speed;

	if(obj->relativeAlt<=0) 
		out.relativeAlt=0;
	else out.relativeAlt=obj->relativeAlt;


//	Console_printf("player->rotate[1]=%f \n",player->rotate[1]);
//	Console_printf("packet_data.rotate[1]=%f \n",packet_data.rotate[1]);
	out.heading=obj->rotate[1];
	out.pitch=obj->rotate[0];
	out.action_test=obj->action_test;
//del ?	out.hit=obj->hited_not_proved;
	out.hit=obj->hited;
	out.hit_joint=obj->hited_joint;

	obj->hited=0;
	obj->action_old=obj->action_test;

	Socket_send(sock_udp,&out,sizeof(Packet_UDP));

}




//Ƽ  Ǵ° ? ׷ ִ° ?
// if  local_player hit  a number of other net object, 
//  
send_udp_hit(int hited_uid,int joint)
{
	
	//del send_udp_time=1000;
	Packet_UDP	out;

	int len;
	
	if(hited_uid<= 0) DEBUGB(" xxxxxxxxxxxxxxxxxxxxx \n");

	out.hit=1;
	out.hit_joint=joint;
	out.hit_uid=hited_uid;
	
	Socket_send(sock_udp,&out,sizeof(Packet_UDP));
	
	DEBUGB(" hited uid=%d\n",hited_uid);
	// ??
	out.hit=0;
	out.hit_uid=0;
}



Object* new_player(char *name);
Object* dopplegang=NULL;


// draft 
// ο net÷̾ ߻ 
// game  client ޴´.
// : YOUR_ID 쿡 !
void recv_NEW_PLAYER(void *buffer)
{
	Object *new;
	Object *obj;
	Packet_Info	*in;
	
	in=(Packet_Info*)buffer;
///	DEBUGB("client: recv new user name : %s \n",in->name);
	
	//ð  ӽÿ ʾ  
	/*if(in->uid!=local_player_uid)
	{
		//̹ object ϸ ׳ .
		//if(buff->address == local addr ) return;
		obj=uid_getObject(in->uid);
		if(obj!=NULL)
			return;
	} */
	
	//̹ object Ѵٴ° object Object̴.
	//׳ .
	obj=uid_getObject(in->uid);
	if(obj)	return;

	new=new_player(in->name);
	new->uid=in->uid;
	new->is_gravity=1;	
	new->active=1;	
	new->net=1; // udp޾ƾϴ ܺ Object 

	DEBUGB("NET: new user name : %s ",in->name);
	
	//ð ϴ  . 
/*	if(in->uid==local_player_uid)
	{
		dopplegang=new;
		DEBUGB("received !! local user : %s   uid=%d ",in->name,in->uid);
		new->active=1;	
	}*/
	
	OK();
}


void do_DEL_PLAYER(void *buffer)
{
	Object *obj;
	Packet_Info *in;	

	in=(Packet_Info*)buffer;
	obj=uid_getObject(in->uid);
	if(obj==NULL){
		DEBUG(" null object ?");
		return;
	}
	
	Object_Remove(obj);

	OK();
}


//template 
void do_TEMP(char *buffer)
{
	Packet_TEMP *packet_temp;
	packet_temp=(Packet_TEMP*)buffer;

	OK();
}



void recv_START_GAME(void *buffer)
{
	Object *new;
	Packet_START_GAME *packet_temp;
	packet_temp=(Packet_START_GAME*)buffer;

	New_Title_center("New Game Start!!!!");
	player_restart(player);
	OK();
}



extern Uint32 game_timer;
//void do_SERVER_INFO(char buffer[])
void do_SERVER_INFO(char *buffer)
{

	int len;
	int i;
	Packet_Server_Info *server_info;
	Packet_Client_Info *client_info;

	
	server_info=(Packet_Server_Info*)buffer;
	net_client_n=server_info->client_n;
	game_timer=server_info->time;
	len=sizeof(Packet_Server_Info);
	
	
	client_info=(Packet_Client_Info*)&buffer[len];
	for(i=0;i<net_client_n;i++)
		memcpy(&client[i],&client_info[i],sizeof(Packet_Client_Info));
	
///	OK();

}

// Ҳ !
void DEL_do_PLAYER_UID(void *buffer)
{
	int oid;
	Object *obj;
	Packet_Info *in;
	in=(Packet_Info*)buffer;

	oid=in->object_id;
	obj=Objects[oid];
// ̹ ϴ Object̹Ƿ 
	obj->uid=in->uid ;
//  uid ޾Ƿ Ȱ .
	
	obj->active=1;
	if(obj==player)
	{
		//init_local_player();
		Camera=obj;
		//?? dopplegang=obj;
		Console_printf("received !! local user : %s   uid=%d ",in->name,in->uid);
		// init_local_player();
	}
	
	OK();
}


void recv_udp2(Socket *sock,char *buffer);
Socket *   New_Socket_UDP(char *host,Uint16 port,void *callback2);

// 1.TCP   udp_port uid !!
// 2.uid  object Ȱȭ 
//
void recv_NET_YOUR_UID(void *buffer)
{
	Packet_Info *in;
	Object *obj;
	int index;
	in=(Packet_Info*)buffer;

	obj=id_getObject(in->object_id);
	CHECK_OBJ(obj);

	obj->uid=in->uid;
	obj->active=1;
//del	obj->udp_send_flag=1;  // udp۰
	SET_FLAG(&obj->flag,OBJECT_LOCAL);
	obj->net=0; //Ǵ°  Object Ÿ
	
	if(test_net_player==obj) 
	{
		local_player_uid=in->uid;
		//Console_printf(" local player !!! Object  !!");
		player=obj;
		Camera=obj;
	}
	
///	DEBUGB("Object [%s] gets UID=%d !!",obj->name,obj->uid);
}

//****  ֽ udpŶ о鿩Ѵ.  Ŷ ٹѴ.
// Ŭ̾Ʈ ׳ .
Uint32  recv_udp_gab_time=0;
Uint32  recv_udp_gab_timeTotal=0;

Draw_Debug_network()
{
	DrawPrintf(" udp_gab_time =%d \n" , recv_udp_gab_time);
}

DEL_recv_udp()
{
	int i,n,p;
	int packet_n;
	Object *obj;

	if(Network_UDP_Connected!=TRUE) return;

	n=SDLNet_CheckSockets(udp_socket_set, 0);
	if(n==0 ){
		recv_udp_gab_timeTotal+=iDeltaTime;
		return; 
	}

	recv_udp_gab_time=recv_udp_gab_timeTotal;
	recv_udp_gab_timeTotal=0;
	
	if(n<0 )  
		Console_printf(" recv udp  error!");
//	if(n>2 ) 		Console_printf(" recv_udp  n= %d ",n);

//del 	if(!SDLNet_SocketReady(Cudp_socket)) return;
	// no-blocking
	do{
//del 		n=SDLNet_UDP_Recv(Cudp_socket, udp_in);
	}
	while(n);
	
	packet_n=udp_in->data[0];
	//Console_printf(" recv udp  packet_n=%d",packet_n);
	data_in=(Packet_UDP*)udp_in->data;
	/*  Console_printf("Client[%d]: seq=%5d  position=%f %f %f \n",n,
					data_in->seq,
					data_in->position[0],
					data_in->position[1],
					data_in->position[2]);  */
	
	for(p=0;p<packet_n;p++)
	for(i=0;i<Object_n;i++)
	{
		obj=Objects[i];
		if(obj->uid != data_in[p].uid) continue;

		if(obj==dopplegang)
		{
			obj->center[0]=data_in[p].position[0] -100;
			obj->center[2]=data_in[p].position[2];
			player->hited=data_in[p].hit;
			player->hited_joint=data_in[p].hit_joint;
		}

		else 	
		{
			obj->center[0]=data_in[p].position[0];
			obj->center[2]=data_in[p].position[2];
		}

		//߿ center[1]ؾ -> ׶ 
		if(data_in[p].relativeAlt==0)
			obj->center[1]=data_in[p].position[1];

		
		obj->direction[0]=data_in[p].direction[0];
		obj->direction[1]=data_in[p].direction[1];
		obj->direction[2]=data_in[p].direction[2];
	
		obj->view_direction[0]=data_in[p].view_direction[0];
		obj->view_direction[1]=data_in[p].view_direction[1];
		obj->view_direction[2]=data_in[p].view_direction[2];
	
		obj->move_direction[0]=data_in[p].move_direction[0];
		obj->move_direction[1]=data_in[p].move_direction[1];
		obj->move_direction[2]=data_in[p].move_direction[2];
		obj->move_speed=data_in[p].move_speed;
	//	Console_printf("obj->move_speed=%f \n",obj->rotate[1]);

		obj->rotate[0]=data_in[p].rotate[0];
		obj->rotate[1]=data_in[p].rotate[1];
		obj->rotate[2]=data_in[p].rotate[2];

	//	Console_printf("obj->rotate[1]=%f \n",obj->rotate[1]);
		obj->rotate[1]=data_in[p].heading;
	//	obj->pitch=data_in[p].pitch;
	//	obj->action=data_in[p].action;
		obj->hited=data_in[p].hit;
		obj->hited_joint=data_in[p].hit_joint;
		obj->action_test=data_in[p].action_test;
		break; // ߰׷ϱ  
	}
	//	Console_printf(" recv  server udp packet222222222222 !");

}


//ý۴ Ѱ ʿ !!
//ڱⲬ   ??
void recv_udp_GAMESERVER(Socket *sock,Uint8 *buffer)
{
	int 		i,n,p;
	int 		packet_n;
	Object 		*obj;
	Packet_UDP	*in;

	SOCKET_CHECK(sock);
	packet_n=buffer[0];

	in=(Packet_UDP*)buffer;
//	return;

	for(p=0;p<packet_n;p++)
	{
		
		if(in[p].uid==0) continue; // ??? 
		
		/// DEBUGB("received UDP packet!!");
		obj=uid_getObject(in[p].uid);  
		if(obj==NULL)
		{	
			DEBUGB("######### Object null!! ");
			return;
		}
	 	
		//obj->net==1 츸 UDPŶ޾Ƽ óѴ. 
		if(obj->net==0) continue; 
		
		obj->hited=in[p].hit;
		obj->hited_joint=in[p].hit_joint;

		// printf("$$$$$$ client: recv_udp_OBJECT_INFO1 n=%d\n",packet_n);
		// local  obj Ŷ ʿϴ !!
		// Ѹ 쿡 ޾ƾѴ.
		//del if(obj->udp_send_flag==1) continue; 	
		if(IS_FLAG(obj->flag,OBJECT_LOCAL)) continue; 	

		/*
		if(in[p].uid==local_player_uid)
		{
			if(dopplegang==NULL)
			{	printf("######### null2");
				ERROR("######### null2");
			}
			obj=dopplegang;
		}
		if(obj==dopplegang)
		{
			obj->center[0]=in[p].position[0] - 100; 
			obj->center[2]=in[p].position[2];
			player->hited=in[p].hit;
			player->hited_joint=in[p].hit_joint;
		}
		else 	 */

		{
			obj->center[0]=in[p].position[0];
			obj->center[2]=in[p].position[2];
		}
	
		vectorCopy(obj->direction,in[p].direction);
		vectorCopy(obj->view_direction,in[p].view_direction);
		vectorCopy(obj->move_direction,in[p].move_direction);
		vectorCopy(obj->rotate,in[p].rotate);
		
		obj->move_speed=in[p].move_speed;
		obj->rotate[1]=in[p].heading;
	//	obj->pitch=data_in[p].pitch;
	//	obj->action=data_in[p].action;

		obj->hited=in[p].hit;  
		obj->hited_joint=in[p].hit_joint;
		obj->action_test=in[p].action_test;

		//߿ center[1]ؾ -> ׶ 
		if(data_in[p].relativeAlt==0)
			obj->center[1]=in[p].position[1];

		
		/*
	//	Console_printf("obj->move_speed=%f \n",obj->rotate[1]);
	//	Console_printf("obj->rotate[1]=%f \n",obj->rotate[1]);
		*/
	}
}



Uint32 LastConnectTime=0;
Enable_Network_Connect()
{
	LastConnectTime=3000;
}



send_udp2(UDPsocket udp_socket,IPaddress *ip,char *buffer,int len)
{
	int result,numsent;
	
	udp_out->data=buffer;
	udp_out->len=len;
	udp_out->address.host=ip->host;
	udp_out->address.port=ip->port;
	// channel -1̸ packet ٿ ּҷ װ 
	// -1 ƴҰ쿡 soket ٿּҷ . 
	//numsent=SDLNet_UDP_Send(udp_socket, packet->channel, packet);
	numsent=SDLNet_UDP_Send(udp_socket, -1 , udp_out);
	if(!numsent) {
		printf("SDLNet_UDP_Send: %s\n", SDLNet_GetError());
		// do something because we failed to send
		// this may just be because no addresses are bound to the channel...
	}
}

// ٿ
send_udp3(UDPsocket udp_socket,char *buffer,int len)
{
	
	int result,numsent;
	
	udp_out->data=buffer;
	udp_out->len=len;
	// channel -1̸ packet ٿ ּҷ װ 
	// -1 ƴҰ쿡 soket ٿּҷ . 
	//numsent=SDLNet_UDP_Send(udp_socket, packet->channel, packet);
	numsent=SDLNet_UDP_Send(udp_socket, 0 , udp_out);
	if(!numsent) {
		printf("SDLNet_UDP_Send: %s\n", SDLNet_GetError());
		// do something because we failed to send
		// this may just be because no addresses are bound to the channel...
	}
}



int SOCKET_CONNECTED(Socket *sock)
{

}


int SOCKET_CHECK(Socket *sock)
{
	if(sock==NULL) ERROR("socket NULL!!\n");
	if(sock->udp_socket==NULL && sock->tcp_socket==NULL) ERROR("socket NULL 2!!\n");
}


int SOCKET_READY(Socket *sock)
{

}



Socket_reset(Socket *sock)
{
	sock->active=0;
	sock->connected=0;
	sock->connecting=0;
	sock->time=0;
	sock->recv_byte=0;
	sock->recv_size=0;
	sock->udp_socket=NULL;
	sock->tcp_socket=NULL;
	sock->thread=NULL;
}


init_Sockets()
{
	int i;
	
	if ( (mutex_tcp_socket_set=SDL_CreateMutex()) == NULL ) {
		fprintf(stderr, "Couldn't create mutex: %s\n", SDL_GetError());
		//exit(1);
	}

	for(i=0;i<MAX_SOCKET;i++)
	{
		Socket_reset(&sockets[i]);
	}

}

Socket_send(Socket *sock,void *data,int len)
{
	if(sock==NULL) return;

	if(sock->udp_socket)
		send_udp2(sock->udp_socket,&sock->ip,data,len );

	if(sock->tcp_socket)
		send_tcp2(sock->tcp_socket,data,len);
}


Socket_send_repeat(Socket *sock)
{
	

}


Socket_connect_del(Socket *sock)
{
	char buffer[30];
	buffer[0]=NET_CONNECTION;
	
	Socket_send(sock,buffer,1);
	sock->connecting=1;
}


Socket_Del(Socket *sock)
{
	if(sock==NULL) return;

	if(sock->tcp_socket!=NULL)
	{
		SDLNet_TCP_DelSocket(tcp_socket_set,sock->tcp_socket);
		SDLNet_TCP_Close(sock->tcp_socket);
	}

	if(sock->thread!=NULL){
		SDL_KillThread(sock->thread);
		sock->thread=NULL;
	}

	Socket_reset(sock);
	socket_n--;
}

Socket_connect_fail(Socket *sock)
{
	void (*cb)(Socket *);
	char buffer[30];
	
	cb=sock->callback_fail;
	if(cb!=NULL)
		cb(sock);
	
	Socket_Del(sock);
}

Socket_disconnect(Socket *sock)
{
	void (*cb)(Socket *);
	char buffer[30];
	
	cb=sock->callback_disconnect;
	if(cb!=NULL)
		cb(sock);
	
	Socket_Del(sock);
}



// what is this ?
typedef struct s_connet_ {
	int	idx;
	char *host;
	Uint16 port;
	void *callback1;
	void *callback2;
	void *callback3;
//=====================================
	SDL_Thread 	*thread;
} Args;



int threadfunc1(void *data)
{
	TCPsocket	tcp_socket;
	IPaddress  	ip;
	Socket		*sock;
	void 		(*cb)(Socket *);
	int i;
	
	sock= data;
	
	if(SDLNet_ResolveHost(&sock->ip, sock->host, sock->port)==-1)
	{
		printf("SDLNet_ResolveHost: %s\n",SDLNet_GetError());
		return 0;
	}

	tcp_socket=SDLNet_TCP_Open(&sock->ip);
	if(!tcp_socket)
	{
		//fail_call
		//Socket_connect_fail(sock);
		cb=sock->callback_fail;
		cb(sock);
		return 0;
	} 
	
	//blocking 
	if ( SDL_mutexP(mutex_tcp_socket_set) < 0 ) { 	fprintf(stderr, "Couldn't lock mutex: %s", SDL_GetError());return 0;	}

	numused=SDLNet_TCP_AddSocket(tcp_socket_set,tcp_socket);
	if(numused==-1) 
		ERROR("SDLNet_AddSocket: %s\n", SDLNet_GetError());

	if ( SDL_mutexV(mutex_tcp_socket_set) < 0 ) {	fprintf(stderr, "Couldn't unlock mutex: %s", SDL_GetError());	return 0;	}

	sock->connecting=0;
	sock->connected=1;
	sock->active=1;
	sock->tcp_socket=tcp_socket;

	//conneted_call
	cb=sock->callback_connect;
	cb(sock);
	return 0;
}

void test_connect()
{
	static Socket *sock=NULL;
	IPaddress ip;

	thread=SDL_CreateThread( threadfunc1,NULL);
	if(thread==NULL) ERROR("thread==NULL");
//void SDL_KillThread(SDL_Thread *thread);
	if(sock==NULL)
	{
	//	sock=New_Socket("127.0.0.1",UDP_PORT,recv_NET_SERVER_NUMBER);
	//	send_NET_SERVER_NUMBER(sock);
	}

	/*
	if(SOCKET_CONNECTED(sock)) 
	{


	}
	
	if(SOCKET_READY(sock)) 
	{

			
	} */

}



Socket *   New_Socket5(char *host,Uint16 port,void *cb_connect,void *cb_disconnect,void *cb_recv,void *cb_fail)
{
	int 	i;
	Args 	args;
	
	for(i=0;i<MAX_SOCKET;i++)
		if(sockets[i].active==0 && sockets[i].connecting==0) break;
	if(i==MAX_SOCKET) ERROR("max");

	sockets[i].host=host;
	sockets[i].port=port;
	sockets[i].callback_connect=cb_connect;
	sockets[i].callback_disconnect=cb_disconnect;
	sockets[i].callback=cb_recv;
	sockets[i].callback_fail=cb_fail;
	
	sockets[i].connecting=1;

	thread=SDL_CreateThread( threadfunc1,&sockets[i]);
	if(thread==NULL) ERROR("thread==NULL");

	sockets[i].thread=thread;
	socket_n++;

	return &sockets[i];
}


Socket *   New_Socket4(char *host,Uint16 port,void *cb_connect,void *cb_recv,void *cb_fail)
{
	return New_Socket5(host,port,cb_connect,NULL,cb_recv,cb_fail);
}



Socket	*New_Socket_UDP(char *host,Uint16 port,void *callback_recv)
{
	int 	i;
	UDPsocket 	udp_socket;
	IPaddress  	ip;
	void 		(*cb)(Socket *);
	
	for(i=0;i<MAX_SOCKET;i++)
		if(sockets[i].active==0 && sockets[i].connecting==0) break;
	if(i==MAX_SOCKET) ERROR("max");

	udp_socket=SDLNet_UDP_Open(0);
	if(!udp_socket)
	{
		DEBUGB("connect NULL   no SERVER !!\n",SDLNet_GetError());
		return NULL;
	} 

	if(port!=0){
		if(SDLNet_ResolveHost(&sockets[i].ip, host, port)==-1)
		{
			printf("SDLNet_ResolveHost: %s\n",SDLNet_GetError());
			return NULL;
		}
		// If -1 is used, then the first unbound channel will be used, 
		// this should only be used for incomming packet filtering
		if(SDLNet_UDP_Bind(udp_socket, -1, &sockets[i].ip)==-1)
		{
			printf("SDLNet_UDP_Bind: %s\n",SDLNet_GetError());
			return NULL;
		}
	}

	sockets[i].active=1;
	sockets[i].udp_socket=udp_socket;
	sockets[i].tcp_socket=NULL;
	sockets[i].callback=callback_recv;
	
	numused=SDLNet_UDP_AddSocket(udp_socket_set,udp_socket);
	if(numused==-1) {
    		printf("SDLNet_AddSocket: %s\n", SDLNet_GetError());
		return NULL;
	} 
	
	socket_n++;
	return &sockets[i];
}



void do_Socket()
{
	int i,result;
	UDPsocket udp_socket;

	numused=SDLNet_CheckSockets(udp_socket_set, 0);
	if(numused!=0) 
	for(i=0;i<MAX_SOCKET;i++)
	{
		if(sockets[i].active==0) continue;
		if(sockets[i].udp_socket==NULL) continue;
		udp_socket=sockets[i].udp_socket;

		if(!SDLNet_SocketReady(udp_socket)) continue;

		do{
			result=SDLNet_UDP_Recv(udp_socket, udp_in);
			sockets[i].callback(&sockets[i],udp_in->data,udp_in->len);

		}  while(result);

	}   


	numused=SDLNet_CheckSockets(tcp_socket_set, 0);
	if(numused!=0)
	for(i=0;i<MAX_SOCKET;i++)
	{
		int byte;
		int size;		
		if(sockets[i].active==0) continue;
		if(sockets[i].tcp_socket==NULL) continue;

		if(!SDLNet_SocketReady(sockets[i].tcp_socket)) continue;
		

		
		byte=sockets[i].recv_byte;

		if(sockets[i].recv_size==0)  
		{
			//ѹũ 
			result=SDLNet_TCP_Recv(sockets[i].tcp_socket,&sockets[i].recv_size,2);
			if(result<0)
			{
				Socket_disconnect(&sockets[i]);
				continue;
			}
		
		}

		result=SDLNet_TCP_Recv(sockets[i].tcp_socket,&sockets[i].buffer[byte],sockets[i].recv_size);
		sockets[i].recv_byte+=result;

		if(result<0)
		{
			//TCP .
			Socket_disconnect(&sockets[i]);
			continue;
			//del if(sockets[i].callback!=NULL)
			//del sockets[i].callback(&sockets[i],sockets[i].buffer,result);
		}
		
//		printf("recv tcp  recv_byte=%d recv_size=%d   byte[0]=%d\n",sockets[i].recv_byte,sockets[i].recv_size,sockets[i].buffer[0]);

		if(sockets[i].recv_byte==sockets[i].recv_size){
			if(sockets[i].callback!=NULL)
				sockets[i].callback(&sockets[i],sockets[i].buffer,sockets[i].recv_byte);
			sockets[i].recv_size=0;
			sockets[i].recv_byte=0;
		}
		else { 
			sockets[i].recv_size-=sockets[i].recv_byte;
			printf(" 2 !!!\n");
		}
	}

	for(i=0;i<MAX_SOCKET;i++)
	{
		//if(sockets[i].active==0) continue;
		if(sockets[i].udp_socket) continue; // if UDP get throughout
		if(sockets[i].connecting==1)
		//if(sockets[i].connected==0) // why doesnt work ?
		{
			if(sockets[i].time>4000)
			{
			//	DEBUGB("socket %d timeout!!",i);
				sockets[i].error=1;
			//del	Socket_send_repeat(&sockets[i]);
				Socket_connect_fail(&sockets[i]);
			}
			else 
				sockets[i].time+=iDeltaTime;
		} 
	}

}



int server_list_n=0;

recv_NET_SERVER_NUMBER(Socket *sock,char *buffer)
{
	int i;
	int n;
	
//	Packet_SERVER_NUMBER *packet;
//	packet=(Packet_SERVER_NUMBER *) buffer;
	
//	n=packet->number;

	for(i=0;i<n;i++)
	{
//		packet->list[i].
	}

}



send_NET_SERVER_NUMBER(Socket *sock)
{
	char buffer[32];
//	buffer[0]=NET_SERVER_NUMBER;
	Socket_send(sock,buffer,1);
}



//*******************  ROOT  SERVER :start  ******************************// 
send_get_server_list(Socket *sock)
{
	char buffer[32];
	buffer[0]=NET_SERVER_LIST;
	Socket_send(sock,buffer,1);
}


//Ʈ ӽϸ 
//ðӼ۵  
fail_get_server_list(Socket *sock)
{
	game_server_n=1;
	run_server=1;  //ü ۵ !!
	
	strcpy(game_server_list[0].address,"127.0.0.1");
	DEBUGB("root_sever connect fail!!  default gameserver is now 127.0.0.1");
}


recv_get_server_list(Socket *sock,char *buffer)
{
	int i;
	int n;
	
	Packet_SERVER_LIST *packet;
	packet=(Packet_SERVER_LIST *) buffer;

	game_server_n=n=packet->number;
//	Console_printf("recv NET_SERVER_LIST !! = %d\n",n);
	DEBUGB(" received server_n  = %d\n",n);
	
	if(game_server_n==0) 
	{	
		fail_get_server_list(sock);
		Socket_Del(sock);
		return;
	}

	
	for(i=0;i<n;i++)
	{
		memcpy(&game_server_list[i],&packet->list[i],sizeof(Packet_SERVER_ITEM));
		DEBUGB("server[%d] %s  %s \n",i,game_server_list[i].title,game_server_list[i].address);
		game_server_list[i].player_n=0;
		
	}
	
	start_connect_GameServer=TRUE;
	//for test
	strcpy(game_server_list[0].address,"127.0.0.1");
	
	//root  
	Socket_Del(sock);
}

//*******************  ROOT  SERVER : end  ******************************// 


//*******************  GameServer : start  ******************************// 
Socket *sock_gamesever=NULL;


// 
send_getGameServerInfo(Socket *sock)
{
	char buffer[32];
	buffer[0]=NET_SERVER_INFO;
	Socket_send(sock,buffer,1);
}


//÷̾˸ 
send_dead(int uid)
{
	char buffer[32];
	buffer[0]=NET_SERVER_INFO;
	Socket_send(sock_gamesever,buffer,1);
}



//  ִ .
recv_getGameServerInfo(Socket *sock,char *buffer)
{
		

}

fail_getGameServerInfo(Socket *sock)
{


}


Object_NET_NEW_PLAYER(Object *obj)
{
	Packet_Info out;
	int len;
	CHECK_OBJ(obj);

	if(Network_TCP_Connected<=0) return;
	out.id=NET_NEW_PLAYER;
	out.udp_port=udp_port; //  ʺѴ. 
	out.object_id=obj->id;
	
	strcpy(out.name,obj->name);	
	printf("client: notice NET_NEW_PLAYER to game_sever !!  %s\n",obj->name);
	Socket_send(sock_gamesever,&out,sizeof(Packet_Info));
}


connect_tcp_GAMESERVER(Socket *sock)
{
	sock_gamesever=sock;
	Network_TCP_Connected=TRUE;

	//GameServer Ǹ ûڽ 
	if(arg_server==0) test_local_player();
}


//gameκ ޴° ó 
recv_tcp_GAMESERVER(Socket *sock,char *buffer,int len)
{
//	if(buffer[0]==NET_SERVER_REPLY) do_SERVER_REPLY(buffer); 
//	else
	if(buffer[0]==NET_NEW_PLAYER)  recv_NEW_PLAYER(buffer); // ο ÷̾ź 
	else
	if(buffer[0]==NET_SERVER_INFO)  do_SERVER_INFO(buffer);
	else 
	if(buffer[0]==NET_DEL_PLAYER)  do_DEL_PLAYER(buffer);
	else
	if(buffer[0]==NET_START_GAME)  recv_START_GAME(buffer);
	else
	if(buffer[0]==NET_PLAYER_UID)  recv_NET_YOUR_UID(buffer); // ÷̾ uid ޱ 
	else DEBUGB("????????????Error !! TCP Packet ???????");
}



fail_GAMESERVER(Socket *sock)
{
	DEBUGB("GAME-SERVER  connect FAIL !!  %s\n",game_server_list[0].address);
	DEBUGB("GAME-SERVER  no response !!\n");
}



void 	getGameSeverInfo()
{
	int i;

	for(i=0;i<game_server_n;i++)
	{
		New_Socket4(game_server_list[i].address,GAME_SERVER_PORT,send_getGameServerInfo
				,recv_getGameServerInfo,fail_getGameServerInfo);
	}

}



// from RootServr ,get GameServer list...
void	get_server_list()
{
	
	static Socket *sock=NULL;
	if(sock==NULL)
	{
		sock=New_Socket4(root_server[0],ROOT_SERVER_PORT,send_get_server_list,
				recv_get_server_list,fail_get_server_list);
	}

}


void 	connect_GameSever()
{
	int result,len;
	unsigned char send_size;
	static Socket *sock=NULL;

	if(sock!=NULL) return;

	//rootκ game  ޾ƿ쿡
	if(arg_server==0)  
		if(game_server_n==0)
		{
			get_server_list();
			return;
		}

	// غ Ǹ Ӽ 
	if(!start_connect_GameServer) return;

	if(arg_server>0) //local GameServer  ϶ ÿѴ. 
	{
		game_server_n=1; 
		strcpy(game_server_list[0].address,"127.0.0.1");
	}
	
	strcpy(GameServer_ip,game_server_list[0].address);
	sock=New_Socket4(GameServer_ip,GAME_SERVER_PORT,connect_tcp_GAMESERVER,recv_tcp_GAMESERVER,fail_GAMESERVER);
	sock_udp=New_Socket_UDP(GameServer_ip,GAME_SERVER_PORT,recv_udp_GAMESERVER);
	if(sock_udp==NULL) ERROR("??");
	Network_UDP_Connected=TRUE;
}


#include "server2.c"


Object *init_local_player();

//Ǹ ¥ΰ÷̾ Ű±.
test_local_player()
{
	if(Network_TCP_Connected==TRUE && test_net_player==NULL)
	{
		test_net_player=init_local_player();
	}
}


//̰Ź ?
int show_conneting=0;
void DealNetwork()
{
	
	if(Network_TCP_Connected==FALSE )
	{
		connect_GameSever();
	}
	
	if(Network_UDP_Connected==TRUE)
	{
		Object *obj;
		int i;
	
		// New_Object
		// Object    
		for(i=0;i<MAX_OBJECTS;i++)
		{
			obj=Objects[i];
			if(obj==NULL) continue;
			if(obj->uid==0) continue;
			if(obj->active==0) continue; //***
			if(IS_FLAG(obj->flag,OBJECT_LOCAL)) Object_send_packet(obj);
		} 
	}
	do_Socket();

	return; 
	{

	/*		if(show_conneting==0){		New_Title_center("connecting...Sever ");
			show_conneting=1;
		}*/
	}

//	recv_tcp_GAMESERVER(Socket *sock,char *buffer,int len)
}

