#include "define.h"
#include "core.h"
#include "math.h"

#define UFL 0
#define UFR 1
#define UBR 3
#define UBL 2
#define DFL 4
#define DFR 5
#define DBL 6
#define DBR 7

#define TOP	0
#define BOTTOM	1

#define UP_FRONT_LEFT 	 (int)0
#define UP_FRONT_RIGHT 	 (int)1
#define UP_BACK_LEFT  	 (int)2
#define UP_BACK_RIGHT 	 (int)3

#define DOWN_FRONT_LEFT  (int)4
#define DOWN_FRONT_RIGHT (int)5 
#define DOWN_BACK_LEFT   (int)6
#define DOWN_BACK_RIGHT  (int)7
#define COINCIDENT	 (int)11

#define UP   		 1
#define DOWN		 2
#define FRONT		 3
#define BACK		 4
#define LEFT		 5
#define RIGHT		 6
#define ONPLANE		 7

#define CELLSIZE    	3*UNIT
#define LEVEL		3	
#define LEAF		999	

void MakeOctreeMap(Shape *m); //,char *fn)
//////  EXPERIMENTAL !!!
int 	draw_cell_n=0;
int 	zbuffer_draw_cell_n=0;


float 	cell_size=CELLSIZE;  // Dont used

int 	octree_level=LEVEL;  

int 	octree_thredhold_triangle_n=300;   // 

//  
//  ƴ get_max_leve()Լ ° 
#define BlockCellsN	1024*256*1

Cell  	*List_Cells1[BlockCellsN];
Cell  	*List_Cells2[BlockCellsN];
Cell    *List_CellsInFOV[BlockCellsN];
Cell	*List_CellsInDOV[BlockCellsN];
Cell  	*List_LeafCellsInFOV[BlockCellsN];

Cell  	**List_ViewableCells;
Cell  	**List_DrawCells;

Cell  	*BlockCells_Sorted[1024];

int		LeafCellsInFOV_n;
int 	list_flag=1;
int     BlockCells_Hit_N;
int     ViewableCells_N=0;
int     BlockCells_inFOV_N=0; // used      
int     CellsInFOV_N=0;  // used
int     CellsInDOV_n=0;    


int     BlockCells_inFOVUnit_N;    
Cell 	*BlockCells_inFOVUnit[1024];
Cell 	*BlockCells_Hit[1024];


Cell *octree_top=NULL;

//WRONG !! -> fixed
//Cell *BlockCells[256][256][256];


void InsertUnitBlock(Cell *n)
{
    int i;static int init=0;
    //int cx,cy,cx;
//    cx=7;
    
    Cell *cn;

    //p=octree_top;
    
    /*if(init==0){
	BlockLevel[0]=Block0;
	BlockLevel[1]=Block1;
	BlockLevel[2]=Block2;
    }	
 if(cn->
    for(
    for(i=0 ; i<octree_level;i++)
	n->child[]
	Blocks[i][0][0][0];
	    BlockCells0[2][2][2];

    n->cx     Cell->min_x - octree_top->max_x;
    octree_top->max_y; */

}
/*		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT1);
  		glDisable(GL_TEXTURE_2D); 
		glDisable(GL_BLEND);
		glDisable(GL_FOG);
*/	
extern int visiable_polygon_n;
int	zbuffer_flag;

DELDraw_BlockCellZbuffer(Cell *cell)
{
	   
	int i;

	if(cell->level == LEAF){
    		cell->FrameID=FrameID;
		Shape_DrawZbuffer(cell->shape);
		return;
	}

//?????????????????????????????????????
	for(i=0;i<8;i++){
		if(cell->child[i]==NULL) continue;
		DELDraw_BlockCellZbuffer(cell->child[i]);
	} 

}



Draw_BlockCell(Cell *cell)
{
	   
	int i;

	if(cell->level == LEAF){
		if(RenderMode==3) 
			Shape_Draw_WIREFRAME(cell->shape);
		else
		{
			Shape_Draw(cell->shape);
		///	Shape_DrawZbuffer(cell->shape);
		}
	
		return;
	}

	for(i=0;i<8;i++){
		if(cell->child[i]==NULL) continue;
		Draw_BlockCell(cell->child[i]);
	} 

}


void Draw_BlockCellsZbuffer()
{
    int i;
    for(i=0;i<ViewableCells_N;i++)
	  DELDraw_BlockCellZbuffer(List_ViewableCells[i]);
}


extern int 	zbuffer_triangle_n;

//void Draw_BlockCells()
void Draw_Cells()
{
	int i;
	zbuffer_triangle_n=0;
	//    for(i=0;i<BlockCells_inFOV_N;i++)
	//for(i=0;i<draw_cell_n;i++)
	for(i=0;i<ViewableCells_N;i++)
	{
		if(List_ViewableCells[i]==NULL) 
		{ 
			DEBUG("NULL, draw_cell_n=%d",draw_cell_n);
			return;
		}
		//	  Draw_BlockCell(List_DrawCells[i]);
		Draw_BlockCell(List_ViewableCells[i]);
	}

}

extern int MapTest_BlcokCellBound;


Draw_CellBound(Cell *c)
{
	glBegin( GL_LINES );
	glVertex3fv(c->conner[UFL]);
	glVertex3fv(c->conner[UFR]);
	glVertex3fv(c->conner[UBL]);
	glVertex3fv(c->conner[UBR]);
	glVertex3fv(c->conner[DBL]);
	glVertex3fv(c->conner[DBR]);
	glVertex3fv(c->conner[DFL]);
	glVertex3fv(c->conner[DFR]);

	glVertex3fv(c->conner[UFL]);
	glVertex3fv(c->conner[UBL]);
	glVertex3fv(c->conner[UFR]);
	glVertex3fv(c->conner[UBR]);
	glVertex3fv(c->conner[DFL]);
	glVertex3fv(c->conner[DBL]);
	glVertex3fv(c->conner[DFR]);
	glVertex3fv(c->conner[DBR]);
	
	glVertex3fv(c->conner[UFL]);
	glVertex3fv(c->conner[DFL]);
	glVertex3fv(c->conner[UFR]);
	glVertex3fv(c->conner[DFR]);
	glVertex3fv(c->conner[UBL]);
	glVertex3fv(c->conner[DBL]);
	glVertex3fv(c->conner[UBR]);
	glVertex3fv(c->conner[DBR]);
	glEnd();
}

Draw_BlockCellBound()
{
    int i;

    glDisable(GL_BLEND);
   

    glColor3ub(0,0,255);
    for(i=0;i<ViewableCells_N;i++)
    {
	    //	    Draw_CellBound(List_DrawCells[i]);
	    Draw_CellBound(List_ViewableCells[i]);

    }

    glColor3ub(0,255,0);
    for(i=0;i<BlockCells_inFOV_N;i++)		    Draw_CellBound(List_CellsInFOV[i]);
	 

}
 
Draw_HitBlockBound()
{
    int i;
    glColor3ub(255,0,255);
    for(i=0;i<BlockCells_Hit_N;i++)
	Draw_CellBound(BlockCells_Hit[i]);
	    
}
   

Cell *FindCurrentBlockCell()
{


}
    
#define CHECK_FULL    2
#define CHECK_PARTIAL 3
#define CHECK_OUT     0
#define CHECK_IN      1

//SpeedOptimizm !!
//need change !!! 2003/07/21
int Check_isInFOV1(Cell *cell) 
{
    vector  tv[3]; 
    int out,in,zero;
    float minus_r=-cell->radius;
    float dpR,dpL,dpT,dpB;

//    printf("m=%f\n",minus_r);
//DEL    if(cell->radius<0) printf("error minus\n");
    zero=in=out=0;
    
    vectorCopy(tv,cell->center);
    vectorSubtract(tv,Camera->position);
	
    dpL=vectorDotProduct(tv,Frustrum.nL);
    dpR=vectorDotProduct(tv,Frustrum.nR);
    dpT=vectorDotProduct(tv,Frustrum.nT);
    dpB=vectorDotProduct(tv,Frustrum.nB);

	
    if(dpR<minus_r) in++;  // OK~
    if(dpR> cell->radius) out++;
    if(dpR<0) zero++;

    if(dpL<minus_r) in++;
    if(dpL> cell->radius) out++;
    if(dpL<0) zero++;

    if(dpT<minus_r) in++;
    if(dpT> cell->radius) out++;
    if(dpT< 0) zero++;

    if(dpB<minus_r) in++;
    if(dpB> cell->radius) out++;
    if(dpB< 0) zero++;


    if(in==4) 	return CHECK_FULL;
    if(zero==4) return CHECK_PARTIAL;
    if(in> 0)  	return CHECK_PARTIAL;
    if(out>0) return 0;
    
    return 0;

}

// too slow code
int Check_isInFOV2(Cell *cell) 
{
    vector  tv[3]; 
    int i,n;
    float dpR,dpL,dpT,dpB;

    
	
    n=0;
    for(i=0;i<8;i++){
	
	    vectorCopy(tv,cell->conner[i]);
	    vectorSubtract(tv,Camera->position);
    
		
	    dpL=vectorDotProduct(tv,Frustrum.nL);
	    dpR=vectorDotProduct(tv,Frustrum.nR);
	    dpT=vectorDotProduct(tv,Frustrum.nT);
	    dpB=vectorDotProduct(tv,Frustrum.nB);
	    if(dpL<0 && dpR<0 && dpT<0 && dpB<0) n++;
	
    }
	    vectorCopy(tv,cell->center);
	    vectorSubtract(tv,Camera->position);
	    dpL=vectorDotProduct(tv,Frustrum.nL);
	    dpR=vectorDotProduct(tv,Frustrum.nR);
	    dpT=vectorDotProduct(tv,Frustrum.nT);
	    dpB=vectorDotProduct(tv,Frustrum.nB);

    	if(dpL<0 && dpR<0 && dpT<0 && dpB<0) n++;

	
    if(n>7) 	return CHECK_FULL;
    if(n>0) 	return CHECK_PARTIAL;
    return 0;

}



//faster  but not yet proved  
// need change code 
int Check_isInFOV3(Cell *cell) 
{
	vector  tv[3]; 
	int out,in,zero;
	float minus_r=-cell->radius;
	float distance;
	float dpR,dpL,dpT,dpB;

	zero=in=out=0;

	//  Cell߽ɱ  tv
	vectorSubtractV3(cell->center,Camera->center,tv);
	vectorSubtract(tv,Camera->view_position);

	//first 
	// does include Camera ?
	distance=vectorLength(tv);
	cell->distance=distance; // get the distance from camera , then insert it to the Cell

	if(distance < cell->radius && cell->level==LEAF )    
	{	
		// Camera->cell=cell;
		return CHECK_FULL;
	}

	if(distance < cell->radius)
		return CHECK_PARTIAL;


	//second 
	// is This cell outside ?
	dpL=vectorDotProduct(tv,Frustrum.nL);
	dpR=vectorDotProduct(tv,Frustrum.nR);
	dpT=vectorDotProduct(tv,Frustrum.nT);
	dpB=vectorDotProduct(tv,Frustrum.nB);

	if(dpR>= cell->radius) out++;
	if(dpL>= cell->radius) out++;
	if(dpT>= cell->radius) out++;
	if(dpB>= cell->radius) out++;

	if(out>0) return 0; // CHECK_OUT

	//third  
	// The rest are FULL or PARTIAL 
	if(dpR<minus_r) in++;  
	if(dpL<minus_r) in++;
	if(dpT<minus_r) in++;
	if(dpB<minus_r) in++;

	if(in==4 || cell->level==LEAF ) 	return CHECK_FULL;

	// The rest are PARTIAL
	return CHECK_PARTIAL;

}

//  	not yet Proved
// 	no PARTIAL just FULL or OUT 
int Object_isInFOV(Object *obj) 
{
	vector  v1[3]; 
	int out,in,zero;
	float minus_r=-obj->radius;
	float distance;
	float dpR,dpL,dpT,dpB;

	zero=in=out=0;
	vectorCopy(v1,obj->center);
	vectorSubtract(v1,Camera->view_position);
	vectorSubtract(v1,Camera->center);

	// second  Algorithm1
	// is This object  outside of FOV ?
	dpL=vectorDotProduct(v1,Frustrum.nL);
	dpR=vectorDotProduct(v1,Frustrum.nR);
	dpT=vectorDotProduct(v1,Frustrum.nT);
	dpB=vectorDotProduct(v1,Frustrum.nB);

	if(dpR>= obj->radius) out++;
	if(dpL>= obj->radius) out++;
	if(dpT>= obj->radius) out++;
	if(dpB>= obj->radius) out++;

	if(out>0) return 0; // CHECK_OUT
	return 1;
}


// function : Cell Obj WOMB ϴ° ˻ 
// object cell Ÿ  xx̳ΰ ϸǹ 
int Object_CheckCellInWOMB(Object *obj,Cell *cell) 
{
	vector  v1[3],v2[3]; 
	int out,in,zero;

	float cell_radius=cell->radius; // 0 
	//float f=cell_radius + 5*METER;
	float f=obj->effective_radius + cell_radius;
	float distance;  // obj߽κ cell߽ɱŸ 

 	vectorCopy(v1,cell->center);
    	vectorSubtract(v1,obj->center);
    	distance=vectorLength(v1);

	//      .--------------.
	//    Žؼ WOMB ִ 
	//leaf  ã  Ѵ. 
	//

	//  ִ ,ġų ų  
	if( f - distance > 0)  
	{
		//return CHECK_FULL;
		return CHECK_PARTIAL;
		
	}
	else 
		return CHECK_OUT;
		
}



// ?
BlockCell_GetUnit(Cell *cell)
{
	int i;
	if(cell->level==octree_level){
		BlockCells_inFOVUnit[BlockCells_inFOVUnit_N++]=cell;
		return;
	}
	for(i=0;i<8;i++)
	{
		if(cell->child[i]==NULL)  continue;
		BlockCell_GetUnit(cell->child[i]);
	}
}

float shortest_distance=30000;

float farthest_distance=0;
Cell  *shortest_cell;
int	shortest_id=0;
// Ǵ°ǰ ?
void getDistanceFromCamera(Cell *c)
{
	float v[3];			
	
	vectorCopy(v,c->center);
	vectorSubtract(v,Camera->position);
	c->distance=vectorLength(v);


	if(c->distance>farthest_distance) 
		farthest_distance=c->distance;

	if(c->distance<shortest_distance) {
		shortest_distance=c->distance;
		shortest_cell=c;
		shortest_id=BlockCells_inFOV_N;
		
	}

}

void Shape_checkBackFace(Shape *shape);

int getTriangleN(Cell *cell)
{

    int n=0,i;
    if(cell->level==LEAF){
	  	
//	    Shape_checkBackFace(cell->shape);
	    return cell->shape->triangle_n;
    }
    
    for(i=0;i<8;i++)
    {
	    if(cell->child[i]==NULL)	continue;
	    n+=getTriangleN(cell->child[i]);
    }

    return n;
}

	




#define A List_CellsInFOV
SWAP(Cell *a,Cell *b)
{
	Cell *tmp;
	tmp=b;
	b=a;
	a=tmp;
}


// EasySort 
// init code ,need fix 
void sortVisiableCells2()
{
	int i,j;
	int  short_id;
	int total_triangle=0;
	float shortest;

	Cell *temp;


	zbuffer_draw_cell_n=0;
	total_triangle=0;
	for(i=0;i<BlockCells_inFOV_N-2;i++)
	{
		shortest=9000000;
		short_id=-1;

		for(j=i;j<BlockCells_inFOV_N;j++){
			if(A[j]->distance<shortest)
			{
				shortest=A[j]->distance;
				short_id=j;
			}
		}

		if(short_id==-1 ) ERROR("Short");
		if(i!=short_id){
			if(A[i]==NULL) ERROR("cell NULL");
//		if(A[i]->shape==NULL) 	ERROR("shape==NULL i=%d j=%d BlockCells_inFOV_N=%d short_id=%d",
///					i,j,BlockCells_inFOV_N,short_id);
		//	SWAP(A[i],A[short_id]);
			temp=A[short_id];
			A[short_id]=A[i];
			A[i]=temp;

			total_triangle+=getTriangleN(A[i]);
			if(total_triangle>2048 && zbuffer_draw_cell_n==0){
				zbuffer_draw_cell_n=i+1;	
				break;
			}
		}

		
	}
	    
	if(zbuffer_draw_cell_n==0) zbuffer_draw_cell_n=BlockCells_inFOV_N;

}
#undef  A


/*************************************************************************
***  QSORT.C - Sample of qsort() algorithm
***  MG - 9/16/97    
***  modified by hyun  2003/
***  Comment: You will note that this program will demonstrate the fact that
***  the Quick Sort algorithm works worst on already-sorted data.
*************************************************************************/
#define ELEMENT Cell

inline int Compare( ELEMENT *A, ELEMENT *B )
{

	if(A->distance < B->distance ) return -1;
	else return 1;
}

/* Swaps 2 elements, called by QSort */
inline void Swap( ELEMENT **One, ELEMENT **Two )
{
	ELEMENT *Tmp;
	Tmp=*One;
	*One=*Two;
	*Two=Tmp;
}


/***********************************************************************
** Name:	QSort
** Descr:	Implements the Quick Sort algorithm to sort an array of strings
** Params:	Lines = Lines to sort
**          Left = Left index of current partition
**          Right = Right index of current partition
** Author:  MG 9/16/97
** Comment: The quick sort algorithm works by recursively dividing the
**          array into partitions, then sub-partitions, and sub-sub partitions,
**          and so on.  A basic organization is performed on each partition.
***********************************************************************/
void QSort( ELEMENT *Lines[], int Left, int Right )
{
	int Part, j;


	if( Right > Left )  /* Watch our bounds */
	{
		Part=Left;
		j=Right-1;

		/* Loop to determine partition */
		for( ;; )
		{
			/* Part (partition) towards the right while it's < rightmost */
			while( Compare( Lines[Part], Lines[Right] ) < 0 )
				Part++;
			/* Move j from right-1 to Part */
			while( j>Part && Compare( Lines[j], Lines[Right] ) >= 0 )
				j--;
			/* If Part and j crossed paths, or j is out of bounds, we got the Part */
			if( Part >= j || j<0)
				break;

			/* Otherwise, swap these lines (here's where data is moved far) */
			Swap( Lines+Part, Lines+j);
		}
		if( Part != Right )
			Swap( Lines+Part, Lines+Right);

		QSort( Lines, Left, Part-1 ); /* Sort the left of the partition */
		QSort( Lines, Part+1, Right ); /* sort the right of the partition */
	}
}

void sortCells3( )
{
	QSort( List_CellsInFOV, 0, BlockCells_inFOV_N-1);
}

#undef ELEMENT 

// ־ top_cell  FOVȿ ִ Cell ãƳ   
// List_CellsInFOV[] Ѵ.
// Ʈ ̿ ˻  ӵ ̵ճ ?
//  Don't Make Leaf !!!  -> for speed 
void findCellsInFOV(Cell *cell)
{
	int i,ret;

	if(cell==NULL){
		//ERROR("cell=NULL !!"); //for robust
		return ;
	}
	ret=Check_isInFOV3(cell);

	if(ret==CHECK_FULL)
	{
		// if(cell->shape==NULL) ERROR("2cell->shape=NULL !!");
		List_CellsInFOV[BlockCells_inFOV_N++]=cell;
		return ; 
	}

	if(ret==CHECK_PARTIAL) 
	{
		for(i=0; i< 8 ; i++)
			if(cell->child[i]!=NULL)    findCellsInFOV(cell->child[i]);
	}

}




// shape ﰢ ո ޸˻ 
// ̰ɹ̸صθ  ӵųִ.̷л 
//
void Shape_checkBackFace(Shape *shape)
{

	int i;
	int triangle_n=shape->triangle_n;
	int polygon_n=shape->polygon_n;	
	
	
	Triangle *tri;
	Polygon	 *poly;

	Vector tV;
	float	tv[3];

    	for(i=0;i< triangle_n;i++)
    	{
 
		tri = &shape->triangle[i]; 

		tv[0]=tri->vertex[0].x;
		tv[1]=tri->vertex[0].y;
		tv[2]=tri->vertex[0].z;

		vectorSubtract(tv,Camera->center);
		
		
		//if(VectorDotProduct(&tV,&tri->Normal)>0) 
		if(vectorDotProduct(tv,tri->normal)>0) 
			tri->isBack=1;
		else tri->isBack=0;


    	}

///* DEL
    for(i=0;i< polygon_n;i++)
    {
 
	poly = &shape->polygon[i]; 
	
	VectorSetVector(&tV,&poly->vertex[0]);
	tv[0]=poly->vertex[0].x;
	tv[1]=poly->vertex[0].y;
	tv[2]=poly->vertex[0].z;
//	VectorSubtract(&tV,&Camera->Position);
	vectorSubtract(tv,Camera->center);

	//if(VectorDotProduct(&tV,&poly->Normal)>0) 
	if(vectorDotProduct(tv,poly->normal)>0) 
		poly->isBack=1;
	else poly->isBack=0;

    }
//*/

}


void checkBackFace()
{
    int i;
//    for(i=0;i<draw_cell_n;i++)
    for(i=0;i<LeafCellsInFOV_n;i++)
	  Shape_checkBackFace(List_LeafCellsInFOV[i]->shape);

} 


//  use radius  View
// void isHitCell(Cell *c,Line *l)
void isHitCell(Cell *c)
{
    int i;
    vector  Va[3],Vb[3],Vc[3]; 
    float   lenth;    

	    
    vectorCopy(Va,c->center);
    vectorSubtract(Va,Camera->position);

    lenth=vectorDotProduct(Va,Camera->direction);
    
    vectorCopy(Vb,Camera->direction);
    vectorScale(Vb,lenth);

    vectorCopy(Vc,Va);         
    vectorSubtract(Vc,Vb);
    lenth=vectorLength(Vc);



    if(lenth < c->radius){
	if( c->level!=LEAF )
	{
	   for(i=0;i<8;i++)
	    if(c->child[i]!=NULL)   isHitCell(c->child[i]);
	}
    
	else //BlockCells_Hit[BlockCells_Hit_N++]=c;	    
		List_ViewableCells[ViewableCells_N++]=c;
    }


}


Line current_Laser;

int    test_count;
extern Cell *HitedCell;


// Cell ﰢ  浹ߴ˻ 
//
inline int check_test(Cell *c)
{
	int i;
	Shape *shape;
	float vp[3];
	float direction[3];
	float point[3];
	float d;

	shape=c->shape;


    	Vector2vector(direction,&current_Laser.normal);
    	Vector2vector(point,&current_Laser.onPoint);

	for(i=0;i<shape->triangle_n;i++)
		if(test_intersect_triangle(&shape->triangle[i],direction,point,vp,&d)==1)
			return 1;


	return 0;
}


inline int Cell_checkIntersectWithLine(Cell *c,Line *l)
{
	int i;
	Shape *shape;
	float vp[3];
	float direction[3];
	float point[3];
	float d;

	shape=c->shape;

    	Vector2vector(direction,&current_Laser.normal);
    	Vector2vector(point,&current_Laser.onPoint);

	for(i=0;i<shape->triangle_n;i++)
		if(test_intersect_triangle(&shape->triangle[i],direction,point,vp,&d)==1)
			return 1;


	return 0;
}



//    ?  ̰ ?
inline int getHitCell_inZbuffer(Cell *c)
{
    int 	i;
    Vector 	V1,V2,V3;
    float   	lenth;    
	
    float 	distance;
    
	    
    if( c->FrameID==FrameID ) { return 0;}

    test_count++;
    //RE VectorCopy(&V1,&c->Center);
    //RE VectorSubtract(&V1,&Camera->Position);

    distance=VectorLength(&V1);
    c->distance=distance;
  

    lenth=VectorDotProduct(&V1,&current_Laser.normal);
    VectorCopy(&V2,&current_Laser.normal);
//	lenth=VectorDotProduct(&V1,&Camera->ViewDirection);
 //  	VectorCopy(&V2,&Camera->ViewDirection);
    VectorScale(&V2,lenth);
   
    
    VectorCopy(&V3,&V1);         
    VectorSubtract(&V3,&V2);
    lenth=VectorLength(&V3);
   
//    DEBUG("radius=%f  v3lenth=%f",c->radius,lenth);
//    List_ViewableCells[ViewableCells_N++]=c;		return;
    if(lenth < c->radius){
	if( c->level==LEAF )
	{
		
		if( c->shape->triangle_n >0 ) 		
		{
			
			if(check_test(c)==1){
				if( c->FrameID==FrameID ) {DEBUG("alrealdy draw");return 1;}
				HitedCell=c;
				return 1;
			}
				
			return 0;


			HitedCell=c;
			return 1;

			if(HitedCell->distance > distance)
			{
				HitedCell=c;
			}
		
			return ;
			
		}
		
	}
	else
	{
	   for(i=0;i<8;i++)
	    if(c->child[i]!=NULL)
		    getHitCell_inZbuffer(c->child[i]);
	    
	}
    
    }

    return 0;
}


Cell NullCell;
// Need Cache !!
// ϰ εģ ?  ?
//void find_HitedObjectInFOV()
void find_HitedCellsInFOV()
{

	int 	i;
	NullCell.FrameID=FrameID+1;
	NullCell.distance=6553500.0;
	HitedCell=&NullCell;
	
//	DEBUG("BlockCells_inFOV_N=%d",BlockCells_inFOV_N);
//	for(i=draw_cell_n-1 ;i<BlockCells_inFOV_N;i++)
	
	if( HitedCell->FrameID==FrameID )
			ERROR("Cell alrealdy checked ");


	test_count=0;
     	for(i=0;i<LeafCellsInFOV_n;i++)
	{
		if(List_LeafCellsInFOV[i]->Hidden==FrameID) continue;
		if(getHitCell_inZbuffer(List_LeafCellsInFOV[i])) break;
	}

//   	for(i=0;i<BlockCells_inFOV_N;i++)		getHitCell_inZbuffer(List_CellsInFOV[i]);
//		isHitCell(List_CellsInFOV[i]);



//	DEBUG("count=%d",test_count);
	if( HitedCell->FrameID==FrameID )
			ERROR("X2 alrealdy draw FrameID=%d",FrameID);


//	return ;
	if(HitedCell!=&NullCell){
		if(HitedCell==NULL) ERROR("NULL");
		List_ViewableCells[ViewableCells_N++]=HitedCell;
	  	Shape_checkBackFace(HitedCell->shape);
		Shape_DrawZbuffer(HitedCell->shape);
		HitedCell->FrameID==FrameID;
	}

	return ;

	if(draw_cell_n<1)
    	{ 
	  	DEBUG("BlockCells_Hit_N=%d",BlockCells_Hit_N);
	  	//ERROR("draw_cell_n<1");
	  	draw_cell_n=1;
		return ;
	  
    	}
 

}


extern int visiable_polygon_n;
int	total_octree_triangle=0;
int 	total_OctreeTriangle()
{
	return total_octree_triangle;    
}


init_threadfunc()
{	
    LeafCellsInFOV_n=0;
    farthest_distance=0;
    shortest_distance=30000;
    BlockCells_inFOV_N=0;
    BlockCells_inFOVUnit_N=0;

}

// ͼ ֱ !!
void cell2leaf(Cell *cell)
{
	   
	int i;

	if(cell->level == LEAF){
	 	List_LeafCellsInFOV[ LeafCellsInFOV_n++]=cell;
		return;
	}
	else 
	for(i=0;i<8;i++){
		if(cell->child[i]==NULL) continue;
		cell2leaf(cell->child[i]);
	} 

}


FOVCell2Leaf()
{
	int i;
	for(i=0;i<BlockCells_inFOV_N;i++)
		cell2leaf(List_CellsInFOV[i]);

}



int Shape_intersection_test(Shape *shape)
{
	float vp[3],d,d_short;
	int i,j;
	d_short=999999;
	
    	for(i=0;i<shape->triangle_n;i++)
	{
		if(test_intersect_triangle(&shape->triangle[i],
					Camera->direction,Camera->position,vp,&d)==1)
		{
		
			if(d_short>d  && d>0){
				return 1;				
				vector2Vector(&Camera->V1,vp);
				d_short=d;
			}

		}
		
	}


}
// cell ִ ﰢ  浹ϳ ˻ϴ° . 
//  ̰   ?
test_intersection()
{
	float vp[3],d,d_short;
    	Shape *shape;

	int i,j;

	d_short=999999;
	vector2Vector(&Camera->V1,Camera->position);

    	for(j=0;j<LeafCellsInFOV_n;j++){
		
	shape=List_LeafCellsInFOV[j]->shape;
	
    	for(i=0;i<shape->triangle_n;i++)
	{
		if(test_intersect_triangle(&shape->triangle[i],
					Camera->direction,Camera->position,vp,&d)==1)
		{
		
			if(d_short>d  && d>0){
				vector2Vector(&Camera->V1,vp);
				d_short=d;
			}

		}
		
	}

	}

}
extern unsigned short *zbuffer;
extern unsigned short *draw_zbuffer;
extern unsigned short zbuffer1[ZBUFFER_HEIGHT*ZBUFFER_WIDTH];
extern unsigned short zbuffer2[ZBUFFER_HEIGHT*ZBUFFER_WIDTH];

extern unsigned int  draw_zbuffer_hole_n,zbuffer_hole_n;
swap_test_old()
{
	   
 /*  if(list_flag==1) {
	   List_ViewableCells=List_Cells1;
	   List_DrawCells=List_Cells2;
	   zbuffer=zbuffer1;
	   draw_zbuffer=zbuffer2;
	   list_flag=2;
		   
   	
   }
    else   {
	   List_ViewableCells=List_Cells2;
	   List_DrawCells=List_Cells1;
	   zbuffer=zbuffer2;
	   draw_zbuffer=zbuffer1;
	   list_flag=1;
    }

 */
    //draw_cell_n=zbuffer_draw_cell_n;
    //draw_cell_n=BlockCells_inFOV_N;
    draw_cell_n=ViewableCells_N;
    draw_zbuffer_hole_n=zbuffer_hole_n;
	
    OK();
}

swap_test()
{

	List_ViewableCells=List_Cells1;
	List_DrawCells=List_Cells2;
	//draw_zbuffer=zbuffer2;
	list_flag=2;


	draw_cell_n=ViewableCells_N;
	draw_zbuffer_hole_n=zbuffer_hole_n;

	OK();
}


void Object_CellsInWOMB(Object *obj,Cell *cell)
{
    int i,ret;

    if(cell==NULL)  ERROR("cell=NULL !!"); //for robust

    ret=Object_CheckCellInWOMB(obj,cell);
    
    //if(ret==CHECK_FULL ||( cell->level==LEAF && ret==CHECK_PARTIAL))
    if(( cell->level==LEAF && ret==CHECK_PARTIAL))
    {
	    if(obj->CellsInWOMB_n> 60){
		    DEBUGB("too many \n"); 
		    return;
	    }
	    obj->CellsInWOMB[obj->CellsInWOMB_n++]=cell;
	    return;
    }
    
    if(ret==CHECK_PARTIAL)
    {
	    for(i=0; i< 8 ; i++)
		    if(cell->child[i]!=NULL)   Object_CellsInWOMB(obj,cell->child[i]);
	    return;
    }
}


int 	LeafCells_n=0;
Cell 	*LeafCellList[512];

// not yet implemented 
cells2leaf(Cell *cell)
{
	int i;

	if(cell->level == LEAF){
	 	LeafCellList[ LeafCells_n++]=cell;
		return;
	}
	else 
	for(i=0;i<8;i++){
		if(cell->child[i]==NULL) continue;
		cells2leaf(cell->child[i]);
	} 
}



// using leaf cell only is better ?
Find_CellsInWOMB(Object *obj,Cell *top_cell)
{
	int 	i;
	
	obj->CellsInWOMB_n=0;
	Object_CellsInWOMB(obj,top_cell);  
//	LeafCells_n=0;
//	for(i=0;i<obj->CellsInWOMB_n;i++)
//		cells2leaf(obj->CellsInWOMB[i]);
//	for(i=0;i<LeafCells_n;i++)
//		obj->CellsInWOMB[i]=LeafCellList[i];
//	obj->CellsInWOMB_n=LeafCells_n;
}



//  cells in DOV : direction_of_View 
Find_CellsInFOV()
{
   
    	BlockCells_inFOV_N=0; // -> just CellsInFoV_n
    	LeafCellsInFOV_n=0;

      	findCellsInFOV(octree_top);   	//  get only Cells InFOV !!
	// FindCellsInDOV();
	// 


	
	
	// qsort   result -> List_CellsInFOV[] number=?
	// rule 1. the first cells must be drawn !!  think about it !!
	// rule 2. 
	// 	   
	// 	find the cells's  2d position( center of the cell) 
	//	if the 2d position point's color does'not exist then must drawn !!
	// 
	// sortVisiableCells2();
	sortCells3();   

	
	// ̷ ϸ ӵ ʳ ? 
	// óϱ.. ѹغ.
	FOVCell2Leaf(); 

//	checkBackFace();

}


void Shape_checkBackFace(Shape *shape);


//  leafCells δٰ  ~
void All_leafCells_visiable()
{
	int i;
	for(i=0;i<LeafCellsInFOV_n;i++)
	{
		List_ViewableCells[i]=List_LeafCellsInFOV[i];
	  	Shape_checkBackFace(List_ViewableCells[i]->shape);
	}
	ViewableCells_N=LeafCellsInFOV_n;		
}


//decal(point p[3],vector normal[3])


Octree_FindCurrentNode()
{
    int i;
//Best CODE
    for(i=0;i<MAX_OBJECTS;){
	if(Objects[i]==NULL ) continue;
//	FindCurrentUnitBlockCell(octree_top,Objects[i++]);
    }
}
     
  		


BlockCell_Makeconner(Cell *cell)
{
    Vector V1,V2;
    cell->conner[DBL][0]=cell->min_x;
    cell->conner[DBL][1]=cell->min_y;
    cell->conner[DBL][2]=cell->min_z;

    cell->conner[DBR][0]=cell->max_x;
    cell->conner[DBR][1]=cell->min_y;
    cell->conner[DBR][2]=cell->min_z;

    cell->conner[DFL][0]=cell->min_x;
    cell->conner[DFL][1]=cell->min_y;
    cell->conner[DFL][2]=cell->max_z;

    cell->conner[DFR][0]=cell->max_x;
    cell->conner[DFR][1]=cell->min_y;
    cell->conner[DFR][2]=cell->max_z;


    cell->conner[UBL][0]=cell->min_x;
    cell->conner[UBL][1]=cell->max_y;
    cell->conner[UBL][2]=cell->min_z;

    cell->conner[UBR][0]=cell->max_x;
    cell->conner[UBR][1]=cell->max_y;
    cell->conner[UBR][2]=cell->min_z;

    cell->conner[UFL][0]=cell->min_x;
    cell->conner[UFL][1]=cell->max_y;
    cell->conner[UFL][2]=cell->max_z;

    cell->conner[UFR][0]=cell->max_x;
    cell->conner[UFR][1]=cell->max_y;
    cell->conner[UFR][2]=cell->max_z;

    cell->cx=(cell->min_x+cell->max_x)/2;
    cell->cy=(cell->min_y+cell->max_y)/2;
    cell->cz=(cell->min_z+cell->max_z)/2;

    cell->center[0]=(cell->min_x+cell->max_x)/2;
    cell->center[1]=(cell->min_y+cell->max_y)/2;
    cell->center[2]=(cell->min_z+cell->max_z)/2;

    cell->Center.x=(cell->min_x+cell->max_x)/2;
    cell->Center.y=(cell->min_y+cell->max_y)/2;
    cell->Center.z=(cell->min_z+cell->max_z)/2;


    
	
   /* 
    DEBUG("level=%d",cell->level);
    DEBUG("min_x=%f,max_x=%f",cell->min_x,cell->max_x);
    DEBUG("min_y=%f,max_y=%f ",cell->min_y,cell->max_y);
    DEBUG("min_z=%f,max_z=%f ",cell->min_z,cell->max_z);
    DEBUG("Center x=%f,y=%f z=%f",cell->Center[0],cell->Center[1],cell->Center[2]);
    DEBUG("connerUFR x=%f,y=%f z=%f", cell->conner[UFR][0],  cell->conner[UFR][1],   cell->conner[UFR][2]);
*/
   //vectorCopy(tv,cell->conner[UFR]);
    vector2Vector(&V1,cell->conner[UFR]);
    vector2Vector(&V2,cell->center);
    VectorSubtract(&V1,&V2);
    cell->radius=VectorLength(&V1);
//    printf("l=%d,radius=%f\n",cell->level,cell->radius);
//    cell->radius=4;

}

Cell * New_OctreeNode(Cell *p,int position)
{

	Cell *t;
	int i;

        t=malloc(sizeof(Cell));
	
	t->parent=p;
	t->shape=NULL;
	
	for(i=0 ; i<8 ; i++)
	    t->child[i]=NULL;
	
        
	if(p==NULL) 	t->level=0;
        else    t->level=p->level+1;

// Dont need	if(t->shape==NULL)		t->shape=New_Shape();

    switch(position)
    {
        case UFR:  //proved
	    t->max_x=p->max_x;
	    t->max_y=p->max_y;
	    t->max_z=p->max_z;
	    t->min_x=p->cx;
	    t->min_y=p->cy;
	    t->min_z=p->cz;
	    break;
	case UFL: //proved
	    t->max_x=p->cx;
	    t->max_y=p->max_y;
	    t->max_z=p->max_z;
	    t->min_x=p->min_x;
	    t->min_y=p->cy;
	    t->min_z=p->cz;
	    break;
	case UBR: 
	    t->max_x=p->max_x;
	    t->max_y=p->max_y;
	    t->max_z=p->cz;
	    t->min_x=p->cx;
	    t->min_y=p->cy;
	    t->min_z=p->min_z;
	    break;
	    
	case UBL: 
	    t->max_x=p->cx;
	    t->max_y=p->max_y;
	    t->max_z=p->cz;
	    t->min_x=p->min_x;
	    t->min_y=p->cy;
	    t->min_z=p->min_z;
	    break;

	case DFR: 
	    t->max_x=p->max_x;
	    t->max_y=p->cy;
	    t->max_z=p->max_z;
	    t->min_x=p->cx;
	    t->min_y=p->min_y;
	    t->min_z=p->cz;
	    break;
	case DFL: 
	    t->max_x=p->cx;
	    t->max_y=p->cy;
	    t->max_z=p->max_z;
	    t->min_x=p->min_x;
	    t->min_y=p->min_y;
	    t->min_z=p->cz;
	    break;
	case DBR: 
	    t->max_x=p->max_x;
	    t->max_y=p->cy;
	    t->max_z=p->cz;
	    t->min_x=p->cx;
	    t->min_y=p->min_y;
	    t->min_z=p->min_z;
	    break;
	    
	case DBL: //proved
	    t->max_x=p->cx;
	    t->max_y=p->cy;
	    t->max_z=p->cz;
	    t->min_x=p->min_x;
	    t->min_y=p->min_y;
	    t->min_z=p->min_z;
	    break;
	default :
    		
	    t->uid=999;
	    return t;

    }
    
	    
//    t->id=position;   ?

	//DEBUG("level=%d  :min_x=%f,max_x=%f",p->level,p->min_x,p->max_x);
        BlockCell_Makeconner(t);
    
    return t;
}







int *z_sorted_id;
int *x_sorted_id;
int *y_sorted_id;

float min_z,max_z, min_y,max_y, min_x,max_x;

//    ? shape ٿ彺Ǿ ϴ°;ƴ 
Shape_getBound(Shape *shape)
{

	int i,tmp_id,number;
	float f;

	int polygon_n=shape->polygon_n;
	int triangle_n=shape->triangle_n;


	Triangle *tri= shape->triangle;
	Polygon  *poly= shape->polygon;
	Polygon  P;


	if(polygon_n >0 && triangle_n >0 ) 
		ERROR("polygon_n ,triangle_n >0 !!");


	if(polygon_n >0  ) 
		number=polygon_n;

	if(triangle_n >0  ) 
		number=triangle_n;


	max_z=-999;min_z=999;
	max_y=-999;min_y=999;
	max_x=-999;min_x=999;


	for ( i = 0; i < number; i++ )
	{ 


		if(triangle_n>0) Triangle2Polygon(&tri[i],&P);
		else PolygonCopy(&P,&poly[i]);	    

		f=P.vertex[0].z;
		if( f < min_z) min_z=f;
		if( f > max_z) max_z=f;

		f=P.vertex[1].z;
		if( f < min_z) min_z=f;
		if( f > max_z) max_z=f;

		f=P.vertex[2].z;
		if( f < min_z) min_z=f;
		if( f > max_z) max_z=f;

	}

	for ( i = 0; i < number; i++ )
	{

		if(triangle_n>0) Triangle2Polygon(&tri[i],&P);
		else PolygonCopy(&P,&poly[i]);	    
		f=P.vertex[0].y;
		if( f < min_y) min_y=f;
		if( f > max_y) max_y=f;

		f=P.vertex[1].y;
		if( f < min_y) min_y=f;
		if( f > max_y) max_y=f;

		f=P.vertex[2].y;
		if( f < min_y) min_y=f;
		if( f > max_y) max_y=f;


	}

	for ( i = 0; i < number; i++ )
	{
		if(triangle_n>0) Triangle2Polygon(&tri[i],&P);
		else PolygonCopy(&P,&poly[i]);	    

		f=P.vertex[0].x;
		if( f < min_x) min_x=f;
		if( f > max_x) max_x=f;

		f=P.vertex[1].x;
		if( f < min_x) min_x=f;
		if( f > max_x) max_x=f;

		f=P.vertex[2].x;
		if( f < min_x) min_x=f;
		if( f > max_x) max_x=f;

	}
	shape->min_x= min_x,shape->max_x=max_x;
	shape->min_y= min_y,shape->max_y=max_y;
	shape->min_z= min_z,shape->max_z=max_z;
}

get_max_level(Cell *top)

{
    int i,level=0;
    float lenth,hlenth,cx,cy,cz;
    
    lenth=max_x-min_x;
    for(i=0;i<8;i++){
//del	printf("i=%d,1<<i=%d,size=%f\n",i,1<<i,(1<<i)*cell_size);
	if(lenth<(1<<i)*cell_size){
	     level=i;
	     break;
	}
    }
    lenth=max_y-min_y;
    //printf("length=%f\n",lenth);
    for(i=0;i<8;i++)
	 if(lenth<(1<<i)*cell_size){
	     if(level<i) level=i;
	     break;
	 }

    lenth=max_z-min_z;
    //printf("length=%f\n",lenth);
    for(i=0;i<8;i++)
	 if(lenth<(1<<i)*cell_size){
	     if(level<i) level=i;
	     break;
	 }

    printf("level=%d\n",level);

    cx=(min_x+max_x)/2;
    cy=(min_y+max_y)/2;
    cz=(min_z+max_z)/2;


    hlenth=cell_size*(1<<level)/2;
    top->min_x=cx - hlenth ;
    top->max_x=cx + hlenth ;
    top->min_y=cy - hlenth ;
    top->max_y=cy + hlenth;
    top->min_z=cz - hlenth ;
    top->max_z=cz + hlenth;

    octree_level=level;
}



// з 
int triangle_state;
int result[64]; 
Polygon ClustTriangle[64];


//#define FRONT 1
int  ClassifyVertex(Plane *P,Vector *V)
{

	float d;

	// this code for -> where is vertex ?  front of the plane  or back ?
	d=VectorDotProduct(&P->normal,V);
	d-=P->distance;

	if( d>=EPSILON) 
		return FRONT;

	if( d>-EPSILON && d<EPSILON ) 
		return ONPLANE;

	return BACK;

}


int PolygonCheckIsLine(Polygon *p)
{
	Vector V1,V2,V3;
	int i;

	if(p->vertex_n<3){
		// DEBUG("it's just vertex  < 3"); maybe not a polygon ,just line 
		return 1;
	}
	
	for(i=0;i<p->vertex_n-2;i++){
		VectorSetVector(&V1,&p->vertex[i]);
		VectorSetVector(&V2,&V1);
		VectorSubtract(&V1,&p->vertex[i+1]);
		VectorSubtract(&V2,&p->vertex[i+2]);
		VectorCrossProduct(&V3,&V1,&V2);
		if(VectorLength(&V3)!=0) return 0;
	}
	return 1;
}



int frontX=0;

// Dont need SpeedOptimize !!
// ߻:1. ﰢ̾ƴ ̷ִ ->  
//
inline int PlaneSplitTriangle(Plane *P,Polygon *T,Polygon *f,Polygon *b)
{

	int Positions[32];
	Vector V,Vt,V1,V2,V3;
	float du,dv,denom,p;
	Line L;
	int i,m,n,Ignore;
	
//    	START();

	f->vertex_n=0;
	b->vertex_n=0;
	

	if(T->vertex_n<3) ERROR("3 !!!");


	
	// why this should be here ? ??????????????????????????????????????
	//if(PolygonCheckIsLine(T) && ){
	//
	// ------> maybe don't need this.
	if((PolygonSortVertex(T)==0)){
		DEBUG("T -> is a line !!!");			
		return;
	}


	for(i=0 ; i<T->vertex_n; i++)
		Positions[i]=ClassifyVertex(P,&T->vertex[i]);

	// normal  	
 	VectorCopy(&f->Normal,&T->Normal);
	VectorCopy(&b->Normal,&T->Normal);
	
	vectorCopy(f->normal,T->normal);
	vectorCopy(b->normal,T->normal);

	PolygonSortVertex(T);
	f->texture_id=T->texture_id;
	b->texture_id=T->texture_id;

	for(n=0 ; n< T->vertex_n; n++)
	{
		m=n+1;
		Ignore=0;
		if(n==T->vertex_n-1) m=0;

		switch(Positions[n])
		{
			case FRONT :
				Polygon_AddVertex(f,&T->vertex[n]);
				break;
			case BACK :
				Polygon_AddVertex(b,&T->vertex[n]);
				break;
				
			case ONPLANE:
				Polygon_AddVertex(f,&T->vertex[n]);
				Polygon_AddVertex(b,&T->vertex[n]);
				break;
				
		}

		
		if ( ( Positions[ n ] == ONPLANE ) && ( Positions[ m ] != ONPLANE ) ) 
		{ Ignore = 1; } 
		
		if ( ( Positions[ n ] != ONPLANE ) && ( Positions[ m ] == ONPLANE ) ) 
		{ Ignore = 1; }

		if ( ( !Ignore ) && ( Positions[ n ] != Positions[ m ] ) ) 
		{ 
			LineSetVector(&L,&T->vertex[n],&T->vertex[m]);
			
			if(VectorIntersectionLinePlane(&V,&L,P)==0){
				// no nedd ~ dummy code !
				DEBUG("oops ! line & plane are perpendicular !!");
				continue;
			}

		
			// question )  there are two points , A and B 
			//  find the center point C of these points 
			//  
			//  sol)    C=(A+B)/2 
			//
			//  how can you prove this methode ?
			//  
			//  and How can you find  1/3 point from A to B ?
			//  
			// 
			VectorSetVector(&Vt,&T->vertex[m]);
			VectorSubtract(&Vt,&T->vertex[n]);
			
			denom=VectorLength(&Vt);

			VectorSetVector(&Vt,&V);
			VectorSubtract(&Vt,&T->vertex[n]);
			
			p=VectorLength(&Vt);

			p=p/denom;

		

			du=T->vertex[m].u - T->vertex[n].u;
			dv=T->vertex[m].v - T->vertex[n].v;


		//	DEBUG("du=%f",du);
		//	if(du>1) DEBUG("?????????????????du");
		//	if(dv>1) DEBUG("?????????????????dv");
			
			V.u=T->vertex[n].u+(p*du); 
			V.v=T->vertex[n].v+(p*dv); 


			Polygon_AddVertex(f,&V);
			Polygon_AddVertex(b,&V);
		}
	
	
	}


		
	// Robust Code !!
	// remove when polygon is line OR not polygon

	/*	
	if(PolygonCheckIsLine(f)){
		//DEBUG(" f -> is a line !!!");			
		f->vertex_n=0;
	}
	if(PolygonCheckIsLine(b)){
		//DEBUG(" b -> is a line !!!");			
		b->vertex_n=0;
	} */

	if(PolygonSortVertex(f)==0) 	f->vertex_n=0;
	if(PolygonSortVertex(b)==0) 	b->vertex_n=0;
		

//	OK();
}


inline void Classify_Polygon(Cell *cell,Polygon *T)
{
    int i,face_n,j,k,l,n;

    Polygon up,down,front,back,left,right;

    Plane ZX,XY,YZ;
    Vector P,Normal;

    P.y=cell->cy;
    P.z=cell->cz;
    P.x=cell->cx;

//    START();
    VectorSet(&Normal,0,1,0); // y
    PlaneSetNormalVertex(&ZX,&Normal,&P);
    VectorSet(&Normal,0,0,1); // z
    PlaneSetNormalVertex(&XY,&Normal,&P);
    VectorSet(&Normal,1,0,0); // x 
    PlaneSetNormalVertex(&YZ,&Normal,&P);
    
    
    face_n=0;

    //Dont remove !! Robust Code
    if((PolygonSortVertex(T)==0)){
		DEBUG("Z -> is a line !!!");			
		return;
	
    }

    PlaneSplitTriangle(&ZX,T,&up,&down);
    
    if(up.vertex_n>=3)  // UP
    {
    	PlaneSplitTriangle(&XY,&up,&front,&back);

	if(front.vertex_n>=3)
	{
		// Front
    		PlaneSplitTriangle(&YZ,&front,&right,&left);

		if(right.vertex_n>=3) //Right
		{
			PolygonCopy(&ClustTriangle[face_n],&right);
			result[face_n++]=UP_FRONT_RIGHT;
		}

		if(left.vertex_n>=3) //Left
		{
			PolygonCopy(&ClustTriangle[face_n],&left);
			result[face_n++]=UP_FRONT_LEFT;
		}
			
		
	}

	if(back.vertex_n>=3) // Back
	{
    		PlaneSplitTriangle(&YZ,&back,&right,&left);

		if(right.vertex_n>=3) //Right
		{
			PolygonCopy(&ClustTriangle[face_n],&right);
			result[face_n++]=UP_BACK_RIGHT;
		}

		if(left.vertex_n>=3) //Left
		{
			PolygonCopy(&ClustTriangle[face_n],&left);
			result[face_n++]=UP_BACK_LEFT;
		
		}
			
	}



    } 
   

    if(down.vertex_n>=3)  // Down
    {
    	PlaneSplitTriangle(&XY,&down,&front,&back);

	if(front.vertex_n>=3)
	{
		// Front
    		PlaneSplitTriangle(&YZ,&front,&right,&left);

		if(right.vertex_n>=3) //Right
		{
			PolygonCopy(&ClustTriangle[face_n],&right);
			result[face_n++]=DOWN_FRONT_RIGHT;
		}

		if(left.vertex_n>=3) //Left
		{
			PolygonCopy(&ClustTriangle[face_n],&left);
			result[face_n++]=DOWN_FRONT_LEFT;
		}
			
		
	}

	if(back.vertex_n>=3) // Back
	{
    		PlaneSplitTriangle(&YZ,&back,&right,&left);
		
		if(right.vertex_n>=3) //Right
		{//
			PolygonCopy(&ClustTriangle[face_n],&right);
			result[face_n++]=DOWN_BACK_RIGHT;
		}

		if(left.vertex_n>=3) //Left
		{
			PolygonCopy(&ClustTriangle[face_n],&left);
			result[face_n++]=DOWN_BACK_LEFT;
		}
			
	
	}


    }

    triangle_state=face_n;
//    OK();
}




int get_ShapeTriangleN(Shape *shape)
{
	int i,n;
	n=0;
   	for(i=0 ; i< shape->polygon_n; i++)
		n+=(shape->polygon[i].vertex_n-2);
	

	return n;
	
}

int cell_uid=0;
//   IDο 
//  parent 忡 shape ܵ -> clean XXX   Ƴ ?  
// super dirty code !!
Build_Octree(Cell *cell,Shape *shape) 
{
	int i,j,number;
	int polygon_n=shape->polygon_n;
	int triangle_n=shape->triangle_n;

	Shape *shape_child[8];
	Triangle *tri= shape->triangle;
	Polygon  *poly= shape->polygon;
	Polygon  P;

	if(triangle_n >0) 
		ERROR("tri>0");

	//    DEBUG("id=%d   Level(%d) : shape->triangle_n = %d \n",cell->id,cell->level,shape->triangle_n);
	//    DEBUG("Level(%d) : shape->polygon_n = %d \n",cell->level,shape->polygon_n);
	//    DEBUG(" here !! 1 ");

	if( cell->level == octree_level) 
		//  if(get_ShapeTriangleN(shape) < octree_thredhold_triangle_n 
		//  && cell->level == octree_level) 
	{
		cell->level=LEAF;
		cell->shape=shape; 
		cell->uid=cell_uid++;
		return;
	}

	if( polygon_n >0 ) 
		number=polygon_n;

	for(i=0 ; i<8 ; i++)
		shape_child[i]=New_Shape();

    
    for(i=0 ; i< number; i++){
	    Classify_Polygon(cell,&poly[i]);
	
	    for(j=0 ; j< triangle_state  ; j++)
	    {
		    switch (result[j])
      		    {
			    case UP_FRONT_RIGHT:
				    Shape_AddPolygon(shape_child[UFR],&ClustTriangle[j]);
				    break;

			    case UP_FRONT_LEFT:
				    Shape_AddPolygon(shape_child[UFL],&ClustTriangle[j]);
				    break;
         
			    case UP_BACK_RIGHT:
					
				    Shape_AddPolygon(shape_child[UBR],&ClustTriangle[j]);
				    break;
         
			    case UP_BACK_LEFT:
				    Shape_AddPolygon(shape_child[UBL],&ClustTriangle[j]);
				    break;
         
			    case DOWN_FRONT_RIGHT:
				    Shape_AddPolygon(shape_child[DFR],&ClustTriangle[j]);
				    break;				   
			    case DOWN_FRONT_LEFT:	    
				    Shape_AddPolygon(shape_child[DFL],&ClustTriangle[j]);            
				    break;
         
			    case DOWN_BACK_RIGHT:
				    Shape_AddPolygon(shape_child[DBR],&ClustTriangle[j]);
				    break;
			    case DOWN_BACK_LEFT:
				    Shape_AddPolygon(shape_child[DBL],&ClustTriangle[j]);
				    break;
			    default:
				    printf("other %d\n",result);
      	
		    }
	    }

    }


    for(i=0;i<8; i++)
    {
	    //   cell->child[i] = New_OctreeNode(tree,i);
	    // Build_Octree (cell->child[i], shape_child[i]);

	    if (shape_child[i]->polygon_n || shape_child[i]->triangle_n)
	    {
		    cell->child[i] = New_OctreeNode(cell,i);
		    Build_Octree (cell->child[i], shape_child[i]);
	    }
	    else{
		    cell->child[i]=NULL;
		    //cell->child[i] = New_OctreeNode(tree,i);
		    Shape_Remove(shape_child[i]);
	    } 
    }
    

//    Shape_Remove(shape);
//    DEBUG(" here !! 4 ");
    
}




int Polygon2Triangle(Polygon *p,Triangle *t);
//  ?
Shape_Polygon2Triangle(Shape *s)
{
	Triangle tri[32];
	int i,n,j;
	
	if(s->polygon==NULL) 	ERROR("NULL!!");
	if(s->polygon_n==0) 	ERROR("0");

	for(i=0; i< s->polygon_n; i++)
	{
		n=Polygon2Triangle(&s->polygon[i],tri);
		for(j=0;j<n;j++)   
			Shape_AddTriangleStatic(s,&tri[j]);
	}
	
	//⼭  polygon shape ־ϴ° Ƴ ?	
	Shape_PolygonRemove(s);
}


Octree_Polygon2Triangle(Cell *cell)
{
	
	int i;

	if(cell->level == LEAF){
		Shape_Polygon2Triangle(cell->shape);
	//	Console_printf("cell_n=%d",0);
	    	total_octree_triangle+=cell->shape->triangle_n;
		return;
	}
	else 
	for(i=0;i<8;i++){
		if(cell->child[i]==NULL) continue;
		Octree_Polygon2Triangle(cell->child[i]);
	} 
	// ڽĿ  й 
	// ̰  LEAF polygon  
	// 밡  .
	Shape_PolygonRemove(cell->shape);
}



void MakeOctreeMap(Shape *m)
{
    Cell *top;
    top=New_OctreeNode(NULL,100);

    Shape_getBound(m);

    top->min_x=m->min_x;
    top->max_x=m->max_x;
    top->min_y=m->min_y;
    top->max_y=m->max_y;
    top->min_z=m->min_z;
    top->max_z=m->max_z;

    get_max_level(top); //  ƽ ϱε

    BlockCell_Makeconner(top);
    Build_Octree(top,m);
    octree_top=top;

    total_octree_triangle=0;

    //octreeɰⰡ Ŀ triangleȯ.
    Octree_Polygon2Triangle(top);
    
    OK();
}


get_map_size_byindex_vertexSort(Shape *m)
{

    int *sorted_id;    
    int loop,i,tmp_id;
    int vertex_n=m->vertex_n;
    int sorted,id,next_id;

    Vertex *vertex=m->vertex;
    Vertex *tmp_vertex;


    sorted_id=malloc( sizeof(int)* vertex_n);

    for ( loop = 0; loop < vertex_n; loop++ )
	sorted_id[loop]=loop;


    do
    {
      sorted = 1;
      for ( i = 0; i < vertex_n; i++ )
      {
        id=sorted_id[i]; 
        next_id=sorted_id[i+1];

	if ( vertex[ next_id ].z > vertex[ id ].z )
	{
	tmp_id = id;
	sorted_id[i]= next_id;
	sorted_id[i+1]= tmp_id;


	tmp_vertex= &vertex[i];
	vertex[i] = vertex[i+1];
////	vertex[i+1]= tmp_vertex;
	
    	sorted = 0;
	}
      }
    } 
    while ( sorted == 0 );


    z_sorted_id=sorted_id;
    sorted_id=malloc( sizeof(int)* vertex_n);

    for ( loop = 0; loop < vertex_n; loop++ )
	sorted_id[loop]=loop;

//    octree_root.min_z=
//    octree_root.min_y=
//    octree_root.min_x=
//    octree_root.max_z=
//    octree_root.max_y=
//    octree_root.max_x=
    

}



get_shape_bound_byindex(Shape *m)
{

    int *sorted_id;    
    int loop,i,tmp_id,tri_n;
    float f;

    Triangle *tri;


    
    tri=m->triangle;
    tri_n=m->polygon_n;
    
    max_z=min_z=tri[0].vertex[0].z;
    max_y=min_y=tri[0].vertex[0].y;
 
    max_x=min_x=tri[0].vertex[0].x;


    for ( i = 0; i < tri_n; i++ )
      {
	f=tri[i].vertex[0].z;
	if( f < min_z) min_z=f;
	if( f > max_z) max_z=f;

	f=tri[i].vertex[1].z;
	if( f < min_z) min_z=f;
	if( f > max_z) max_z=f;

	f=tri[i].vertex[2].z;
	if( f < min_z) min_z=f;
	if( f > max_z) max_z=f;

      }

    for ( i = 0; i < tri_n; i++ )
      {
	f=tri[i].vertex[0].y;
	if( f < min_y) min_y=f;
	if( f > max_y) max_y=f;

	f=tri[i].vertex[1].y;
	if( f < min_y) min_y=f;


	if( f > max_y) max_y=f;

	f=tri[i].vertex[2].y;
	if( f < min_y) min_y=f;
	if( f > max_y) max_y=f;


      }

    for ( i = 0; i < tri_n; i++ )
      {
	f=tri[i].vertex[0].x;
	if( f < min_x) min_x=f;
	if( f > max_x) max_x=f;

	f=tri[i].vertex[1].x;
	if( f < min_x) min_x=f;
	if( f > max_x) max_x=f;

	f=tri[i].vertex[2].x;
	if( f < min_x) min_x=f;
	if( f > max_x) max_x=f;

      }

}

float *ZP[16];
int ZPsize[16];


void initZP()
{
	int i;
	long size;
	for(i=0;i<11; i++){
//		ZPsize[i]=powl(2,i);
///		size= ZPsize[i]*ZPsize[i];
//		ZP[i]=xmalloc(size);
	}
	
	
}

//float ZP[1024*1024];

void MakeZP()
{
	int i,j,k,w,h;

	float large_value=999;
	int size;	
	int smaller_size;
	// size>>1;
	smaller_size=size>>1;

	for(i=0;i<11; i++){
	    for(h=0;h<ZPsize[i];h++)	
		for(w=0;w<ZPsize[i];w++);
//			ZP[i][w][h]=1;
	    //getLarge;


	}
	
}
	

int isOccluded(Cell *node)
{



}
			
void ProcessOctreeNode(Cell *node)
{
	if(isOccluded(node)) return;
	

	Shape_Draw(node->shape);
//	Draw_BlockCells
}
/*	   if(node->child[i]->min_y < p->y && p->y < node->child[i]->max_y )
	    if(node->child[i]->min_z < p->z && p->z < node->child[i]->max_z )

		if(octree_level< node->level)
		    return node;
		else FindBoundOctreeNode(node->child[i],p);	
	}
	else   return NULL;


   for(i=0 ; i< 8 ; i++){
	 if(node->child[i]==NULL) continue;
	  if(node->cx < p->x && p->x < node->child[i]->max_x )
	   if(node->child[i]->min_y < p->y && p->y < node->child[i]->max_y )
	    if(node->child[i]->min_z < p->z && p->z < node->child[i]->max_z )

		if(octree_level< node->level)
		    return node;
		else FindBoundOctreeNode(node->child[i],p);	
	}
	else   return NULL;
*/


