#include "que.h"

/*    
 *    general_que  v0.01
 *    
 *    Լ̸ ӽ.
 *    QUE_XXX -> Que_XXX ɼ
 *
 *    TODO :
 *    	1.  ɰ
 */ 


QUE * New_QUE(int size)
{
	QUE *q;
	q=malloc(sizeof(QUE));

	q->buffer=malloc(size);
	q->front=0;
	q->rear=0;
	q->size=size;
	
	return q;
}

STACK * New_STACK(int size)
{
	STACK *s;
	s=malloc(sizeof(STACK));

	s->buffer=malloc(size);
	s->top=0;
	s->byte_n=0;
	s->size=size;
	
	return s;
}
inline int STACK_Push_BYTE(STACK *s,char b)
{
	register int top;
	char out;
	top=s->top;
	if(s->byte_n == s->size ) return FAIL; // no space
	s->buffer[top]=b;
	
	s->top++;
	s->byte_n++;
	
	return 1;	
}
	
inline int STACK_Pop_BYTE(STACK *s,char *b)
{
	register int top;
	char out;
	top=s->top;
	if(top == 0 ) return FAIL; // no data
	*b=s->buffer[top-1];
	s->top--;
	s->byte_n--;
}

inline int STACK_Pop(STACK *s,char *buff,int size)
{

	int i;
	if(s->size < size) return FAIL;
	for(i=0;i<size;i++)
		STACK_Pop_BYTE(s,&buff[i]);
		
}
	


//: ť ִ Ÿũ 
int QUE_getDataSize(QUE *q)
{
	int size;

	size=q->rear - q->front  ;

	if(size < 0)  // 512  + (2 - 3 )
		return (q->size + size);
	
	return size;
}


int QUE_getFreeSize(QUE *q)  //׻  1Ʈ Ѵ.
{
	int size;

	size= q->rear - q->front + 1;

//	if(size==0 ) return q->size; 

	if(size > 0) // 512 -  (511-0)
		return (q->size - size);    //    OK
	
	if(size < 0)
		return (- size);
}

int QUE_IncFront(QUE *q)
{
	q->front++;
	q->front= q->front % q->size;
}

int QUE_IncRear(QUE *q)
{
	q->rear++;
	q->rear= q->rear % q->size;
}


//̰ ڳ.
inline int QUE_Add_BYTE(QUE *q,char b)
{
	register int rear;

	if(QUE_getFreeSize(q)==0 ) return FAIL;
	
	rear= q->rear;

	q->buffer[rear]=b;

	// 1 
	rear++;
	q->rear= rear % q->size;
	return 1;
}

inline int QUE_Pull_BYTE(QUE *q,char *b)
{
	register int front;
	char out;
	
	if(QUE_getDataSize(q)==0 ) return FAIL;
	front= q->front;
	*b=q->buffer[front];

	// 1 
	front++;
	q->front= front % q->size;
	return 1;
}


// pullʰ ׳  ش.         
// -- BEST Function !!! wonderfull....
inline int QUE_Show_BYTE(QUE *q,char *b,int pos)
{
	register int pointer;
	char out;
	
	
	if(QUE_getDataSize(q) < pos) return FAIL;
		// 1.   1byte , pos=0϶ 

	pointer= q->front + pos; 
	pointer= pointer % q->size;
	*b=q->buffer[pointer];
	
	//  
	// 1.  front < rear 
	// 2.  front == rear   :  
	// 3   rear  < front 
	return 1;
}



//ϰ ,ʼ    Que_Push 
int QUE_Add(QUE *q,char *buff,int size) 
{
	int i;
	
	if(QUE_getFreeSize(q)<size ) return FAIL;
	for(i=0;i<size;i++)
		QUE_Add_BYTE(q,buff[i]);

	printf("ok add %d \n",size);
	return 1;
}

int QUE_AddQ(QUE *q,QUE *source_q,int size) 
{
	int i;
	char byte;
	if(QUE_getFreeSize(q)<size  ||  QUE_getDataSize(source_q)<size )
	{
		printf( "QUE_AddQ : error !\n");
		exit(1);	
		return FAIL; // ̾  
	}
	
	for(i=0;i<size;i++)
	{
		QUE_Pull_BYTE(source_q,&byte);
		QUE_Add_BYTE(q,byte);
	}
	return 1;
}


// n ̾Ƴũ, out,ҹ ,ϰ ̾Ƴũ 
int QUE_Pull(QUE *q,char *out,int size)
{
//	if(QUE_getDataSize(q)<size ) return FAIL;
	int i;
	for(i=0;i<size;i++)
		if(QUE_Pull_BYTE(q,&out[i])==0) break;

	
//	printf("ok del %d \n",size);
//	printf("QUE_getDataSize()=%d\n",QUE_getDataSize(q));
	return i;
}

int QUE_Show(QUE *q,char *out,int size)
{
//	if(QUE_getDataSize(q)<size ) return FAIL;
	int i;
	for(i=0;i<size;i++)
		if(QUE_Show_BYTE(q,&out[i],i)==0) break;
	
	return i;
}



void que_test()
{
	int i,r;
	char in[1024];
	char out[512];
	
	int in_size;
	int out_n;
	int out_pos=0;
	int in_pos=0;
	int tmp;
	
	QUE *que;

	for(i=0;i<1024;i++) 
		in[i]=i%50;  	// 0 1023迭 
	
	que=New_QUE(130);  //ť  Ҵ 
	
	
	if(QUE_Add(que,&in[in_pos],100)==1) in_pos+=100; 

	QUE_Pull(que,&out[out_pos],80);	out_pos+=80;

	if(QUE_Add(que,&in[in_pos],100)==1)  in_pos+=100;
	QUE_Pull(que,&out[out_pos],90);	out_pos+=90;

	if(QUE_Add(que,&in[in_pos],70)==1)  in_pos+=70;
	QUE_Pull(que,&out[out_pos],40);	out_pos+=40;



	
	if(QUE_Add(que,&in[in_pos],70)==1)  in_pos+=70;
	QUE_Pull(que,&out[out_pos],tmp=QUE_getDataSize(que));
	out_pos+=tmp;

	
	if(QUE_Add(que,&in[in_pos],90)==1)  in_pos+=90;
	QUE_Pull(que,&out[out_pos],80);	out_pos+=80;

	if(QUE_Add(que,&in[in_pos],20)==1)  in_pos+=20;
	QUE_Pull(que,&out[out_pos],tmp=QUE_getDataSize(que));
	out_pos+=tmp;


	for(i=0;i<out_pos;i++)printf("out[%d]=%d\n",i,out[i]);


	printf("debug :2 QUE_getDataSize()=%d\n",QUE_getDataSize(que));
	printf("debug :2 QUE_getFreeSize()=%d\n",QUE_getFreeSize(que));

/*	for(i=0;i<30;i++)
		r=rand()%1000;
		if(add_que(in,r)==0){
			out_n=get_que(out,sizeof(out));
		}

*/

	exit(1);
}

