#include "define.h"
//#include "core.h"
#include "network.h"


#define MAX_CLIENT	128

//Uint32 game_timer=0;
int server_game_timer=0;
struct s_client {
	int	active;
	char 	name[128];
	
//	int	uid;		// unique player ID
	Uint32	host;
	IPaddress ip;
	int	seq;
	int	loss;
	int	misc;

	char	os[128];
	char    gl_driver[128];
	int	fps;
	
	int	hit_n;
	Uint16	hit_damage;
	Sint16	hit_joint;

	int 	last_packet_uid;
	UDPsocket udp_socket;
	TCPsocket tcp_socket;

} client_list[MAX_CLIENT];

int		client_n=0;

struct s_player {
	int	active;	
	int	client_id;
	char 	name[128];
	int	uid;		// unique player ID
	
	int	life;
	int	money;
	int	kill;
	int	death;
	
	int	hit_n;
	Uint16	hit_damage;
	Sint16	hit_joint;

	int	packet;
	Packet_UDP  data;
} player_list[MAX_CLIENT];

int		player_n=0;

Packet_Client_Info client_info[MAX_CLIENT];


Uint16 		port;

IPaddress 	ip,*remoteip;
TCPsocket 	server_socket;
SDLNet_SocketSet  server_tcp_set;
SDLNet_SocketSet  server_udp_set;


Packet_Info	*packet_info;
//del Packet_Info	packet_info_out;

int		out_n=0;
Packet_UDP	packet_out[MAX_CLIENT];
//del Packet_UDP	*data_in;

UDPpacket 	*udp_in, *udp_out;
UDPsocket	server_udp_socket;


char 		recv_buffer[MAXBUF];
char 		recv_buffer[MAXBUF];
char 		send_buffer[MAXBUF];
int 		numused;


// ****************** test ***********************
char		local_server_name[64]="test local server";

//Server 
int uid_getIndex(int uid)
{
	int i;
	
	for(i=0;i<MAX_CLIENT;i++)
	{
		//if(client_list[i].uid != uid) continue;
		if(player_list[i].uid == uid) return i;
	}

	return -1;
}


void reset_client(int index)
{
	client_list[index].active=0;
//del 	client_list[index].uid=0;
	
	client_list[index].tcp_socket=NULL;
	client_list[index].udp_socket=NULL;
	client_list[index].loss=0;
	client_list[index].misc=0;
	client_list[index].seq=0;
	
//	client_list[index].kill=0;
//	client_list[index].death=0;
//	client_list[index].hit_n=0;
}

int  get_uid()
{
	int i,uid;

again:
	uid=rand();
	for(i=0;i<MAX_CLIENT;i++)
		if(player_list[i].uid==uid) //̹ 
			goto again;


	return uid;

}


// ?? 
send_index(int id, void *buff, int len )
{

	send_tcp2(client_list[id].tcp_socket,buff,len); 
	/* 
	SDLNet_TCP_Send(client_list[id].tcp_socket,&size,2); 
	result=SDLNet_TCP_Send(client_list[id].tcp_socket,buff,len); 

	if(result<len){
		printf("SDLNet_TCP_Send: %s\n",SDLNet_GetError());
		//printf("ERROR:SDLNet_TCP_Send: r=%d %s\n",result,SDLNet_GetError());
		exit(0);
	} */
}


// good idea !!
send_tcp_ALL(void *buff,int len)
{
	int i,result;
	Uint16 size;

	size=len;
	for(i=0; i<MAX_CLIENT;i++)
	{
		//if(client_list[i].udp_socket==NULL)  continue;
		if(client_list[i].tcp_socket==NULL)  continue;
		send_index(i,buff,len);
	}
}




int    done_init_gameserver=0;
// game_server ʱȭ 
void init_server_Network() // SERVER 
{
	int len,i;
	Uint32 ipaddr;
	Uint16 port;
	
	if(done_init_gameserver>0) return; 

	for(i=0;i<MAX_CLIENT;i++)
	{
		reset_client(i);
	}

	// Resolve the argument into an IPaddress type
	if(SDLNet_ResolveHost(&ip,NULL,GAME_SERVER_PORT)==-1)
	{
		printf("SDLNet_ResolveHost: %s\n",SDLNet_GetError());
		exit(3);
	}

	// open the server socket
	server_socket=SDLNet_TCP_Open(&ip);
	if(!server_socket)
	{
		printf("SDLNet_TCP_Open: %s\n",SDLNet_GetError());
		exit(4);
	}
	server_tcp_set=SDLNet_AllocSocketSet(MAX_CLIENT);
	if(!server_tcp_set) {
		printf("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
		exit(1); //most of the time this is a major error, but do what you want.
	}

	// server_socket server_tcp_set ߰Ѵ 
	numused=SDLNet_TCP_AddSocket(server_tcp_set,server_socket);
	if(numused==-1) {
    		printf("SDLNet_AddSocket: %s\n", SDLNet_GetError());
   		 // perhaps you need to restart the set and make it bigger...
	} 

	if(!(udp_in=SDLNet_AllocPacket(MAXBUF)))
	{
		printf("SDLNet_AllocPacket: %s\n",SDLNet_GetError());
		exit(5);
	}
	udp_in->data=recv_buffer;

	if(!(udp_out=SDLNet_AllocPacket(MAXBUF)))
	{
		printf("SDLNet_AllocPacket: %s\n",SDLNet_GetError());
		exit(5);
	}

	server_udp_set=SDLNet_AllocSocketSet(MAX_CLIENT);	
	if(!server_udp_set) {
		printf("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
		exit(1); //most of the time this is a major error, but do what you want.
	}

	server_udp_socket=SDLNet_UDP_Open(GAME_SERVER_PORT);
	numused=SDLNet_UDP_AddSocket(server_udp_set,server_udp_socket);
	if(numused==-1) {
		printf("SDLNet_AddSocket: %s\n", SDLNet_GetError());
		// perhaps you need to restart the set and make it bigger...
	}

	done_init_gameserver=1;
	start_connect_GameServer=TRUE;

	OK();
}


 //̴°ų 
void del_client(int n)
{
	int 	channel,len;
	int	result;
	int 	uid;
	unsigned char send_size;
	UDPsocket udp_socket;
	
	printf("SDLNet_TCP_Recv: %s\n",SDLNet_GetError());
	printf("	maybe disconnect ? -> right \n");


	tcp_socket=client_list[n].tcp_socket;
	SDLNet_TCP_DelSocket(server_tcp_set,tcp_socket);
	SDLNet_TCP_Close(tcp_socket);
	
	udp_socket=client_list[n].udp_socket;
	if(udp_socket!=NULL){
		SDLNet_UDP_DelSocket(server_udp_set,udp_socket);
		SDLNet_UDP_Close(udp_socket);
		//	SDLNet_UDP_Unbind(client_list[i].udp_socket, 0);
	}

	//del uid=client_list[n].uid;
	reset_client(n);
	client_n--;

	//ݻ ״ ʿ.
//	packet_info=(Packet_Info*)send_buffer;
//	packet_info_out.id=NET_DEL_PLAYER;
//	packet_info_out.uid=uid;
	
	len=sizeof(Packet_Info);
	send_size=len;
	send_tcp_ALL(send_buffer,len);
}

//=============================================
// player uid  ˷ش 
//̰ Լΰ ?
void do_NET_SERVER_REPLY(int client_id)
{
	int 	channel,len;
	int	result;
	unsigned char send_size;
	Packet_Info *packet_info;

	//=============================================
	// player uid  ˷ش 
//	packet_info_out.id=NET_SERVER_REPLY;
//	packet_info_out.uid=get_uid();
	len=sizeof(Packet_Info);
	//send_index(client_id,&packet_info_out,len);

	//==================================
	//ο Ŭ̾Ʈ  ߰ 
	//==================================
//	player[player_n].uid=packet_info_out.uid;
//	strcpy(player[player_n].name,packet_info->name);	//SDLNet_UDP_Open(port);
	
	//================== εĳƮ ====================
	//packet_info_out.id=NET_NEW_PLAYER;
//	strcpy(packet_info_out.name,player[player_n].name);	//SDLNet_UDP_Open(port);
//	send_tcp_ALL(&packet_info_out,len);

	player_n++;
}



// ʿ ȣ 
// Ŭ̾Ʈκ name,udp_port ޾Ƴ 
// uid, udp_port ˷ش 
void 	xxdo_NET_NEW_PLAYER1(int n) 
{

	int 		channel,len;
	int		result;
	Uint16 		send_size;
	Packet_Info 	*in;
	Packet_Info	out;
	UDPsocket 	udp_socket;

	in=(Packet_Info*)recv_buffer;
	printf("server: client_id=%d  name=%s  udp_port=%d \n",client_n,in->name,in->udp_port);


	// Ŭ̾Ʈ udp ߰ϱ  
	// ̰  ̴  
	ip.host=client_list[n].host;
//	ip.port=htons(in->udp_port);  // network  . 
	ip.port=in->udp_port;  // network  . 
//	ip.port=SDLNet_Write16(in->udp_port);  // network  . 

	// ġ߿ !!
	udp_socket=new_UDPsocket(&port); // ο udp_socket,udp_port
	printf("server: server_udp_port=%d \n",port);

	//***  SDLNet_UDP_Bind ּҴ Ʈּҿ ƮƮ    
	channel=SDLNet_UDP_Bind(udp_socket, -1, &ip);
	if(channel==-1) {
		printf("SDLNet_UDP_Bind: %s\n", SDLNet_GetError());
		// do something because we failed to bind
	} 

	numused=SDLNet_UDP_AddSocket(server_udp_set,udp_socket);
	if(numused==-1) {
		printf("SDLNet_AddSocket: %s\n", SDLNet_GetError());
		// perhaps you need to restart the set and make it bigger...
	}

	
	// ⼭  ä 
	//=============================================
	//Ŭ̾ƮԸ  ä udp_port,uid ˷ֱ 
	out.id=NET_YOUR_UID;
	out.udp_port=port;
	out.uid=get_uid();
	len=sizeof(Packet_Info);
	send_tcp2(client_list[n].tcp_socket,&out,len);



	//==================================
	//ο Ŭ̾Ʈ  ߰ 
	//==================================
	client_list[n].udp_socket=udp_socket;		
	//client_list[n].uid=out.uid;
	strcpy(client_list[n].name,in->name);	

	//================== εĳƮ ====================
	// uid׳ ڵκ  
	out.id=NET_NEW_PLAYER;
	strcpy(out.name,client_list[n].name);	//SDLNet_UDP_Open(port);
	send_tcp_ALL(&out,len);
	client_n++;
}

int Sever_new_player(char *name,int uid,int cidx)
{
	int i;
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].active==0) break;
	}
	strcpy(player_list[i].name,name);
	player_list[i].uid=uid;
	player_list[i].active=1;
	player_list[i].client_id=cidx;
	player_n++;
	/// DEBUGB(" player_n=%d \n",player_n);
	return i;
}

int Sever_del_player(int uid)
{
	int i;
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].uid==uid) break;
	}

	player_list[i].active=0;
	player_n--;
}


// must   name size   < 64byte !!!
// udpϻ 
void 	do_NET_NEW_PLAYER2(int client_idx) 
{
	int	pidx;
	int 		channel,len;
	int		result;
	int		id;
	int		i;
	Uint16 		send_size;
	Packet_Info 	*in;
	Packet_Info	out;
	UDPsocket 	udp_socket;

	in=(Packet_Info*)recv_buffer;
	printf("SERVER: new_player client_idx=%d  name=\"%s\" \n",client_idx,in->name);

	// Ŭ̾Ʈ udp ߰ϱ  
	// ̰  ̴  
	//ip.port=htons(in->udp_port);  // network  . 
	
	//=============================================
	// Ŭ̾ƮԸ  uid ˷ֱ 
	out.id=NET_YOUR_UID;
	out.uid=get_uid();
	out.object_id=in->object_id;
	len=sizeof(Packet_Info);
	send_tcp2(client_list[client_idx].tcp_socket,&out,len);

	//==================================
	//ο Ŭ̾Ʈ  ߰ 
	pidx=Sever_new_player(in->name,out.uid,client_idx);

	//=======================================
	// notice to new player 
	// send the current player_list 
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].active==1)
		{
			out.id=NET_NEW_PLAYER;
			out.uid=player_list[i].uid;
			strcpy(out.name,player_list[i].name);	
			send_tcp2(client_list[client_idx].tcp_socket,&out,len);
		}
	}

	
	//================== εĳƮ ====================
	// uid׳ ڵκ  
	out.id=NET_NEW_PLAYER;
	out.uid=player_list[pidx].uid;
	strcpy(out.name,player_list[pidx].name);	//SDLNet_UDP_Open(port);
///	printf("********** server: name=%s \n",out.name);
	send_tcp_ALL(&out,len);
}



// ۵ɰͰ. Ȯο.
void del_client1(int n)
{
	int 	channel,len;
	int	result;
	int 	uid;
	unsigned char send_size;
	UDPsocket udp_socket;
	Packet_Info out;
	
	printf("SERVER: maybe disconnect ? -> right \n");
	
	tcp_socket=client_list[n].tcp_socket;
	SDLNet_TCP_DelSocket(server_tcp_set,tcp_socket);
	SDLNet_TCP_Close(tcp_socket);
	
	udp_socket=client_list[n].udp_socket;
	if(udp_socket!=NULL){
		SDLNet_UDP_DelSocket(server_udp_set,udp_socket);
		SDLNet_UDP_Close(udp_socket);
		//	SDLNet_UDP_Unbind(client_list[i].udp_socket, 0);
	}

	//del uid=client_list[n].uid;
	reset_client(n);
	client_n--;
	
	//ݻ ״ ʿ.
	out.id=NET_DEL_PLAYER;
	out.uid=uid;
	len=sizeof(Packet_Info);
	send_tcp_ALL(&out,len);

}




// templete
send_TEMP()
{
	int len;
	int i;
	Packet_TEMP server_temp;

	server_temp.id=NET_START_GAME;
	len=sizeof(Packet_TEMP);
	
	memcpy(send_buffer,&server_temp,len);
//	send_tcp_ALL(send_buffer,len);
}


Uint32 server_info_time=0;

send_NET_SERVER_INFO()
{
	int len;
	int i;
	Packet_Server_Info server_info;
	
	server_info.id=NET_SERVER_INFO;
	server_info.client_n=player_n;
	server_info.time=server_game_timer;

	len=sizeof(Packet_Server_Info);
	memcpy(send_buffer,&server_info,len);

	
	//for(i=0;i<client_n;i++)
	for(i=0;i<MAX_CLIENT;i++)
	{
		
		if(player_list[i].active==0) continue;
		client_info[i].uid=player_list[i].uid;
//		client_info[i].seq=client_list[i].seq;
//		client_info[i].loss=client_list[i].loss;
//		client_info[i].misc=client_list[i].misc;
	}

	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].active==0) continue;
		memcpy(&send_buffer[len],&client_info[i],sizeof(Packet_Client_Info));
		len+=sizeof(Packet_Client_Info);
	}

	send_tcp_ALL(send_buffer,len);

}


send_START_GAME()
{
	int len;
	int i;
	Packet_START_GAME out;

	out.id=NET_START_GAME;
	len=sizeof(Packet_START_GAME); // 1byte
	send_tcp_ALL(&out,len);  // 1byte
}



packet_parsing(int n)
{

	int 	channel,len;
	int	result;

	switch(recv_buffer[0]){
		case NET_PLAYERINFO:
			break;
		case NET_CLIENT_INFO:  			
			break;
		case NET_NEW_PLAYER:	//ο ó  !!
			do_NET_NEW_PLAYER2(n);
			break;

		default:
			//printf("TCP_Recv %d bytes  from [%d] ???????\n",len,i);
			printf("paralle ??? \n");
	}

}
del_ecv_packet_udp(int n)
{

	int 	channel,len;
	int	result;


	data_in=(Packet_UDP*)recv_buffer; // udp_in

	if(client_list[n].seq > data_in->seq )   // 8 > 6,7 
	{
		client_list[n].misc++;
	//	return; 
	}



	if((client_list[n].seq+1)!= data_in->seq )   // 8  > 6
	{ 
		client_list[n].loss++;
	}


	client_list[n].seq=data_in->seq;

	client_list[n].last_packet_uid=data_in->uid;


	if(data_in->hit) 
	{
		int idx;
		
		data_in->hit=0;
		
		idx=uid_getIndex(data_in->hit_uid);
		if(idx<0)
		{	
			printf("how ??");
		}
	//	player[idx].hit_damage=data_in->hit_damage;
	//	player[idx].hit_joint=data_in->hit_joint;
	//	player[idx].hit_n++;
	}

	memcpy(&packet_out[out_n],data_in,sizeof(Packet_UDP));
//del 	packet_out[out_n].uid=client_list[n].uid; //???
	out_n++;
}



// udp  Ʈ ѰҶϴ°.
recv_udp_packet(UDPpacket *udp_in)
{

	int 	channel,len;
	int	pidx,cidx;
	int	result;
	Packet_UDP	*in;
	
	in=(Packet_UDP*)udp_in->data; 
///	printf("server: UDP_Recv1  \n");

	if(in->hit) 
	{
		int idx2;
		in->hit=0;
		DEBUGB(" Hited uid=%d\n",in->uid);
	/*
		pidx=uid_getIndex(in->hit_uid);
		if(idx2<0)
		{	
			printf("how ??\n");
		}
		//player[idx2].hit_damage=in->hit_damage;
		player_list[pidx].hit_joint=in->hit_joint;
		player_list[pidx].hit_n++;
	*/
		return ;
	}


	pidx=uid_getIndex(in->uid);
	if(  pidx <0){
		// ERROR("server: idx =%d" ,idx);
		DEBUGB("server: pidx =%d" ,pidx);
		return; 
	}
	
	cidx=player_list[pidx].client_id;
	
	if( pidx <0 || cidx <0){
		ERROR("pidx =%d   , cidx =%d" ,pidx,cidx);
		return; 
	}

	/*
	if(client_list[index].seq > in->seq )   // 8 > 6,7 
	{
		client_list[index].misc++;
		return; 
	}

	if((client_list[index].seq+1)!= in->seq )   // 8  > 6
	{ 
		client_list[index].loss++;
	}

	client_list[index].seq=data_in->seq; */

	
	
//	printf("server: UDP_Recv2  \n");

	if(client_list[cidx].udp_socket==NULL)
	{
		UDPsocket udp_socket;
		printf("SERVER: udp_socket init !!\n");
		udp_socket=SDLNet_UDP_Open(0);
		//***  SDLNet_UDP_Bind ּҴ Ʈּ,Ʈ    
		result=SDLNet_UDP_Bind(udp_socket, -1, &udp_in->address);
		if(result<0) 
			ERROR("SDLNet_UDP_Bind: %s\n", SDLNet_GetError());
		client_list[cidx].udp_socket=udp_socket;
	}
	
	
	//client_list[n].last_packet_uid=data_in->uid;
	//printf("server: UDP_Recv from [%d] \n",n);

	player_list[pidx].packet=1;
	memcpy(&player_list[pidx].data,in,sizeof(Packet_UDP));
	//packet_out[out_n].uid=client_list[index].uid; //???
	out_n++;
}


void poll_TCP()
{
	TCPsocket tcp_socket;
	Uint32 	ipaddr;
	
	int 	len;
	int 	i;
	int 	channel;
	int 	n;
	Uint16 	recv_size;

	n=SDLNet_CheckSockets(server_tcp_set, 0);
	if(n==0) return;

// **** Լ  socket_Set ִ°͸  üũѴ. 
// server_socket  ο Ŭ̾Ʈϰ ...
if(SDLNet_SocketReady(server_socket))
{
	// non-blocking mode 
	// get a new client-connected-socket 
	tcp_socket=SDLNet_TCP_Accept(server_socket);
	if(tcp_socket)
	{
		// get the clients IP and port number
		remoteip=SDLNet_TCP_GetPeerAddress(tcp_socket);
		if(!remoteip){
			printf("SDLNet_TCP_GetPeerAddress: %s\n",SDLNet_GetError());
			return;
		}

		//ִ ڸã 
		for(i=0;i<MAX_CLIENT;i++)	//if(client_list[i].using==0) 
			if(client_list[i].tcp_socket==NULL) 
				break;

		if(i>=MAX_CLIENT){
			printf("Too many client !!\n");
			return;
		}
	
		// New_Socket4(ip,PORT,,recv,fail_get_server_list);
		//⼭  UDPä  
		//UDP portȣ ޾ƾѴ. 
		client_list[i].active=1;
		client_list[i].host=remoteip->host;// network endian 
		client_list[i].tcp_socket=tcp_socket;
		client_list[i].udp_socket=NULL;
		
		// server_tcp_set  οŬ̾Ʈ tcp_socket߰ 
		numused=SDLNet_TCP_AddSocket(server_tcp_set,tcp_socket);
		if(numused==-1) {
			printf("SDLNet_AddSocket 1: %s\n", SDLNet_GetError());
			// perhaps you need to restart the set and make it bigger...
		}
		client_n++;
	///	printf("SERVER: new client \n");
	}

}


	for(i=0;i<MAX_CLIENT;i++)
	{
		
		if(client_list[i].active==0)  continue;
		tcp_socket=client_list[i].tcp_socket;
		if(tcp_socket==NULL)  continue;

		if(!SDLNet_SocketReady(tcp_socket)) continue;
		
		// read the buffer from client
		SDLNet_TCP_Recv(tcp_socket,&recv_size,2);
		len=SDLNet_TCP_Recv(tcp_socket,recv_buffer,recv_size);

		if(len<=0)
		{
			//  ó 
			del_client1(i);
			continue;
		} 
		//del printf("server: recv tcp  buff[0]=%d \n",recv_buffer[0]);
		//  ƴ϶ 
		packet_parsing(i);
	}


}



// Ƽ udpƮ 
recv_UDP1()
{
	int i,j,recv_n;
	int result;
	UDPsocket udp_socket;

	out_n=0;
	result=SDLNet_CheckSockets(server_udp_set, 0);
	if(result==0) return;
	
	printf("server: UDP_Recv 1 \n");
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(client_list[i].active==0)  continue;
		if(client_list[i].udp_socket==NULL)  continue;

		udp_socket=client_list[i].udp_socket;
		if(!SDLNet_SocketReady(udp_socket)) continue;
		printf("server: UDP_Recv  \n");

		// BIND udp_socket.
		// no-blocking
		// **  ֱ Ŷް  
		// **** seq  ޾ƾѴ.
		// ߻ !!!!!!!!!!!!!!!!!
		do{
			result=SDLNet_UDP_Recv(udp_socket, udp_in);
		//del	recv_packet_udp2(i);
		}
		while(result);
	}

	
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(client_list[i].hit_n==0)  continue;
		
		for(j=0;j<out_n;j++)
		{
		//del 	if(packet_out[j].uid==client_list[i].uid)
			{
				packet_out[j].hit=1;
				packet_out[j].hit_damage=client_list[i].hit_damage;
				packet_out[j].hit_joint=client_list[i].hit_joint;
				break;
			}
		}
		client_list[i].hit_n=0;
	}


}


//  udpƮ 
poll_UDP2()
{
	int i,j,recv_n;
	int result;
	
//	printf("recv_UDP2() \n");
	for(i=0;i<MAX_CLIENT;i++)
	{
		player_list[i].packet=0;
		player_list[i].hit_n=0;
	}

	// Ѱ udpƮκ Ŷ ٸ.
	result=SDLNet_CheckSockets(server_udp_set, 0);

	if(result==0) return;
	{
	
		// if there are packetStoms, How can I deal this situation ?
		if(!SDLNet_SocketReady(server_udp_socket)) return;
		do{
			result=SDLNet_UDP_Recv(server_udp_socket, udp_in);
			recv_udp_packet(udp_in);
		}
		while(result);
	}


	/*
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].hit_n==0)  continue;
		{
			player_list[i].data.hit=1;
			player_list[i].data.hit_joint=player_list[i].hit_joint;
		}
		player_list[i].hit_n=0;
	}*/

	// Ŷ ÷ ľ 
	out_n=0;
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(player_list[i].packet>0)
		{
			memcpy(&packet_out[out_n++],&player_list[i].data,sizeof(Packet_UDP));
		}
	}

	server_send_udp();
}


server_send_udp()
{
	UDPsocket udp_socket;
	int result,numsent;
	int i;

	if(out_n==0 ) return; //  Ŭ̾Ʈ鿡  ʺ 
	udp_out->data=(char *) &packet_out;
	udp_out->len=sizeof(Packet_UDP)*out_n;

	packet_out[0].n=out_n; // Ŭ̾Ʈ n . 
//	printf("server: send out_n=%d\n",out_n);
	// Ŭ̾ƮԹ߼ 
	for(i=0; i<MAX_CLIENT;i++)
	{
		if(client_list[i].active==0 )  continue;
		if(client_list[i].udp_socket==NULL)  continue;
		udp_socket=client_list[i].udp_socket;
	
		client_list[i].hit_n=0; //ʱȭ
		// channel -1̸ packet ٿ ּҷ װ
		// -1 ƴҰ쿡 soket ٿּҷ .
		// BINDּҷ ߼ !!
		result=SDLNet_UDP_Send(udp_socket, 0 , udp_out);
		if(!result) {
			printf("ERROR ?SDLNet_UDP_Send: %s\n", SDLNet_GetError());
			printf("ERROR ?SDLNet_UDP_Send to clinent = %d  len=%d\n",i,udp_out->len);
		}

	}

//	OK();
}

// Ʈũ ī 
void count_timer()
{
	//server_game_timer-=iDeltaTime;
	
	if(server_game_timer<0)
	{
		server_game_timer=1000*60*1;
		send_START_GAME();
	}

	server_info_time+=iDeltaTime;
	if(server_info_time > 1000  ) 
	{
		server_info_time=0;
		send_NET_SERVER_INFO();
	}

}



int sended_root_info_flag=0;

// dont close the Socket !!! 
Server_send_client_info(Socket *sock)
{
	int len;
	Packet_Info packet;
	
	packet.id=NET_CLIENT_INFO;
	strcpy(packet.name,local_server_name);	
	len=sizeof(Packet_Info);

	Socket_send(sock,&packet,len);
	DEBUGB("LOCAL_SERVER: connected ROOT-SERVER !!\n");
	sended_root_info_flag=1;
//del	Socket_Del(sock);
}

Server_FAIL_client_info(Socket *sock)
{
	int len;
	sended_root_info_flag=1;
	DEBUGB("LOCAL_SERVER: connect fail  ROOT-SERVER !!\n");
}


server_send_info()
{
	static Socket *sock=NULL;
	if(sock==NULL){
		sock=New_Socket4(ROOT_SERVER_IP,ROOT_SERVER_PORT,Server_send_client_info,NULL,Server_FAIL_client_info);
		/// OK();
	}
}


void count_timer();

extern int ai_n;
Object *new_ai();

int do_Server()
{
	
	int i;
	


	//  ӽϸ ü 
	if( arg_server==0)
		if(run_server==0 ) return; // serverغʵ.

	init_server_Network();

	// root ڽ ˸° ϴ 
	//  ȰȭѾѴ.
	// local÷̰ϰؾϹǷ..
	if(sended_root_info_flag==0)	server_send_info();

	{
		count_timer();
		poll_TCP(); // TCP ó 		
		poll_UDP2();
		// packet_parsing(i);
	}

	//÷̾  aiѴ.
	if(Network_TCP_Connected>0)
	{
		if(ai_n<3)
			new_ai();
	}
}


