#include "../system.h"
#include "shape.h"
#include "map.h"
#include "texture.h"

//	DRAFT
// ܾ  鹮->Ѱ 鹮ڷ ν
// Token  =,{,},  ٷ  Word νѴ.
char read_buff[1024*64];
FILE *read_fd=0;
int	 read_size=0;
int	 read_pos=0;

int ffeof(FILE *fd)
{	
	if(fd!=read_fd)
	{
		///printf("xxxxxxxxXXX\n");
		read_size=fread(read_buff,sizeof(read_buff),1,fd);
		read_pos=0;
		read_fd=fd;
	}
	printf("read_size=%d\n",read_size);
	return (read_size<=read_pos) ;
}
void frewind(FILE *fd)
{
	if(fd!=read_fd)
	{
		read_size=fread(read_buff,sizeof(read_buff),1,fd);
		read_pos=0;
		read_fd=fd;
	}
	read_pos=0;
}

void fgetw(FILE *fd,char *buff,int size,int *newline_n=NULL)
{
	static char buffx[128];
	char	ch;
	int		i=0;
	int		quat=0,comment=0;

	/*
	if(fd!=read_fd)
	{
		read_size=fread(read_buff,sizeof(read_buff),1,fd);
		read_pos=0;
		read_fd=fd;
	} */

	while(!feof(fd))
	//while(read_size<=read_pos)
	{
		ch=fgetc(fd);
		///	read_size=fread(read_buff,sizeof(read_buff),1,fd);
		//ch=read_buff[read_pos++];
		
		
		if(i>size) 
			system_error("fgetw(): over run !!");

		switch(ch)
		{	
			case '\n':	if(newline_n) (*newline_n)++;
			case ' ': 
				if(quat) {
			   		buff[i++]=' ';
					break;
				}
			case 0x0d:  //for dos 
			case '\t':
			case '[':
			case ']':
			case ')':
			case '(':
			case '=':
				if(i>0){
					buff[i]=0;
					return;
				}

				break;
			
			case '\'' :
			case '\"' :
				if(quat!=1){
					quat=1;
					break;
				}	
				else {
					buff[i]=0;
					return ;
				}
	//		case '#' :
			case '/' :
				ch=fgetc(fd);
				//ch=read_buff[read_pos];
				if(ch=='/')
				{
					fgets(buffx,sizeof(buffx),fd);

				}
				else{
					buff[i++]='/';
					fseek(fd,-1,SEEK_CUR);
				}
				break;

			default :
			   buff[i++]=ch;
		}

	}
	return ;
}	


// Ʈ:  scanf  newline,TAB  鹮ó   
// For example, most scanf conversions skip over any amount of white space 
// (including spaces, tabs, and newlines) 
class Parsing
{
	public:
	FILE *fd;
	char buff[64];
	int  newline_num;

	Parsing(FILE *fd_)
	{
		fd=fd_;
	}
	void rewind()
	{
		//frewind(fd);
		fseek(fd,0,SEEK_SET);
	}

	void strips(char *str)
	{

	}

	char *getWord()
	{
		int n=0;
		fgetw(fd,buff,sizeof(buff),&n);
		newline_num+=n;
		return buff;
		//strip_ctrlchar(buff);
	}

	virtual bool findClass(char *name)
	{
		rewind();
		while(!feof(fd))
		{
			getWord();
			if(strcasecmp(buff,"class")==0 or strcasecmp(buff,"classname")==0)
			{
				getWord();
				if(strcasecmp(buff,name)==0)
				{
					//if(!strcasecmp(name,"info"))	printf("xxxbuff=%s\n",buff);
					getWord(); // {
					if(strcmp(buff,"{")!=0) 
						system_error("Parsing :  { !=%s",buff);
					//fseek(fd,read_pos,SEEK_SET);
					return true;
				}
			}
		}
		return false;
	}
	int findClose()
	{
		while(!feof(fd))
		{
			getWord();
			if(strcasecmp(buff,"}")==0)
					return true;
		}
		return false;
	}
	
	int  classSize(char *classname)
	{	
		if(findClass("info")==false)
		{
			// if no info class
			if(findClass(classname)==false) return 0;
			newline_num=0;
			findClose();
			int size=newline_num -1 ;
			findClass(classname);
			return size;
		}

		while(!feof(fd))
		{
			getWord();
			if(strcasecmp(buff,classname)==0)
			{
				getWord(); 
				int size=atoi(buff);
				if(findClass(classname)==false) return 0;
				return size;
			}
		}
		return 0;
	}

	int  InfoItemIntValue(char *item)
	{
		//printf("InfoItemIntValue\n");
		if(findClass("info")==false)
			return 0;
		
		while(!feof(fd))
		{
			getWord();
			//printf("buff=[%s]\n",buff);
			if(strcasecmp(buff,item)==0)
			{
				getWord(); 
				int size=atoi(buff);
				return size;
			}
		}
		return 0;
	}


};


// hyun 0.25  MilkShape3D plugin 
void Load_RAX(Object *shape,char *filename)
{
	int 		vertex_n,material_n,joint_n;
	int 		i,j,n;
	int			textures_id[32];
	int 		vertex_id[3];
	char 		buffer[256],dummy[128];
	FILE 		*fd;
	Vertex 		*vertex; 
	Triangle 	*triangle;
	Parsing		*rax;
	
	float		aaaa;

	if(!(fd=fopen(get_pathname(filename),"rb"))) 
		system_error("Load_RAX() can't open [%s]",filename);
	rax=new Parsing(fd);
	
	joint_n=rax->InfoItemIntValue("Joint");
	//printf("joint_n=%d \n",joint_n);
	
	// Ʈ б 
	if(rax->findClass("Joint"))
	{
		//JointHierarchy
		Joint *joint;
		int idx,pidx,vertex_n;
		for(i=0;i< joint_n ; i++)
		{
			joint=new Joint();
			shape->joints.add(joint);
		}

		for(i=0;i< joint_n ; i++){
			joint=shape->joints[i];

			// index,parent,vertex_n 
			// translate,rotate MilkShape3D  ؽʱȭϱ ̴.
			// name
			fscanf(fd,"%d %d %d %f %f %f %f %f %f"
					,&idx,&pidx,&vertex_n
					,&joint->translate[0]
					,&joint->translate[1]
					,&joint->translate[2]
					,&joint->rotate[0]
					,&joint->rotate[1]
					,&joint->rotate[2]);
			strcpy(joint->name ,rax->getWord());
			joint->id=idx;
			joint->parent_id=pidx;
			//joint->vertex_n=vertex_n;
			if(pidx==-1)
			{
				joint->parent=NULL;
			}
			else
			{
				joint->parent=shape->joints[pidx];
				joint->children.add(joint);
			}
			//printf("name =%s \n",joint->name);
		}
	} else system_error("cant find Joint!!");


	if(rax->findClass("Material"))
	{
		material_n=rax->classSize("Material");
		//printf("material_n=%d\n",material_n);
		for(i=0;i< material_n ; i++){
			fscanf(fd,"%s %s",dummy,buffer);
			//printf("buffer =%s\n",buffer);
			textures_id[i]=LoadTextureFile(buffer); 
		}
		if(material_n==1)
		{
			shape->texid=textures_id[0];
			shape->flag_triangle=MODE_INDEX_ONETEX;
		}

	}
	else system_error("cant find Material!!");

	if(rax->findClass("Vertex"))
	{
		Joint *joint;
		int jidx,v_n; 
		float x,y,z;
		float u,v;
		vertex_n=rax->classSize("Vertex");
		
		// vertex & UV
		for(i=0;i< vertex_n ; i++){
			Vertex *vert;
			vert=new Vertex();
			// index  x  y  z  u  v  joint_index
			fscanf(fd,"%d %f %f %f %f %f %d",&j,&x,&y,&z,&u,&v,&jidx);
			vert->x=x;	vert->y=y;	vert->z=z;
			vert->u=u;	vert->v=-v; // ***********
			shape->vertexs.add(vert);
			//DEL shape->joints[jidx]->vertexs.add(vert);
			shape->joints[jidx]->vertexs_id.add(i);
		}	
	}  else system_error("cant find Vertex");

	if(rax->findClass("Triangle"))
	{
		int  	tex_id;
		int 	triangle_n;
		int		v_id[3];
		triangle_n=rax->classSize("Triangle");
		//triangle=shape->triangle;
		for(i=0; i< triangle_n ; i++)
		{
			Triangle *tri;
			int idx;
			tri = new Triangle();
			// index   v1 v2 v3 texture_index
			int vidx[3];
			fscanf(fd,"%d %d %d %d %d",&idx,
					&vidx[0],
					&vidx[1],
					&vidx[2],
					&tex_id);
			tri->vertex_id[0]=vidx[0];
			tri->vertex_id[1]=vidx[1];
			tri->vertex_id[2]=vidx[2];

			tri->texture_id=textures_id[tex_id];
			tri->flag=TRIANGLE_MODE_INDEX;
			shape->triangles.add(tri);	
			//̰  Ǿߵɲ.
			//vectors2normal(&vertex[v_id[0]],&vertex[v_id[1]],&vertex[v_id[2]], triangle[i].normal);
			// ׳ ù° ﰢ Ʈ Ѵ.
			///triangle[i].joint=  joint_of_vertex[v_id[0]];
			//̰ ۾.. make_triangle_norm(&triangle[i]);
			//vectors2normal(&vertex[v_id[0]],&vertex[v_id[1]],&vertex[v_id[2]], triangle[i].normal);
		}
	} else system_error("cant find Triangle");

///	shape->vertex0=vertex;
	fclose(fd);
}

int Load_ANI(Object *obj,Animate *animate,char *filename)
{
	int 		joint_n,frame_n;
	int			jnt_idx;
	int 		i,j,n,count;
	char 		buffer[256],dummy[128];
	FILE 		*fd;
	Joint 		*joint;
	Key			*frame;
	Parsing		*ani;

	if(!(fd=fopen(get_pathname(filename),"rb"))) system_error("file open [%s]",filename);
	
	ani=new Parsing(fd);

	frame_n=ani->InfoItemIntValue("frame");
	joint_n=ani->InfoItemIntValue("joint");
	//printf("frame=%d	joint=%d\n",frame_n,joint_n);
	
	for(i=0;i<frame_n;i++)
	{
		frame=new Key();
		animate->frames.add(frame);
		for(j=0;j<joint_n;j++)
		{
			Key *key=new Key();
			frame->joints.add(key);
		}
	}

	if(ani->findClass("joints"))
	{
	//	if(obj->joints.size()<=jnt_idx)
	//		system_error("Load_ANI() over !!");
	//	joint=obj->joints[jnt_idx];
		for(j=0;j<joint_n;j++)
		{
			fscanf(fd,"%s %d",buffer,&jnt_idx);
			for(i=0;i<frame_n;i++)
			{
				Key *key=animate->frames[i]->joints[jnt_idx];

				fscanf(fd,"%d %f %f %f ",&n
						,&key->translate[0]
						,&key->translate[1]
						,&key->translate[2]);
				fscanf(fd," %f %f %f ",  
						&key->rotate[0],
						&key->rotate[1],
						&key->rotate[2]);

				/*
				printf(" %d %f %f %f %f %f %f \n",n
						,key->translate[0]
						,key->translate[1]
						,key->translate[2]
						,key->rotate[0]
						,key->rotate[1]
						,key->rotate[2]);
						*/

			}
		}
	} else system_error("cant find ani[Joint]");
/*
	loaded_Ani[loaded_Ani_n].frame_n=frame_n;
	loaded_Ani[loaded_Ani_n].joint_n=joint_n;
	loaded_Ani[loaded_Ani_n].frame=frame;

	for(j=0;j<joint_n;j++)
	{
		fscanf(fd,"%s %d",buffer,&count);
		DEBUG("%s %d",buffer,count);
		fscanf(fd,"%s ",buffer); // {
		for(i=0;i< count; i++)
		{
			fscanf(fd,"%d %f %f %f ",&n
					,&frame[j][i].translate[0]
					,&frame[j][i].translate[1]
					,&frame[j][i].translate[2]);
			fscanf(fd," %f %f %f ",  
					&frame[j][i].rotate[0],
					&frame[j][i].rotate[1],
					&frame[j][i].rotate[2]);
		
		} 
	}
	loaded_Ani_n++;

	*/
}


void Load_MODEL(Object *obj,const char *filename)
{
	FILE 		*fd;
	char 		buffer[128];
	char 		name[128];
	int		i,j,k,n;
	Parsing		*model;

	if(!(fd=fopen(get_pathname(filename),"rb"))) 	system_error("can't open [%s]",filename);

	model=new Parsing(fd);
	if(model->findClass("Shape"))
	{
		int index;
		float t[3];
		fscanf(fd,"%s %f %f %f",name,&t[0],&t[1],&t[2]);
		obj->translate[0]=t[0];  // offset 
		obj->translate[1]=t[1];
		obj->translate[2]=t[2];
	//	printf("%d   %s %f %f %f\n",index,buffer,t[0],t[1],t[2]);
		Load_RAX(obj,name);
	}
	else 
		system_error("cant find Shape class!!");

	if(model->findClass("ani"))
	{
		int index;
		int time;
		int size;
		Animate	*animate;
		
		//printf("ani_size=%d \n",model->classSize("ani"));
		size=model->classSize("ani");
		for(i=0;i<size;i++)
		{
			animate=new Animate();
			fscanf(fd,"%d  %s %d",&index,buffer,&time);
			printf("	animate=%s\n",buffer);
			Load_ANI(obj,animate,buffer);

			strcpy(animate->name,buffer);
			animate->time=time;	
			obj->animates.add(animate);
		///	loaded_Ani[animation_n].DeltaTime=time/loaded_Ani[animation_n].frame_n;
		///	shape->animationKey=shape->animation[0];
		}		
	} 
	else system_error("cant find ani class!!");

	if(model->findClass("event0"))
	{
		printf("size=%d \n",model->classSize("event0"));
	}
	else system_error("cant find event class!!");

//	printf("exit\n");
//	system_exit();
/*
	if(OpenSession(fd,"Anicorrectx")==1)
	{
		int joint_idx;
		Key **frame;
		int frame_n;
		float translate[3],rotate[3];
		n=getSessionValue();
		
		for(i=0;i<n;i++)
		{
			fscanf(fd,"%d   %f  %f  %f %f %f %f ",&joint_idx,
					&translate[0],&translate[1],&translate[2],
					&rotate[0],&rotate[1],&rotate[2]);
			
		}
			
		for(i=0;i<shape->ani_n;i++)
		{
			frame=loaded_Ani[shape->animation[i]].frame;
			frame_n=loaded_Ani[shape->animation[i]].frame_n;
			
			for(k=0;k<frame_n;k++)
			{
				frame[joint_idx][k].translate[0]+=translate[0]; 
				frame[joint_idx][k].translate[1]+=translate[1]; 
				frame[joint_idx][k].translate[2]+=translate[2]; 
				frame[joint_idx][k].rotate[0]+=rotate[0]; 
				frame[joint_idx][k].rotate[1]+=rotate[1]; 
				frame[joint_idx][k].rotate[2]+=rotate[2]; 
			}

		}
	}
*/

	fclose(fd);
}

