`timescale 1ns/1ps

module module1(clk,rst,inp,en,out1,out2,out3,out4,out5,out6,out7,out8,out9,out10,
				cnt32_out,cnt10_out,cnt30_out,cnt8_out,
				block_mean,	block_mean_vaild,bm_adr,frame_end
			);
	input clk,rst,en;
	input[7:0]inp;

	output [17:0] out1,out2,out3,out4,out5,out6,out7,out8,out9,out10;	
	
	output [7:0] block_mean;
	reg [7:0] block_mean;
		
	output block_mean_vaild;
	reg block_mean_vaild;
	
	output [6:0] bm_adr;
	
	output frame_end;
	wire frame_end;
	
	reg clear1,clear2,clear3,clear4,clear5,clear6,clear7,clear8,clear9,clear10;
	output [2:0] cnt8_out;
	output [3:0] cnt10_out;
	output [4:0] cnt30_out;
	output [4:0] cnt32_out;
	wire carry10,carry32,carry30;
	wire [10:1] acc_en;
	wire [7:0] inp;
		
	acc acc1(clk, clear1,acc_en[1],inp,out1);
	acc acc2(clk, clear2,acc_en[2],inp,out2);
	acc acc3(clk, clear3,acc_en[3],inp,out3);
	acc acc4(clk, clear4,acc_en[4],inp,out4);
	acc acc5(clk, clear5,acc_en[5],inp,out5);
	acc acc6(clk, clear6,acc_en[6],inp,out6);
	acc acc7(clk, clear7,acc_en[7],inp,out7);
	acc acc8(clk, clear8,acc_en[8],inp,out8);
	acc acc9(clk, clear9,acc_en[9],inp,out9);
	acc acc10(clk,clear10,acc_en[10],inp,out10);
	
	//32,10,30,8,80īimplimentation
	cnt32 cnt32(clk,rst,en,cnt32_out,carry32);
	      
	cnt10 cnt10(clk,rst,carry32,cnt10_out,carry10);
	      
	cnt30 cnt30(clk,rst,carry10,cnt30_out,carry30);
	
	cnt8 cnt8(clk,rst,carry30,cnt8_out, /* carry8 */ );
	
	cnt80 cnt80(clk,rst,block_mean_vaild,bm_adr,frame_end);
	
	assign acc_en[1]=(en&cnt10_out==0)?1'b1:1'b0;
	assign acc_en[2]=(en&cnt10_out==1)?1'b1:1'b0;
	assign acc_en[3]=(en&cnt10_out==2)?1'b1:1'b0;
	assign acc_en[4]=(en&cnt10_out==3)?1'b1:1'b0;		
	assign acc_en[5]=(en&cnt10_out==4)?1'b1:1'b0;
	assign acc_en[6]=(en&cnt10_out==5)?1'b1:1'b0;
	assign acc_en[7]=(en&cnt10_out==6)?1'b1:1'b0;
	assign acc_en[8]=(en&cnt10_out==7)?1'b1:1'b0;
	assign acc_en[9]=(en&cnt10_out==8)?1'b1:1'b0;
	assign acc_en[10]=(en&cnt10_out==9)?1'b1:1'b0;
	
//	//assignframe_end=(bm_adr==79)?1'b1:1'b0;
//	always@(posedge clk or negedge rst)
//		begin
//				if(!rst)
//					begin
//						frame_end<=0;
//					end
//				else if(bm_adr==79)
//					begin
//						frame_end<=1;
//					end
//				else
//					begin
//						frame_end<=0;
//					end
//		end
//
	//assignbl_m1=(cnt30_out==29&cnt10_out==0&cnt32_out==31)?out1[9:0]:10'b00000_00000;
	//assignbl_m2=(cnt30_out==29&cnt10_out==1&cnt32_out==31)?out2[9:0]:10'b00000_00000;
	//assignbl_m3=(cnt30_out==29&cnt10_out==2&cnt32_out==31)?out3[9:0]:10'b00000_00000;
	//assignbl_m4=(cnt30_out==29&cnt10_out==3&cnt32_out==31)?out4[9:0]:10'b00000_00000;
	//assignbl_m5=(cnt30_out==29&cnt10_out==4&cnt32_out==31)?out5[9:0]:10'b00000_00000;
	//assignbl_m6=(cnt30_out==29&cnt10_out==5&cnt32_out==31)?out6[9:0]:10'b00000_00000;
	//assignbl_m7=(cnt30_out==29&cnt10_out==6&cnt32_out==31)?out7[9:0]:10'b00000_00000;
	//assignbl_m8=(cnt30_out==29&cnt10_out==7&cnt32_out==31)?out8[9:0]:10'b00000_00000;
	//assignbl_m9=(cnt30_out==29&cnt10_out==8&cnt32_out==31)?out9[9:0]:10'b00000_00000;
	//assignbl_m10=(cnt30_out==29&cnt10_out==9&cnt32_out==31)?out10[9:0]:10'b00000_00000;
	
	//block_meanalways
	always@(posedge clk or negedge rst)
		begin
			if(!rst)
				begin
					block_mean<=0;
					clear1<=1;clear2<=1;clear3<=1;clear4<=1;clear5<=1;clear6<=1;clear7<=1;clear8<=1;clear9<=1;clear10<=1;
				end
			else if (cnt30_out==29&cnt32_out==31)
				begin
					case(cnt10_out)
						0:begin block_mean_vaild<=1;block_mean<=out1[17:10] ;clear1<=0;end
						1:begin block_mean_vaild<=1;block_mean<=out2[17:10] ;clear2<=0;end
						2:begin block_mean_vaild<=1;block_mean<=out3[17:10] ;clear3<=0;end
						3:begin block_mean_vaild<=1;block_mean<=out4[17:10] ;clear4<=0;end
						4:begin block_mean_vaild<=1;block_mean<=out5[17:10] ;clear5<=0;end
						5:begin block_mean_vaild<=1;block_mean<=out6[17:10] ;clear6<=0;end
						6:begin block_mean_vaild<=1;block_mean<=out7[17:10] ;clear7<=0;end
						7:begin block_mean_vaild<=1;block_mean<=out8[17:10] ;clear8<=0;end
						8:begin block_mean_vaild<=1;block_mean<=out9[17:10] ;clear9<=0;end
						9:begin block_mean_vaild<=1;block_mean<=out10[17:10];clear10<=0;end
						default
							begin
								block_mean<=0;
							end
					endcase
				end
			else
				begin
					block_mean<=0;	block_mean_vaild<=0;clear1<=1;clear2<=1;clear3<=1;clear4<=1;clear5<=1;clear6<=1;clear7<=1;clear8<=1;clear9<=1;clear10<=1;
			end
		end

endmodule

// module block_mean_resister1(
// 	input clk,rst,block_mean_vaild,	
// 	input frame_end,
// 	input [9:0] block_mean,
// 	input [9:0] bm_adr,
// 	output [9:0] block_mean1
// 	);
// 	reg [9:0] bm[0:80];
// 	wire 
// 	assign bm[bm_adr] = (block_mean_vaild==1) ? block_mean : bm[bm_adr]; 		
// endmodule
// 
module acc(clk ,rst,en,inp,out);//###########################################
	input clk ,rst,en;//Ŭ,,ο̺
	input [7:0] inp;//8bitԷ
	output[17:0] out;//18bit
	reg [17:0] out;
always@(posedge clk or negedge rst)
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		out<=out+inp;
		else
			out<=out;
	end
endmodule //#########################################################################

module  cnt8(clk ,rst,en,out,carry);//8ī###########################################
	input clk ,rst,en;
	output[2:0] out;
	output carry;
	reg [2:0] out;
	wire q7;
always@(posedge clk )
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		if (q7) out<=0;
		else
		out<=out+1;
	end
assign q7=(out==7);
assign carry=q7&en;
endmodule //#########################################################################

module cnt10(clk ,rst,en,out,carry);//10ī###########################################
	input clk ,rst,en;
	output[3:0] out;
	output carry;
	reg [3:0] out;
	wire q9;
always@(posedge clk )
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		if(q9)out<=0;
		else out<=out+1;
	end
assign q9=(out==9);
assign carry=q9&en;
endmodule //#########################################################################

module cnt32(clk ,rst,en,out,carry);//32ī####################################
	input clk ,rst,en;
	output[4:0] out;
	output carry;
	reg [4:0] out;
	wire q31;
always@(posedge clk )
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		if(q31)out<=0;
		else out<=out+1;
	end
assign q31=(out==31);
assign carry=q31&en;
endmodule //#########################################################################

module cnt30(clk ,rst,en,out,carry);//30ī###########################################
	input clk ,rst,en;
	output[4:0] out;
	output carry;
	reg [4:0] out;
	wire q29;
always@(posedge clk )
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		if(q29)out<=0;
		else out<=out+1;
	end
assign q29=(out==29);
assign carry=q29&en;
endmodule //#########################################################################

module cnt80(clk ,rst,en,out,carry);//80ī###########################################
	input clk ,rst,en;
	output[6:0] out;
	output carry;
	reg [6:0] out;
	wire q79;
always@(posedge clk )
	begin
		if(!rst)out<=0;//negativeReset
		else if(en)		
		if(q79)out<=0;
		else out<=out+1;
	end
assign q79=(out==79);
assign carry=q79&en;
endmodule //#########################################################################
